/********* Processed script output *********/
 // Measurement back pressure flow rate at 100Hz (7x7 silicon pump P024 (Silicon High Flow))
 /*    
     flow rate    
 */
 
 /*
 Hardware setup:
     
     Frequency generator (HP33120A) connected to a piezo amplifier (SVR 500)
         HP33120A:     Hi_Voltage= 225 V
                     Lo_Voltage = -60 V
                     Duty Cycle = 50 // in percent
                     Frequency = 100 // Hz
                     ActorFreqFlanke = 250 //Hz
         SVR 500 without terminating resistance: Amplification_factor = 200
     
     pressure controller  CPC3000 (PCS 400M)(0 - 500 hPa) to outlet of micro pump
         via network interface
         PressureType=3
         PressureTimeout=60
         PressureErrorAbs=0.2
     FlowBus El-Flow (3ml/min air sensor) to inlet of pump
     
 */
 // Measurement of flow vs backpressure and frequency excitation with underpressure for water (as in test script TS1147)    
 // test script number (integer, 4 digit, non-zero)
 // this symbol defines the version of the test script
 
 //    General measurement configuration definitions for use with LittleC
 //    For detailed parameter specification see associated LIB_COMMON library.
 
 // value of "WATER" defines the medium being used during test. Possible values are:    AIR,    WATER,    OIL.
 
 // value of "SILICON" defines the material of micropump being tested. Possible values are:    STEEL, TITANIUM,    SILICON
 
 // value of "uP029_M30_K200_sl4" defines the type of micropump being tested. Possible values are:    TUDOS, MIKROAUG, uP026
 
 // lot number (integer, 4 digit max., non-zero)
 // measurement number (integer, 3 digit max., non-zero)
 // wafer name designation (string, 10 chars max length)
 // device name designation (string, 10 chars max length)
 // housing name designation (string constant)
 
 // measurement setup type, if several measurement configuration can be used within a single test script (see LIB_MMT_TEST_SETUPS library for valid definitions)
 
 // results file path
 // results file path
 // calibration file path
 /* EMFT LittleC library micropump measurement parameter definitions on different measurement stations */
 
     
     
         /*    Common routines library for use with LittleC */
 
     // common library definitions are being processed
     // this symbol denotes, that a common library was already included
     // this symbol defines the version of the common library
     
     
         /*    Measurement test setups library for use with LittleC */
 
     // measurement test setups library definitions are being processed
     // this symbol denotes, that a measurement test setups library was already included
     // this symbol defines the version of the measurement test setups library
 
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
         
     // define this value to use default values without entry (default defines can be set from Excel worksheet), or undefine for manual entry
     
     // values below will be compared with the built-in macro value "PC-L109-08", which identifies the machine, on which the measurements are performed
     // to get computer id, select Start->Run->Cmd.exe and type ipconfig /all and use the value under 'Host name'. 
     // For current computer name use value: "PC-L109-08"
     
     
     
     
     
     
     
     
     // values below will be compared with the macro value "FLOW VS BACK PRESSURE AND EXCITATION FREQUENCY WITH UNDERPRESSURE FOR WATER", which defines script measurement type and corresponding instrument setup
     
     //    "WATER" = "AIR" 
     // Measurement back pressure flow rate at a constant frequency excitation (as in test script LCS0130)
     // Measurement of silicon valves leakage rate (as in test script LCS0135)
     // Characterization of silicon valves sticking (as in test script LCS0145)
     
     // Measurement of limit flow vs backpressure at a constant frequency excitation (as in test script LCS0146)
     // Measurement of flow rate, temperature and density vs. frequency (as in test script LCS0161)
     // Long term measurement of flow rate and pressure at a constant frequency excitation (as in test script LCS0162)
     
     // Measurement of mass vs. frequency (as in test script LCS0165)
     // Measurement of mass vs. pressure at a constant frequency excitation (as in test script LCS0166)
     
     // Calibration procedure for pressure sensors (as in script LCS0197)
         
     // Measurement of inlet and outlet port flow rate vs. voltage (as in test script LCS0218)
     
     // Measurement of inlet and outlet port flow rate vs. frequency (as in test script LCS0219)
         
     // Measurement of max. outlet over pressure, max. inlet under pressure, leakage and pump rate (as in test script LCS0244)
     
     // Measurement water bolus pressure flow rate at a burst excitation (as in test script LCS0433)
     
     //    "WATER" = "WATER"     
     // Measurement of silicon valves leakage rate for water (as in test script LCS1135)
     // Characterization of silicon valves sticking for water (as in test script TS1145)    
     // Measurement of limit flow vs backpressure at a constant frequency excitation for water (as in test script TS1146)    
     // Measurement of flow vs backpressure and frequency excitation with underpressure for water (as in test script TS1147)    
     // Calibration procedure for pressure sensors for water (as in script LCS1197)
     // Measurement line purging with underpressure for water (as in test script TS1148)
     // Long term measurement of flow rate and pressure at a constant frequency excitation using underpressure (as in test script LCS1162)
     // Long term measurement of flow rate and pressure at a constant frequency excitation (as in test script LCS1163)
     
     
     
     
     
     // values below will be compared with the macro value "SILICON", which defines the material of micropump being tested
     
     
     
     
     // values below will be compared with the macro value "uP029_M30_K200_sl4", which defines the type of micropump being tested
     // TUDOS micropump
     // MIKROAUG micropump
     // uP026 micropump
     // uP029 micropump
     // uP029 micropump
     // uP029 micropump
     // unbekannter typ
     
     // values below will be compared with the macro value "WATER", which defines the medium being used during test
     
     
     
     
     //Definition for invalid Parameter Value
     
     
     int Is_Within_Limits( int x, int lo, int hi )
     {        
         int out_of_limits;        
         out_of_limits = 0;
         if ( x < lo )    {
             out_of_limits = -1;        // below lower limit
         };
         if ( x > hi )    {
             out_of_limits = 1;        // over upper limit
         };            
         return (out_of_limits);
     }
 
     int Prompt_For_Int_Entry( int lo, int hi )
     {        
         int resp;
         int param_invalid;    
         
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action            
             return ( 0 );    // exit with error code return
         }
         
         param_invalid = 0;    // initialize variables
         do    {
             resp = getnum();        
             param_invalid = Is_Within_Limits( resp, lo, hi);
         }
         while ( ( (param_invalid != 0) && (Signal_goto_safe_state == 0) ) && (Signal_goto_safe_state == 0 ) );        // repeat until parameter not within limits
         return (resp);
     }
 
     int Wait_On_User_Response( char key)
     {    
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action            
             return ( 0 );    // exit with error code return
         }        
         
                 
         return 0;
     }
 
         
     // this symbol denotes, that a EMFT micropump parameter library was already included
     // this symbol defines the version of the micropump library
     
     // MICROPUMP PARAMETERS, INDEPENDENT OF MEASUREMENT SITE AND MEASUREMENT FLOW    
         
         
         
     
             // high-voltage piezo amplifier maximum voltage (V) - micropump driving voltage max. voltage
         // high-voltage piezo amplifier minimum voltage (V) - micropump driving voltage min. voltage
         // define this symbol, which denotes, that the micropump type was found
     
         
         
 
     // MEASUREMENT FLOW PARAMETERS, INDEPENDENT OF MEASUREMENT SITE 
     
         
     
     
     
     
         
             
     
         
         
     
     
         
         
         
             
         // start frequency setting (Hz)
         // stop frequency setting (Hz)
         // step frequency setting (Hz)
         
         // start value of pressure in hPa (mbar)
         // pressure step in hPa (mbar)
         // start value of pressure in hPa (mbar)
         
         // default value of underpressure in hPa (mbar)
         
         
         
     
         
     
     
     
     
     // MEASUREMENT SITE PARAMETERS            
     
         
     
     
     
     
         
         
     
         
         
     
     
         
     
     
         
     
         
             
         // CPC3000 device 1 is used for overpressure scan
         
         
         //    define this symbol to use pressure controller with Yt stripchart plotting option            
             
         // CPC3000 device 2 is used for underpressure setting
         
         //#define        CPC3000_DEV2_PRESS_IS_LOGGED                        1            // no need to log this, since it is a constant value
         //    define this symbol to use pressure controller with Yt stripchart plotting option            
     
                 
                     //    define this symbol to use Beckhoff pressure sensor 1 on line A at all
             //    define this symbol to use Yt stripchart plotting option on fmmt measurement on Beckhoff pressure sensor 1 on line A
             //    define this symbol to log measurement on Beckhoff pressure sensor 1 on line A
             
             //    define this symbol to use Beckhoff pressure sensor 2 on line A at all
             //    define this symbol to use Yt stripchart plotting option on fmmt measurement on Beckhoff pressure sensor 2 on line A
             //    define this symbol to log measurement on Beckhoff pressure sensor 2 on line A
                                 
             // XY graph of input flow vs backpressure
             
             // XY1 graph is showing last 100 points - when this is reached, the oldest points are discarded
             
             // this is not a macro or a string constant - it is a string variable, device dependent!
             
             
             
             
         
             
             // XY2 graph is showing last 100 points - when this is reached, the oldest points are discarded
             // this is not a macro or a string constant - it is a string variable, device dependent!
             // y axis is using Beckhoff pressure sensors, line A
             
             
             
             
 
             //    Beckhoff base bus library for use with LittleC
 
 
     
         // include symbols once
         //    ETHERCAT device library for use with LittleC
 
     
         
     // this symbol denotes, that a ETHERCAT library was already included
     // this symbol defines the version of the ETHERCAT device library
     
     
     
     // "PC-L109-08" machine is being used
             
         /*
         Note:    Use log file of the EtherCAT_Control program to identify the adapter name
                 Use value "Realtek RTL8169/8110 PCI Gigabit Ethernet NIC" if the line contains "ec_init on adapter:"Realtek RTL8169/8110 PCI Gigabit Ethernet NIC" ID:"\Device\NPF_{3134B559-08DC-4397-B2A4-DD68D4FE4953}" succeeded."
         */        
         // Use log file of the EtherCAT_Control program to identify the adapter name
         
         
         // "PC-L109-08" machine is being used
         
     // "PC-L109-08" machine is being used
     
     // "PC-L109-08" machine is being used
     
             
     // this symbol denotes, that a Beckhoff modules library was already included        
     // this symbol defines the version of the Beckhoff modules library
 
     // Error section Beckhoff connections
     
     
             
     
     
 
     
     
 
      
     
     
     int        bus_Beckhoff_error;    
     
     int Bus_Beckhoff_Connect()
     {
     
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 13, 1, -3 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         /*    EMFT_EtherCAT_Connect function parameter description:
             1. parameter - EtherCAT adapter name 
             Note:    Use log file of the EtherCAT_Control program to identify the adapter name
                     Use value "Realtek RTL8169/8110 PCI Gigabit Ethernet NIC" if the line contains "ec_init on adapter:"Realtek RTL8169/8110 PCI Gigabit Ethernet NIC" ID:"\Device\NPF_{3134B559-08DC-4397-B2A4-DD68D4FE4953}" succeeded."
         */         
         bus_Beckhoff_error = EMFT_EtherCAT_Connect( "Realtek PCI GBE Family Controller" );
         if ( bus_Beckhoff_error != 0 )    {
             EMFT_EtherCAT_Disconnect();                
             Log_Error( 13, 1, -2 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );     //    -1 );    // exit with error code return
         }
 
         return ( 0 );
     }
 
     int Bus_Beckhoff_Disconnect()
     {
         
         bus_Beckhoff_error = EMFT_EtherCAT_Disconnect();        // Disconnect all Beckhoff modules
     
         if ( bus_Beckhoff_error != 0 )    {            
             Log_Error( 13, 1, -2 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );     //    -2 );    // exit with error code return
         }
     
         return ( 0 );
         
     }
 
             //    use valve line B
             
             //    Beckhoff valve library for use with LittleC
 
 
     
         //
         /*    EL2809 routines library for use with LittleC */
 
     // EL2809 library definitions are being processed
     
     
     
     
     
     
             // Use log file of the EtherCAT_Control program to identify the EL2809 module address. Use value xxx if the line contains "Found EL2809 at position xxx    ID: 0xaf93052    Manufacturer: 0x2    Revision: 0x110000"
     
         
     
     
     
     // this symbol denotes, that a EL2809 library was already included
     // this symbol defines the version of the EL2809 library
 
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     //delay time 
     
         
     // this symbol denotes, that a Beckhoff EL2809 based valves library was already included        
     // this symbol defines the version of the valves library
     
     // connection table    of valves to EL2809 module
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
         
     
     
 
     
         // close entire valve line A
         
         
         
         
         
         
         
         
         
         
     
     
     
         
         
                 
                     // set initial state of valve line B        
             
             
             
             
             
             
                 
     
         
         
         
     
         
     
     // Error section Beckhoff valves
     
     
             
     
     
     
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
     
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
     
     
     
 
     
     
 
 
     int        valve_Beckhoff_error;    
     int     EL2809_ch_value;
     
     int Valves_Beckhoff_Configure()
     {    
     
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error(11, 1, -18);    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         /*    EMFT_EL2809_Setup function parameter description:
         1. parameter - EL2809 slave module number
         Note:    Use log file of the EtherCAT_Control program to identify the EL2809 module number: 
                 Use value xxx if the line contains "Found EL2809 at position xxx    ID: 0x7103052    Manufacturer: 0x2    Revision: 0x110000"
         */         
         valve_Beckhoff_error = EMFT_EL2809_Setup( 6 );
         if ( valve_Beckhoff_error != 0)    {
             EMFT_EtherCAT_Disconnect();                
             Log_Error( 11, 1, -16 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );     //    -16 );    // exit with error code return
         }
         
         EMFT_Wait( 100 );    // wait for output valve to stabilize
         
                 
         /*
             Sends the sequence of valve on/off commands to the EL2809 Beckhoff module
             according to performed measurement type.        
         */
         Valves_Beckhoff_SetValve_A_State( 0, 0 );
         Valves_Beckhoff_SetValve_A_State( 1, 0 );
         Valves_Beckhoff_SetValve_A_State( 2, 0 );
         Valves_Beckhoff_SetValve_A_State( 3, 0 );
         Valves_Beckhoff_SetValve_A_State( 4, 0 );
         Valves_Beckhoff_SetValve_A_State( 5, 0 );
         
         Valves_Beckhoff_SetValve_B_State( 6, 1 );
         Valves_Beckhoff_SetValve_B_State( 7, 1 );
         Valves_Beckhoff_SetValve_B_State( 8, 0 );
         Valves_Beckhoff_SetValve_B_State( 9, 0 );
         Valves_Beckhoff_SetValve_B_State( 10, 1 );
         Valves_Beckhoff_SetValve_B_State( 11, 1 );
         
         return ( 0 );
     }
     
     /*
         Sends the valve on/off command to the EL2809 Beckhoff module
         Valve channel numbers A1 to A6 are currently supported
         Valve state=0 denotes valve closed, otherwise valve open
     */
     int Valves_Beckhoff_SetValve_A_State( char valve_nr, char valve_state )
     {
         
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error(11, 1, -18);    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         /*    EMFT_EL2809_SetCh function parameter description:
             1. parameter - EL2809 slave module number
             Note:    Use log file of the EtherCAT_Control program to identify the EL2809 module number: 
                     Use value xxx if the line contains "Found EL2809 at position xxx    ID: 0x7103052    Manufacturer: 0x2    Revision: 0x110000"
             2. parameter - EL2809 module channel number, integer, value interval: 0 to 15
             3. parameter - EL2809 module channel value ( 0 - OFF, 1 - ON )
         */
         valve_Beckhoff_error = EMFT_EL2809_SetCh( 6, valve_nr, valve_state );
         if ( valve_Beckhoff_error != 0)    {
             EMFT_EtherCAT_Disconnect();            
             if ( valve_nr == 0 )    {
                 Log_Error( 11, 1, -3 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //    -3 );    // exit with error code return
             }
             else if ( valve_nr == 1 )    {
                 Log_Error( 11, 1, -4 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //    -4 );    // exit with error code return
             }
             else if ( valve_nr == 2 )    {
                 Log_Error( 11, 1, -5 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //    -5 );    // exit with error code return
             }
             else if ( valve_nr == 3 )    {
                 Log_Error( 11, 1, -6 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //    -6 );    // exit with error code return
             }
             else if ( valve_nr == 4 )    {
                 Log_Error( 11, 1, -7 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //    -7 );    // exit with error code return
             }
             else if ( valve_nr == 5 )    {
                 Log_Error( 11, 1, -8 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //    -8 );    // exit with error code return
             }            
             else {
                 Log_Error( 11, 1, -15 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //    -15 );    // exit with error code return            
             }            
         }
         if (valve_state == 1) {
             puts("Valve Channel "); print(valve_nr); puts(" (line A) switched to OPEN.\n");    
         } else {
             puts("Valve Channel "); print(valve_nr); puts(" (line A) switched to CLOSED.\n");    
         }
         
         EMFT_Wait( 100 );    // wait for output valve to stabilize
         
         return ( 0 );
         
     }
 
     /*
         Sends the valve on/off command to the EL2809 Beckhoff module
         Valve channel numbers B1 to B6 are currently supported
         Valve state=0 denotes valve closed, otherwise valve open
     */
     int Valves_Beckhoff_SetValve_B_State( char valve_nr, char valve_state )
     {
         
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error(11, 1, -18);    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         /*    EMFT_EL2809_SetCh function parameter description:
             1. parameter - EL2809 slave module number
             Note:    Use log file of the EtherCAT_Control program to identify the EL2809 module number: 
                     Use value xxx if the line contains "Found EL2809 at position xxx    ID: 0x7103052    Manufacturer: 0x2    Revision: 0x110000"
             2. parameter - EL2809 module channel number, integer, value interval: 0 to 15
             3. parameter - EL2809 module channel value ( 0 - OFF, 1 - ON )
         */
         valve_Beckhoff_error = EMFT_EL2809_SetCh( 6, valve_nr, valve_state );
         if ( valve_Beckhoff_error != 0)    {
             EMFT_EtherCAT_Disconnect();            
             if ( valve_nr == 6 )    {
                 Log_Error( 11, 1, -9 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //    -9 );    // exit with error code return
             }
             else if ( valve_nr == 7 )    {
                 Log_Error( 11, 1, -10 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //    -10 );    // exit with error code return
             }
             else if ( valve_nr == 8 )    {
                 Log_Error( 11, 1, -11 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //    -11 );    // exit with error code return
             }
             else if ( valve_nr == 9 )    {
                 Log_Error( 11, 1, -12 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //    -12 );    // exit with error code return
             }
             else if ( valve_nr == 10 )    {
                 Log_Error( 11, 1, -13 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //    -13 );    // exit with error code return
             }
             else if ( valve_nr == 11 )    {
                 Log_Error( 11, 1, -14 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //    -14 );    // exit with error code return
             }
             else {
                 Log_Error( 11, 1, -15 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //    -15 );    // exit with error code return            
             }
             
         }
         
         if (valve_state == 1) {
             puts("Valve Channel "); print(valve_nr); puts(" (line B) switched to OPEN.\n");    
         } else {
             puts("Valve Channel "); print(valve_nr); puts(" (line B) switched to CLOSED.\n");    
         }
 
         EMFT_Wait( 100 );    // wait for output valve to stabilize
         
         return ( 0 );
         
     }
     
     /*
         Reads the valve on/off state of a specified channel from EL2809 Beckhoff module
         Valve channel numbers A1 to A6 are currently supported
         Return value: valve state=0 denotes valve closed, otherwise valve open
     */
     int Valves_Beckhoff_GetValve_A_State( char valve_nr )
     {    
             
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error(11, 1, -18);    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         /*    EMFT_EL2809_GetCh function parameter description:
             1. parameter - EL2809 slave module number
             Note:    Use log file of the EtherCAT_Control program to identify the EL2809 module number: 
                     Use value xxx if the line contains "Found EL2809 at position xxx    ID: 0x7103052    Manufacturer: 0x2    Revision: 0x110000"
             2. parameter - EL2809 module channel number, integer, value interval: 0 to 15        
         */
         
         EL2809_ch_value = EMFT_EL2809_GetCh( 6, valve_nr );
         
         return ( EL2809_ch_value );
         
     }    
 
     /*
         Reads the valve on/off state of a specified channel from EL2809 Beckhoff module
         Valve channel numbers B1 to B6 are currently supported
         Return value: valve state=0 denotes valve closed, otherwise valve open
     */
     int Valves_Beckhoff_GetValve_B_State( char valve_nr )
     {    
             
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error(11, 1, -18);    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         /*    EMFT_EL2809_GetCh function parameter description:
             1. parameter - EL2809 slave module number
             Note:    Use log file of the EtherCAT_Control program to identify the EL2809 module number: 
                     Use value xxx if the line contains "Found EL2809 at position xxx    ID: 0x7103052    Manufacturer: 0x2    Revision: 0x110000"
             2. parameter - EL2809 module channel number, integer, value interval: 0 to 15        
         */
         
         EL2809_ch_value = EMFT_EL2809_GetCh( 6, valve_nr );
         
         return ( EL2809_ch_value );
         
     }        
     
             //    Beckhoff pressure sensor library for use with LittleC
 
     
     
         /*    EL3054 routines library for use with LittleC */
 
     // EL3054 library definitions are being processed
     
         
     // this symbol denotes, that a EL3054 library was already included
     // this symbol defines the version of the EL3054 library
 
     
     
     
     
 
     int     EL3054_raw_value;
     float     EL3054_ch_value;
     
     
     
 
     
     // use 100 counts, if there is much noise    
     // Use 50 seconds timeout for 10 element stability buffer
     
     
     
     
 
     
     
     // Use 50 seconds timeout for 10 element stability buffer
 
     
         // Use log file of the EtherCAT_Control program to identify the EL3054 module address. Use value xxx if the line contains "Found EL3054 at position xxx    ID: 0xfb63052    Manufacturer: 0x2    Revision: 0x110000"
         // Use log file of the EtherCAT_Control program to identify the EL3054 module address. Use value xxx if the line contains "Found EL3054 at position xxx    ID: 0xfb63052    Manufacturer: 0x2    Revision: 0x110000"
 
         
     
     /*    EL3054 module calibration data:
         EL3054 module by default converts  
         a 4-20 mA current input (referred to as 'in' in the following) to
         a corresponding digital output (referred to as 'out' in the following)
         on a specified channel (out of 2 possible).
         Calibration data contains:
         -    date of calibration
         -    calibration expiration date
         -    EL3054 module user-scale calibration data
             -    number of calibration data points
             -    calibration points data
     */
 
     // EL3054 calibration date (format dd.mm.yyyy)
     // EL3054 calibration expiration date (format dd.mm.yyyy)
     
     /* Channel 0 calibration information */
     // human-readable name for identifying the output quantity, used for logging
     // human-readable name for identifying the raw output quantity, used for logging
     
     
     // number of calibration points on channel 0
 
     // calibration point 0 index
     // ch 0, calibration point 0: 0, input current is 4.0 mA
     
 
     // calibration point 1 index
     // ch 0, calibration point 1: 32767, input current is 20.0 mA
     
 
     /* Channel 1 calibration information */
     // human-readable name for identifying the output quantity, used for logging
     // human-readable name for identifying the raw output quantity, used for logging
     
     
     // number of calibration points on channel 1
 
     // calibration point 0 index
     // ch 1, calibration point 0: 0, input current is 4.0 mA
     
 
     // calibration point 1 index
     // ch 1, calibration point 1: 32767, input current is 20.0 mA
     
     
     /* Channel 2 calibration information */
     // human-readable name for identifying the output quantity, used for logging
     // human-readable name for identifying the raw output quantity, used for logging
     
     
     // number of calibration points on channel 2
 
     // calibration point 0 index
     // ch 2, calibration point 0: 0, input current is 4.0 mA
     
 
     // calibration point 1 index
     // ch 2, calibration point 1: 32767, input current is 20.0 mA
     
     
     /* Channel 3 calibration information */
     // human-readable name for identifying the output quantity, used for logging
     // human-readable name for identifying the raw output quantity, used for logging
     
     
     // number of calibration points on channel 3
 
     // calibration point 0 index
     // ch 3, calibration point 0: 0, input current is 4.0 mA
     
 
     // calibration point 1 index
     // ch 3, calibration point 1: 32767, input current is 20.0 mA
     
     
     
     
     
     
     
     
     
     
     
     int EL3054_Configure( int EL3054_module_nr )    
     {        
         int        EL3054_error;
         int        EL3054_days_to_calibration;    
                     
         /*    EMFT_EL3054_Setup function parameter description:
             1. parameter - EL3054 slave module number
             Note:    Use log file of the EtherCAT_Control program to identify the EL3054 module number: 
                     Use value xxx if the line contains "Found EL3054 at position xxx    ID: 0x7103052    Manufacturer: 0x2    Revision: 0x110000"
         */         
         EL3054_error = EMFT_EL3054_Setup( EL3054_module_nr );    
         if ( EL3054_error != 0 )    {            
             return 0;        
         };
                 
         // EMFT_Check_Exp_Date calculates the number of days left between the date in future and now. Input date is in string format "dd.mm.yyyy" e.g. "31.12.2018". A negative number of days is returned for already past dates
         EL3054_days_to_calibration = EMFT_Check_Exp_Date( "31.12.2022" );
         
         if ( EL3054_days_to_calibration < 0 )    {
             puts("Please recalibrate devices, connected to the EL3054 module.\nScript will now exit!\n(press 'p' to proceed)\n");    // notify user of failed calibration check status
             emft_write_current_timestamp();    emft_write_string("\tCalibration date for devices, connected to the EL3054 module, has expired "); emft_write_var( -EL3054_days_to_calibration ); emft_write_string(" days ago!\r\n");        // log pressure sensor calibration date
             Wait_On_User_Response('p');
             return -1;        // exit
         }
         else    {
             emft_write_current_timestamp();    emft_write_string("\tCalibration date for devices, connected to the EL3054 module, expires in "); emft_write_var( EL3054_days_to_calibration ); emft_write_string(" days!\r\n");        // log pressure sensor calibration date
         }
         
         // channel 0 user-scale setup
         EL3054_error = EMFT_EL3054_Setup_UserScale( EL3054_module_nr, 0,  2);    // setup default 2 calibration points (4-20mA) on all channels        
         if ( EL3054_error != 0)    {        
             return EL3054_error;
         }
         
         EL3054_error = EMFT_EL3054_Set_UserScale_CalPt( EL3054_module_nr, 0, 0, 0, "mA", 4 );    // first calibration point is at 0, output current is 4.0 mA
         if ( EL3054_error != 0)    {        
             return EL3054_error;
         }
         
         EL3054_error = EMFT_EL3054_Set_UserScale_CalPt( EL3054_module_nr, 0, 1, 32767, "mA", 20 );    // second calibration point is at 0x7fff, output current is 20.0 mA
         if ( EL3054_error != 0)    {        
             return EL3054_error;
         }
 
         // channel 1 user-scale setup
         EL3054_error = EMFT_EL3054_Setup_UserScale( EL3054_module_nr, 1,  2);    // setup default 2 calibration points (4-20mA) on all channels        
         if ( EL3054_error != 0)    {        
             return EL3054_error;
         }
         
         EL3054_error = EMFT_EL3054_Set_UserScale_CalPt( EL3054_module_nr, 1, 0, 0, "mA", 4 );    // first calibration point is at 0, output current is 4.0 mA
         if ( EL3054_error != 0)    {        
             return EL3054_error;
         }
         
         EL3054_error = EMFT_EL3054_Set_UserScale_CalPt( EL3054_module_nr, 1, 1, 32767, "mA", 20 );    // second calibration point is at 0x7fff, output current is 20.0 mA
         if ( EL3054_error != 0)    {        
             return EL3054_error;
         }
         
         // channel 2 user-scale setup
         EL3054_error = EMFT_EL3054_Setup_UserScale( EL3054_module_nr, 2,  2);    // setup default 2 calibration points (4-20mA) on channels        
         if ( EL3054_error != 0)    {        
             return EL3054_error;
         }
         
         EL3054_error = EMFT_EL3054_Set_UserScale_CalPt( EL3054_module_nr, 2, 0, 0, "mA", 4 );    // first calibration point is at 0, output current is 4.0 mA
         if ( EL3054_error != 0)    {        
             return EL3054_error;
         }
         
         EL3054_error = EMFT_EL3054_Set_UserScale_CalPt( EL3054_module_nr, 2, 1, 32767, "mA", 20 );    // second calibration point is at 0x7fff, output current is 20.0 mA
         if ( EL3054_error != 0)    {        
             return EL3054_error;
         }
         
         // channel 3 user-scale setup
         EL3054_error = EMFT_EL3054_Setup_UserScale( EL3054_module_nr, 3,  2);    // setup default 2 calibration points (4-20mA) on all channels        
         if ( EL3054_error != 0)    {        
             return EL3054_error;
         }
         
         EL3054_error = EMFT_EL3054_Set_UserScale_CalPt( EL3054_module_nr, 3, 0, 0, "mA", 4 );    // first calibration point is at 0, output current is 4.0 mA
         if ( EL3054_error != 0)    {        
             return EL3054_error;
         }
         
         EL3054_error = EMFT_EL3054_Set_UserScale_CalPt( EL3054_module_nr, 3, 1, 32767, "mA", 20 );    // second calibration point is at 0x7fff, output current is 20.0 mA
         if ( EL3054_error != 0)    {        
             return EL3054_error;
         }
                 
         
                 
         
                         
         
                 
         
                 
         return (EL3054_error);        // exit with success code return
     }    
     
     int EMFT_EL3054_GetRawValue( int EL3054_module_nr, int EL3054_ch_nr )    
     {
         int        EL3054_error;
         float     t_start, t_now, delta_t;        
         int     EL3054_IsRawReadoutStable;
         
         EL3054_error = EMFT_EL3054_Config_Raw_Stability( EL3054_module_nr, EL3054_ch_nr, 10,    100 );
         
         EL3054_IsRawReadoutStable = 0;    // reset stability criterion            
         t_start = EMFT_Get_TimeStamp();    // store stabilization loop start time
         do    {            
 
             EL3054_raw_value = EMFT_EL3054_GetRawCh( EL3054_module_nr, EL3054_ch_nr );    // get a value and store in stability buffer
 
             EL3054_IsRawReadoutStable = EMFT_EL3054_IsRawReadoutStable( EL3054_module_nr, EL3054_ch_nr );
 
             t_now = EMFT_Get_TimeStamp();    // store stabilization loop current time
             
             delta_t = t_now - t_start;        // check elapsed time against stabilization timeout in ms
 
                         
                         
                         
                         
         } while ( ( ( EL3054_IsRawReadoutStable == 0 ) && ( delta_t < 50000 ) ) && (Signal_goto_safe_state == 0) );            
                         
         if ( delta_t >= 50000 )    {                        
             puts( "EL3054 stabilization timeout!\n" );    // signal the timeout error to the user
             return (-1);    // return error code
         }
         else {
             return (EL3054_error);    // exit with success code return
         };
         
     }
 
     float EMFT_EL3054_GetValue( int EL3054_module_nr, int EL3054_ch_nr )
     {
         int        EL3054_error;
         float     t_start, t_now, delta_t;        
         int     EL3054_IsReadoutStable;
                 
         EL3054_error = EMFT_EL3054_Config_Stability( EL3054_module_nr, EL3054_ch_nr, 10, 0.5 );
         
         EL3054_IsReadoutStable = 0;    // reset stability criterion            
         t_start = EMFT_Get_TimeStamp();    // store stabilization loop start time
         do    {            
         
             EL3054_ch_value = EMFT_EL3054_GetCh( EL3054_module_nr, EL3054_ch_nr );    // get a value and store in stability buffer
             
             EL3054_IsReadoutStable = EMFT_EL3054_IsReadoutStable( EL3054_module_nr, EL3054_ch_nr );
 
             t_now = EMFT_Get_TimeStamp();    // store stabilization loop current time
             
             delta_t = t_now - t_start;        // check elapsed time against stabilization timeout in ms
 
                         
                         
                         
                         
         } while ( ( ( EL3054_IsReadoutStable == 0 ) && ( delta_t < 50000 ) ) && (Signal_goto_safe_state == 0) );            
         
         if ( delta_t >= 50000 )    {                        
             puts( "EL3054 stabilization timeout!\n" );    // signal the timeout error to the user
             return (-1);    // return error code
         }
         else {
             return (EL3054_error);    // exit with success code return
         };
         
     }
     
     
     // this symbol denotes, that a Beckhoff EL3054 based pressure sensors library was already included        
     // this symbol defines the version of the pressure sensor library
     
     // connection table    of pressure sensors to EL3054 module
     
     // Line A address 
     
     
     //    General sensor map configuration definitions for use with LittleC
 
 
 
 
     
     // Line A, PS1 
         
     // Line A, PS2 
         
     // Line B address 
     
     
     // Line B, PS1
             float    Beckhoff_B_PS1_mmt;                    // floating-point measurement on pressure sensor 1, Line B        
         int        Beckhoff_B_PS1_immt;                // integer raw measurement on pressure sensor 1, Line B
         
         
         
         
                     // line B, pressure sensor 1 was calibrated at least once
             // 2020_02_04_16_54_25    *****    Measurement:    CALIBRATION OF PRESSURE SENSORS FOR WATER    *****
 // 2020_02_04_16_54_26    1    Test environment:
 // 2020_02_04_16_54_26    1.1    Run by:    pc-l109-08
 // 2020_02_04_16_54_26    1.2    Run on:    PC-L109-08
 // 2020_02_04_16_54_27    1.3    IP address:    169.254.142.73
 // 2020_02_04_16_54_27    1.4    Run using:    Little C scripter -- Ver.: 1.0.0.0, built on: Jan 17 2020 at 17:04:25
 // 2020_02_04_16_54_27    1.5    Script:
 // 2020_02_04_16_54_28    1.5.1    Name:    T:/MAF_Durchlauf_Doku/ArbPl_Mess_und_Prozessequipment/Scripte/LittleC_SCRIPTS_2/LCS1197.c
 // 2020_02_04_16_54_28    1.5.2    Version:    MM1
 // 2020_02_04_16_54_28    1.5.3    Cal. date:    "04.02.2020"
 // 2020_02_04_16_54_28    1.5.4    Cal. exp. date:    "01.01.2021"
 // 2020_02_04_16_54_29    1.6    Library versions:
 // 2020_02_04_16_54_29    1.6.1    Common:    MM7_MW4_AK1
 // 2020_02_04_16_54_29    1.6.2    Micropumps:    MM5_MW3
 // 2020_02_04_16_54_30    1.6.3    MENSOR CPC3000 pressure regulator:    MM5_MW6
 // 2020_02_04_16_54_31    1.6.8    Calibration file:    MM1
 // 2020_02_04_16_54_31    2    Calibration site:    PC-L109-08
 // 2020_02_04_16_54_31    2.1    Instruments used:
 // 2020_02_04_16_54_32    2.1.3    Mensor CPC3000 pressure controller:
 // 2020_02_04_16_54_32    2.1.3.1    Serial number:     MENSOR,CPC3000,810615,2.6.0
 // 2020_02_04_16_54_33    3.4    Actuation:
 // 2020_02_04_16_54_33    3.4.1    HiLevel:    90
 // 2020_02_04_16_54_33    3.4.2    LoLevel:    -20
 // 2020_02_04_16_54_34    *****    Start of measurement:    CALIBRATION OF PRESSURE SENSORS FOR WATER    *****
 // 2020_02_04_16_54_34    HeaderStop:    25
 // 2020_02_04_16_54_35    PT. TYPE    ADC[B_PS1]    P1
 // 2020_02_04_16_54_36         [counts]    [hPa]
 // 2020_02_04_16_56_04    CP    4707    0
 // 2020_02_04_16_57_15    CP    5884    250
 // 2020_02_04_16_58_23    CP    7047    500
 // 2020_02_04_16_59_24    CP    8240    750
 // 2020_02_04_17_00_23    CP    9382    1000
 // 2020_02_04_17_01_25    CP    10588    1250
 // 2020_02_04_17_02_31    CP    11723    1500
 // 2020_02_04_17_03_31    CP    12913    1750
 // 2020_02_04_17_04_36    CP    14096    2000
 // 2020_02_04_17_05_43    TP    12907    1750
 // 2020_02_04_17_06_51    TP    11723    1500
 // 2020_02_04_17_08_00    TP    10553    1250
 // 2020_02_04_17_09_12    TP    9378    1000
 // 2020_02_04_17_10_17    TP    8234    750
 // 2020_02_04_17_11_28    TP    7046    500
 // 2020_02_04_17_12_40    TP    5880    250
 // 2020_02_04_17_13_51    TP    4709    0
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 // 2020_02_04_17_15_57    *****    End of measurement:    CALIBRATION OF PRESSURE SENSORS FOR WATER    *****
                 
                 
         
         
             // human-readable name for identifying the plotting output quantity, used for logging and plotting
             // Current stripchart plot history length
             // Current stripchart time axis default width in seconds
             // Current stripchart plot Y axis minimum value for current (use float value)
             // Current stripchart plot Y axis maximum value for current (use float value)        
             
                 
         
     // Line B, PS2 
             float    Beckhoff_B_PS2_mmt;                    // floating-point measurement on pressure sensor 2, Line B
         int        Beckhoff_B_PS2_immt;                // integer raw measurement on pressure sensor 2, Line B
         
         
         
             
                     // line B, pressure sensor 2 was calibrated at least once
             // 2020_02_04_16_54_37    *****    Measurement:    CALIBRATION OF PRESSURE SENSORS FOR WATER    *****
 // 2020_02_04_16_54_38    1    Test environment:
 // 2020_02_04_16_54_38    1.1    Run by:    pc-l109-08
 // 2020_02_04_16_54_39    1.2    Run on:    PC-L109-08
 // 2020_02_04_16_54_39    1.3    IP address:    169.254.142.73
 // 2020_02_04_16_54_39    1.4    Run using:    Little C scripter -- Ver.: 1.0.0.0, built on: Jan 17 2020 at 17:04:25
 // 2020_02_04_16_54_40    1.5    Script:
 // 2020_02_04_16_54_40    1.5.1    Name:    T:/MAF_Durchlauf_Doku/ArbPl_Mess_und_Prozessequipment/Scripte/LittleC_SCRIPTS_2/LCS1197.c
 // 2020_02_04_16_54_40    1.5.2    Version:    MM1
 // 2020_02_04_16_54_41    1.5.3    Cal. date:    "04.02.2020"
 // 2020_02_04_16_54_41    1.5.4    Cal. exp. date:    "01.01.2021"
 // 2020_02_04_16_54_42    1.6    Library versions:
 // 2020_02_04_16_54_42    1.6.1    Common:    MM7_MW4_AK1
 // 2020_02_04_16_54_42    1.6.2    Micropumps:    MM5_MW3
 // 2020_02_04_16_54_43    1.6.3    MENSOR CPC3000 pressure regulator:    MM5_MW6
 // 2020_02_04_16_54_43    1.6.8    Calibration file:    MM1
 // 2020_02_04_16_54_44    2    Calibration site:    PC-L109-08
 // 2020_02_04_16_54_44    2.1    Instruments used:
 // 2020_02_04_16_54_45    2.1.3    Mensor CPC3000 pressure controller:
 // 2020_02_04_16_54_45    2.1.3.1    Serial number:     MENSOR,CPC3000,810615,2.6.0
 // 2020_02_04_16_54_46    3.4    Actuation:
 // 2020_02_04_16_54_46    3.4.1    HiLevel:    90
 // 2020_02_04_16_54_46    3.4.2    LoLevel:    -20
 // 2020_02_04_16_54_47    *****    Start of measurement:    CALIBRATION OF PRESSURE SENSORS FOR WATER    *****
 // 2020_02_04_16_54_47    HeaderStop:    25
 // 2020_02_04_16_54_48    PT. TYPE    ADC[B_PS2]    P1
 // 2020_02_04_16_54_49         [counts]    [hPa]
 // 2020_02_04_16_56_05    CP    4719    0
 // 2020_02_04_16_57_17    CP    5880    250
 // 2020_02_04_16_58_25    CP    7049    500
 // 2020_02_04_16_59_25    CP    8207    750
 // 2020_02_04_17_00_24    CP    9394    1000
 // 2020_02_04_17_01_26    CP    10563    1250
 // 2020_02_04_17_02_33    CP    11718    1500
 // 2020_02_04_17_03_31    CP    12876    1750
 // 2020_02_04_17_04_38    CP    14062    2000
 // 2020_02_04_17_05_44    TP    12879    1750
 // 2020_02_04_17_06_52    TP    11713    1500
 // 2020_02_04_17_08_01    TP    10559    1250
 // 2020_02_04_17_09_13    TP    9402    1000
 // 2020_02_04_17_10_18    TP    8203    750
 // 2020_02_04_17_11_29    TP    7057    500
 // 2020_02_04_17_12_42    TP    5889    250
 // 2020_02_04_17_13_52    TP    4681    0
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 // 2020_02_04_17_15_58    *****    End of measurement:    CALIBRATION OF PRESSURE SENSORS FOR WATER    *****
                 
                 
         
         
             // human-readable name for identifying the plotting output quantity, used for logging and plotting
             // Current stripchart plot history length
             // Current stripchart time axis default width in seconds
             // Current stripchart plot Y axis minimum value for current (use float value)
             // Current stripchart plot Y axis maximum value for current (use float value)        
             
             
     // Error section Beckhoff pressure sensor
     
     
             
     
     
     
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
     
     
     
 
     
     
     
     int        PS_Beckhoff_error;    
     char    PS_Beckhoff_macro_name[100];
     char    PS_Beckhoff_macro_value[100];
     int        PS_Beckhoff_CalPt_Idx;
     int        PS_Beckhoff_CalPt_Nr;
     int        PS_Beckhoff_CalPt_In;
     float    PS_Beckhoff_CalPt_Out;
     
     int PS_Beckhoff_Configure()
     {    
         
         int        EL3054_days_to_calibration;
                     
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 12, 1, -10 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         /*    EMFT_EL3054_Setup function parameter description:
             1. parameter - EL3054 slave module number
             Note:    Use log file of the EtherCAT_Control program to identify the EL3054 module number: 
                     Use value xxx if the line contains "Found EL3054 at position xxx    ID: 0x7103052    Manufacturer: 0x2    Revision: 0x110000"
         */         
         PS_Beckhoff_error = EMFT_EL3054_Setup( 3 );
         if ( PS_Beckhoff_error != 0)    {
             EMFT_EtherCAT_Disconnect();                
             Log_Error( 12, 1, -8 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );     //    -8 );    // exit with error code return
         }
                 
                 
         
             // Line A, PS1 user-scale setup
                         
             // Line A, PS2 user-scale setup
                         
             // Line B, PS1 user-scale setup
             
                 // line B pressure sensor 1
                 Beckhoff_B_PS1_mmt = 0.0;                // reset measurement
                 Beckhoff_B_PS1_immt = 0;                // reset integer raw measurement
                 PS_Beckhoff_CalPt_Idx = 0;                // reset calibration point index counter
                 PS_Beckhoff_CalPt_Nr = 9;        // initial number of calibration points is 9
                 
                                     PS_Beckhoff_CalPt_Nr = PS_Beckhoff_CalPt_Nr + 2;
                                 PS_Beckhoff_error = EMFT_EL3054_Setup_UserScale( 3, 2, PS_Beckhoff_CalPt_Nr );    // setup PS_Beckhoff_CalPt_Nr calibration points
                 
                 if ( PS_Beckhoff_error != 0)    {        
                     Log_Error( 12, 1, -5 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //    -5 );    // exit with error code return
                 }
                 
                 PS_Beckhoff_CalPt_Nr = 0;    // reset current calibration point number
                 
                                     PS_Beckhoff_error = EMFT_EL3054_Set_UserScale_CalPt( 3, 2, PS_Beckhoff_CalPt_Nr, 2363 , "hPa", -500 );    // enter calibration extension point
                     if ( PS_Beckhoff_error != 0)    {        
                         EMFT_EtherCAT_Disconnect();                
                         Log_Error( 12, 1, -6 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //    -6 );    // exit with error code return
                     }                
                     
                 
                 for ( PS_Beckhoff_CalPt_Idx = 0; PS_Beckhoff_CalPt_Idx < 9; PS_Beckhoff_CalPt_Idx = PS_Beckhoff_CalPt_Idx + 1 )    {
                     // scroll through all sensor calibration points
                     
                     PS_Beckhoff_CalPt_Nr = PS_Beckhoff_CalPt_Nr + 1;    // increment current calibration point number
                     
                     EMFT_VSnPrintf( PS_Beckhoff_macro_name, "PS_BECKHOFF_B_PS1_CP%d_IN", PS_Beckhoff_CalPt_Idx );    // get calibration point input macro value
                     PS_Beckhoff_error = EMFT_GetMacroValue( PS_Beckhoff_macro_name, PS_Beckhoff_CalPt_In );        // obtain macro value - calibration point input
                     
                     EMFT_VSnPrintf( PS_Beckhoff_macro_name, "PS_BECKHOFF_B_PS1_CP%d_OUT", PS_Beckhoff_CalPt_Idx );    // get calibration point input macro value
                     PS_Beckhoff_error = EMFT_GetMacroValue( PS_Beckhoff_macro_name, PS_Beckhoff_CalPt_Out );        // obtain macro value - calibration point output
                     
                     PS_Beckhoff_error = EMFT_EL3054_Set_UserScale_CalPt( 3, 2, PS_Beckhoff_CalPt_Nr, PS_Beckhoff_CalPt_In , "hPa", PS_Beckhoff_CalPt_Out );    // enter calibration point
                     if ( PS_Beckhoff_error != 0)    {        
                         EMFT_EtherCAT_Disconnect();                
                         Log_Error( 12, 1, -6 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //    -6 );    // exit with error code return
                     }
                 
                 }
                 
                                     PS_Beckhoff_error = EMFT_EL3054_Set_UserScale_CalPt( 3, 2, PS_Beckhoff_CalPt_Nr + 1, 18774 , "hPa", 3000 );    // enter calibration extension point
                     if ( PS_Beckhoff_error != 0)    {        
                         EMFT_EtherCAT_Disconnect();                
                         Log_Error( 12, 1, -6 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //    -6 );    // exit with error code return
                     }                
                     
                                 
                 // EMFT_Check_Exp_Date calculates the number of days left between the date in future and now. Input date is in string format "dd.mm.yyyy" e.g. "31.12.2018". A negative number of days is returned for already past dates
                 EL3054_days_to_calibration = EMFT_Check_Exp_Date( "01.01.2022" );
                 
                 if ( EL3054_days_to_calibration < 0 )    {
                     puts("Please recalibrate devices, connected to the EL3054 module.\nScript will now exit!\n(press 'p' to proceed)\n");    // notify user of failed calibration check status
                     emft_write_current_timestamp();    emft_write_string("\tCalibration date for devices, connected to the EL3054 module, has expired "); emft_write_var( -EL3054_days_to_calibration ); emft_write_string(" days ago!\r\n");        // log pressure sensor calibration date
                     Wait_On_User_Response('p');
                     Log_Error( 12, 1, -4 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //    -4 );    // exit with error code return
                 }
                 else    {
                     emft_write_current_timestamp();    emft_write_string("\tCalibration date for devices, connected to the EL3054 module, expires in "); emft_write_var( EL3054_days_to_calibration ); emft_write_string(" days!\r\n");        // log pressure sensor calibration date
                 }
                         
             // Line B, PS2 user-scale setup
                             // line B pressure sensor 2
                 Beckhoff_B_PS2_mmt = 0.0;                // reset measurement
                 Beckhoff_B_PS2_immt = 0;                // reset integer raw measurement
                 PS_Beckhoff_CalPt_Idx = 0;                // reset calibration point index counter
                 PS_Beckhoff_CalPt_Nr = 9;        // initial number of calibration points is 9
                 
                                     PS_Beckhoff_CalPt_Nr = PS_Beckhoff_CalPt_Nr + 2;
                                 PS_Beckhoff_error = EMFT_EL3054_Setup_UserScale( 3, 3, PS_Beckhoff_CalPt_Nr );    // setup PS_Beckhoff_CalPt_Nr calibration points
                 
                 if ( PS_Beckhoff_error != 0)    {        
                     Log_Error( 12, 1, -5 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //    -5 );    // exit with error code return
                 }
     
                 PS_Beckhoff_CalPt_Nr = 0;    // reset current calibration point number
                 
                                     PS_Beckhoff_error = EMFT_EL3054_Set_UserScale_CalPt( 3, 3, PS_Beckhoff_CalPt_Nr, 2379, "hPa", -500 );    // enter calibration extension point
                     if ( PS_Beckhoff_error != 0)    {        
                         EMFT_EtherCAT_Disconnect();                
                         Log_Error( 12, 1, -6 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //    -6 );    // exit with error code return
                     }                
                     
                 
                 for ( PS_Beckhoff_CalPt_Idx = 0; PS_Beckhoff_CalPt_Idx < 9; PS_Beckhoff_CalPt_Idx = PS_Beckhoff_CalPt_Idx + 1 )    {
                     // scroll through all sensor calibration points
                     PS_Beckhoff_CalPt_Nr = PS_Beckhoff_CalPt_Nr + 1;    // increment current calibration point number
                     
                     EMFT_VSnPrintf( PS_Beckhoff_macro_name, "PS_BECKHOFF_B_PS2_CP%d_IN", PS_Beckhoff_CalPt_Idx );    // get calibration point input macro value
                     PS_Beckhoff_error = EMFT_GetMacroValue( PS_Beckhoff_macro_name, PS_Beckhoff_CalPt_In );        // obtain macro value - calibration point input
                     
                     EMFT_VSnPrintf( PS_Beckhoff_macro_name, "PS_BECKHOFF_B_PS2_CP%d_OUT", PS_Beckhoff_CalPt_Idx );    // get calibration point input macro value
                     PS_Beckhoff_error = EMFT_GetMacroValue( PS_Beckhoff_macro_name, PS_Beckhoff_CalPt_Out );        // obtain macro value - calibration point output
                     
                     PS_Beckhoff_error = EMFT_EL3054_Set_UserScale_CalPt( 3, 3, PS_Beckhoff_CalPt_Nr, PS_Beckhoff_CalPt_In, "hPa", PS_Beckhoff_CalPt_Out );    // enter calibration point
                     if ( PS_Beckhoff_error != 0)    {        
                         EMFT_EtherCAT_Disconnect();                
                         Log_Error( 12, 1, -6 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //    -6 );    // exit with error code return
                     }
                 
                 }
                 
                                     PS_Beckhoff_error = EMFT_EL3054_Set_UserScale_CalPt( 3, 3, PS_Beckhoff_CalPt_Nr + 1, 18722, "hPa", 3000 );    // enter calibration extension point
                     if ( PS_Beckhoff_error != 0)    {        
                         EMFT_EtherCAT_Disconnect();                
                         Log_Error( 12, 1, -6 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //    -6 );    // exit with error code return
                     }                
                     
                                 
                 // EMFT_Check_Exp_Date calculates the number of days left between the date in future and now. Input date is in string format "dd.mm.yyyy" e.g. "31.12.2018". A negative number of days is returned for already past dates
                 EL3054_days_to_calibration = EMFT_Check_Exp_Date( "01.01.2022" );
                 
                 if ( EL3054_days_to_calibration < 0 )    {
                     puts("Please recalibrate devices, connected to the EL3054 module.\nScript will now exit!\n(press 'p' to proceed)\n");    // notify user of failed calibration check status
                     emft_write_current_timestamp();    emft_write_string("\tCalibration date for devices, connected to the EL3054 module, has expired "); emft_write_var( -EL3054_days_to_calibration ); emft_write_string(" days ago!\r\n");        // log pressure sensor calibration date
                     Wait_On_User_Response('p');
                     Log_Error( 12, 1, -4 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //    -4 );    // exit with error code return
                 }
                 else    {
                     emft_write_current_timestamp();    emft_write_string("\tCalibration date for devices, connected to the EL3054 module, expires in "); emft_write_var( EL3054_days_to_calibration ); emft_write_string(" days!\r\n");        // log pressure sensor calibration date
                 }
                         
                 
         
                 
         
                         
         
                 
                     // EMFT_StripChart_Add_Plot function adds a plot to the stripchart control    
             // 0. parameter - number of points in the history buffer
             // 1. parameter - Y axis manual scaling mode minimum
             // 2. parameter - Y axis manual scaling mode maximum - depending on displayed quantity units and data type
             // 3. parameter - X axis (time axis) initial window width in seconds
             // 4. parameter - human-readable name of channel
             // 5. parameter - human-readable units of channel
             // 6. parameter - color: [0] = "RED", "GREEN", "BLUE" ,"CYAN", "MAGENTA", "YELLOW", "DARK RED" ,"DARK BLUE", "DARK GREEN", "DARK CYAN", "DARK MAGENTA", "DARK YELLOW", "LIGHT GRAY", "DARK GRAY", "BLACK", "WHITE", "FHG", "LIGHT BLUE"
             // 7. parameter - Y axis data type = "USHORT", "SHORT", "FLOAT", "DOUBLE" 
             // 8. parameter - Y axis, used to display the data = "LEFT", "RIGHT"
             PS_Beckhoff_error = EMFT_StripChart_Add_Plot(    100, 
                                                         -500, 
                                                         3000, 
                                                         10, 
                                                         "B_PS1", 
                                                         "hPa", "LIGHT BLUE", "FLOAT", "LEFT");
         
                     // EMFT_StripChart_Add_Plot function adds a plot to the stripchart control    
             // 0. parameter - number of points in the history buffer
             // 1. parameter - Y axis manual scaling mode minimum
             // 2. parameter - Y axis manual scaling mode maximum - depending on displayed quantity units and data type
             // 3. parameter - X axis (time axis) initial window width in seconds
             // 4. parameter - human-readable name of channel
             // 5. parameter - human-readable units of channel
             // 6. parameter - color: [0] = "RED", "GREEN", "BLUE" ,"CYAN", "MAGENTA", "YELLOW", "DARK RED" ,"DARK BLUE", "DARK GREEN", "DARK CYAN", "DARK MAGENTA", "DARK YELLOW", "LIGHT GRAY", "DARK GRAY", "BLACK", "WHITE", "FHG", "LIGHT BLUE"
             // 7. parameter - Y axis data type = "USHORT", "SHORT", "FLOAT", "DOUBLE" 
             // 8. parameter - Y axis, used to display the data = "LEFT", "RIGHT"
             PS_Beckhoff_error = EMFT_StripChart_Add_Plot(    100, 
                                                         -500, 
                                                         3000, 
                                                         10, 
                                                         "B_PS2", 
                                                         "hPa", "FHG", "FLOAT", "LEFT");
                 
         
         return ( 0 );
     }
         
     int PS_Beckhoff_GetStableRawValue( int EL3054_module_nr, int EL3054_ch_nr )    
     {
         int        PS_Beckhoff_error;
         float     t_start, t_now, delta_t;        
         int     EL3054_IsRawReadoutStable;
                             
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 12, 1, -10 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         PS_Beckhoff_error = EMFT_EL3054_Config_Raw_Stability( EL3054_module_nr, EL3054_ch_nr, 10,    100 );
         
         EL3054_IsRawReadoutStable = 0;    // reset stability criterion            
         t_start = EMFT_Get_TimeStamp();    // store stabilization loop start time
         do    {            
 
             EL3054_raw_value = EMFT_EL3054_GetRawCh( EL3054_module_nr, EL3054_ch_nr );    // get a value and store in stability buffer
 
             EL3054_IsRawReadoutStable = EMFT_EL3054_IsRawReadoutStable( EL3054_module_nr, EL3054_ch_nr );
 
             t_now = EMFT_Get_TimeStamp();    // store stabilization loop current time
             
             delta_t = t_now - t_start;        // check elapsed time against stabilization timeout in ms
             
         } while ( ( ( EL3054_IsRawReadoutStable == 0 ) && ( delta_t < 50000 ) ) && (Signal_goto_safe_state == 0) );            
 
                 
                 
                 
                                 
         if ( delta_t >= 50000 )    {                        
             puts( "EL3054 stabilization timeout!\n" );    // signal the timeout error to the user
             return (-1);    // return error code
         }
         else {
             return ( 0 );    // exit with success code return
         };
         
     }
 
     int PS_Beckhoff_GetValue( int EL3054_module_nr, int EL3054_ch_nr )
     {                        
                             
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 12, 1, -10 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         EL3054_ch_value = EMFT_EL3054_GetCh( EL3054_module_nr, EL3054_ch_nr );    // get a value and store in stability buffer
         
         // assign the readout to target sensor readout
         if ( EL3054_module_nr == 3 )    {
             // module A was selected
             
                     }
         
         if ( EL3054_module_nr == 3 )    {
             // module B was selected
             
                 if ( EL3054_ch_nr == 2 )    {                
                     Beckhoff_B_PS1_mmt = EL3054_ch_value;    // assign readout to line B, pressure sensor 1
                     
                         EMFT_StripChart_Add_Point( "B_PS1", EL3054_ch_value);    // add a point to plot of EL3054 channel value vs. time                                    
                                     }
                         
             
                 if ( EL3054_ch_nr == 3 )    {                
                     Beckhoff_B_PS2_mmt = EL3054_ch_value;    // assign readout to line B, pressure sensor 2
                     
                         EMFT_StripChart_Add_Point( "B_PS2", EL3054_ch_value);    // add a point to plot of EL3054 channel value vs. time                                    
                                     }
                     }        
         return ( EL3054_ch_value );
     }
     
     int PS_Beckhoff_GetStableValue( int EL3054_module_nr, int EL3054_ch_nr )
     {        
         float     t_start, t_now, delta_t;        
         int     EL3054_IsReadoutStable;
         float     EL3054_ch_value;
                             
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 12, 1, -10 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         if ( EL3054_module_nr == 3 )    {
                                 }
         
         if ( EL3054_module_nr == 3 )    {
                             PS_Beckhoff_error = EMFT_EL3054_Config_Stability( EL3054_module_nr, EL3054_ch_nr, 10, 5 );
                                         PS_Beckhoff_error = EMFT_EL3054_Config_Stability( EL3054_module_nr, EL3054_ch_nr, 10, 5 );
                     }
 
         EL3054_IsReadoutStable = 0;    // reset stability criterion            
         t_start = EMFT_Get_TimeStamp();    // store stabilization loop start time
         do    {            
         
             EL3054_ch_value = EMFT_EL3054_GetCh( EL3054_module_nr, EL3054_ch_nr );    // get a value and store in stability buffer
                     
             EL3054_IsReadoutStable = EMFT_EL3054_IsReadoutStable( EL3054_module_nr, EL3054_ch_nr );
 
             t_now = EMFT_Get_TimeStamp();    // store stabilization loop current time
             
             delta_t = t_now - t_start;        // check elapsed time against stabilization timeout in ms
             
         } while ( ( ( EL3054_IsReadoutStable == 0 ) && ( delta_t < 50000 ) ) && (Signal_goto_safe_state == 0) );            
     
         // assign the readout to target sensor readout
         if ( EL3054_module_nr == 3 )    {
             // module A was selected
             
                     }
         
         if ( EL3054_module_nr == 3 )    {
             // module B was selected
             
                 if ( EL3054_ch_nr == 2 )    {                
                     Beckhoff_B_PS1_mmt = EL3054_ch_value;    // assign readout to line B, pressure sensor 1
                                             EMFT_StripChart_Add_Point( "B_PS1", EL3054_ch_value);    // add a point to plot of EL3054 channel value vs. time                                    
                                     }
                         
             
                 if ( EL3054_ch_nr == 3 )    {                
                     Beckhoff_B_PS2_mmt = EL3054_ch_value;    // assign readout to line B, pressure sensor 2
                     
                         EMFT_StripChart_Add_Point( "B_PS2", EL3054_ch_value);    // add a point to plot of EL3054 channel value vs. time            
                                     }
                     }        
                 
         if ( delta_t >= 50000 )    {                        
             puts( "EL3054 stabilization timeout!\n" );    // signal the timeout error to the user
             return (-1);    // return error code
         }
         else {
             return ( 0 );    // exit with success code return
         };
         
     }
 
     int PS_Beckhoff_Add_to_LogMmtRow()
     
                 
                 
                     // Beckhoff pressure sensor 1 on Line B has to be logged
             emft_write_string("\t"); emft_write_var( Beckhoff_B_PS1_mmt );
             emft_write_string("\t"); emft_write_var( Beckhoff_B_PS1_immt);
         
                 
                     // Beckhoff pressure sensor 2 on Line B has to be logged
             emft_write_string("\t"); emft_write_var( Beckhoff_B_PS2_mmt );
             emft_write_string("\t"); emft_write_var( Beckhoff_B_PS2_immt);
         
                 
         
         return ( 0 );    
     
     }
 
     int PS_Beckhoff_Add_to_LogMmtHeaderRow()
     {
                 
                 
                     // Beckhoff pressure sensor 1 on Line B has to be logged
             EMFT_VSnPrintf( Log_Header_params, "%s\t%s\t%s_RAW", Log_Header_params, "B_PS1", "B_PS1");
             EMFT_VSnPrintf( Log_Header_units, "%s\t[%s]\t[]", Log_Header_units,"hPa");
 
                 
                     // Beckhoff pressure sensor 2 on Line B has to be logged
             EMFT_VSnPrintf( Log_Header_params, "%s\t%s\t%s_RAW", Log_Header_params, "B_PS2", "B_PS2");
             EMFT_VSnPrintf( Log_Header_units, "%s\t[%s]\t[]", Log_Header_units,"hPa");
 
                 
                 
         return ( 0 );    
     }
 
     int PS_Beckhoff_Add_to_SQL()
     {
                 
                 
                     EMFT_VSnPrintf( sql_query_params, "%s, %s, %s_RAW", sql_query_params,"B_PS1", "B_PS1");
             EMFT_VSnPrintf( sql_query_values, "%s, %f, %i", sql_query_values, Beckhoff_B_PS1_mmt, Beckhoff_B_PS1_immt);
 
                 
                     EMFT_VSnPrintf( sql_query_params, "%s, %s, %s_RAW", sql_query_params,"B_PS2", PS_BECKHOFF_A_PS1_NAME);
             EMFT_VSnPrintf( sql_query_values, "%s, %f, %i", sql_query_values, Beckhoff_B_PS2_mmt, Beckhoff_B_PS2_immt);
 
                 
         
         return ( 0 );    
     }
 
 
         /*Pressure controller Mensor CPC3000 (PCS 400M)(0 - 500 hPa) library for use with LittleC */
 
     
         
     // this symbol denotes, that a CPC3000 library was already included
     // this symbol defines the version of the CPC3000 library
     
     
     
     
     // Pressure_Controller1_Stop function parameter - controller will go to standby without ventilation
     // Pressure_Controller1_Stop function parameter - controller will go to ventilation
     
     char CPC3000_SerialNr[50];    // serial number string
     
     
     
     
     
         // "PC-L109-08" computer was selected as a measurement station        
                     //    CPC 3000 is device 1
             // if user did not specify another communication mode, set default mode
                 //    define this symbol to use pressure controller 1 communication TCP: 1 or GPIB: 2
                         
             
                             // VISA style, GPIB communication controller and device address. Example GPIB1::27::INSTR - controller 1, device addr. 27.
                 // does not have any meaning in GPIB communication mode
                 // 1 second GPIB communication timeout.  Valid entries: 0 =Infinite, 1=10 us, 2=30 us,    3=100 us,    4=300 us,    5=1 ms,    6=3 ms,    7=10 ms, 8=30 ms, 9=100 ms, 10=300 ms, 11=1 s, 12=3 s, 13=10 s,    14=30 s, 15=100 s, 16=300 s, 17=1000 s
                         
             // human-readable name for identifying the Mensor CPC3000 controller
             // human-readable name for identifying the pressure output quantity, used for logging and plotting
             // maximum pressure controller output pressure in CPC3000_UNITS_STRING
             // minimum pressure controller output pressure in CPC3000_UNITS_STRING
             // allowed stabilization time in ms, before timeout is signaled and controller is turned to sensor mode            
             // stability buffer size
             // stability limit standard deviation value            
                 
                         
         
                     //    CPC 3000 is device 2
             // if user did not specify another communication mode, set default mode
                 //    define this symbol to use pressure controller 1 communication TCP: 1 or GPIB: 2
                         
                         
                             // VISA style, GPIB communication controller and device address. Example GPIB1::27::INSTR - controller 1, device addr. 27.
                 // does not have any meaning in GPIB communication mode
                 // 1 second GPIB communication timeout.  Valid entries: 0 =Infinite, 1=10 us, 2=30 us,    3=100 us,    4=300 us,    5=1 ms,    6=3 ms,    7=10 ms, 8=30 ms, 9=100 ms, 10=300 ms, 11=1 s, 12=3 s, 13=10 s,    14=30 s, 15=100 s, 16=300 s, 17=1000 s
                         
             // human-readable name for identifying the Mensor CPC3000 controller
 
             // human-readable name for identifying the pressure output quantity, used for logging and plotting
             // maximum pressure controller output pressure in CPC3000_UNITS_STRING
             // minimum pressure controller output pressure in CPC3000_UNITS_STRING
             // allowed stabilization time in ms, before timeout is signaled and controller is turned to sensor mode            
             // stability buffer size
             // stability limit standard deviation value            
                 
                         
                 
     
         
     
     //    pounds per square inch
     //    inches of mercury @ 0 C 
     //    inches of mercury @ 60 F 
     //    inches of water @ 4 C 
     //    inches of water @ 20 C 
     //    inches of water @ 60 F 
     //    feet of water @ 4 C 
     //    feet of water @ 20 C 
     //    feet of water @ 60 F 
     //    millitorr 
     //    inches of seawater @ 0 C 
     //    feet of seawater @ 0 C 
     //    atmospheres 
     //    bars 
     //    millibars 
     //    millimeters of water @ 4 C 
     //    centimeters of water @ 4 C 
     //    meters of water @ 4 C
     //    millimeters of mercury @ 0 C 
     //    centimeters of mercury @ 0 C 
     //    torr 
     //    kilopascals 
     //    pascals 
     //    dyne per square centimeter 
     //    grams per square centimeter 
     //    kilograms per square centimeter 
     //    meters of seawater @ 0 C 3.5 % 
     //    ounce per square inch 
     //    pounds per square foot 
     //    tons per square foot 
     //    percent of full scale % 
     //    micron HG @ 0 C 
     //    ton per square inch 
     //    hectopascals 
     //    megapascals 
     //    millimeters of water @ 20 C 
     //    centimeter of water @ 20 C 
     //    meters of water @ 20 C
 
     //    pounds per square inch
     //    inches of mercury @ 0 C 
     //    inches of mercury @ 60 F 
     //    inches of water @ 4 C 
     //    inches of water @ 20 C 
     //    inches of water @ 60 F 
     //    feet of water @ 4 C 
     //    feet of water @ 20 C 
     //    feet of water @ 60 F 
     //    millitorr 
     //    inches of seawater @ 0 C 
     //    feet of seawater @ 0 C 
     //    atmospheres 
     //    bars 
     //    millibars 
     //    millimeters of water @ 4 C 
     //    centimeters of water @ 4 C 
     //    meters of water @ 4 C
     //    millimeters of mercury @ 0 C 
     //    centimeters of mercury @ 0 C 
     //    torr 
     //    kilopascals 
     //    pascals 
     //    dyne per square centimeter 
     //    grams per square centimeter 
     //    kilograms per square centimeter 
     //    meters of seawater @ 0 C 3.5 % 
     //    ounce per square inch 
     //    pounds per square foot 
     //    tons per square foot 
     //    percent of full scale % 
     //    micron HG @ 0 C 
     //    ton per square inch 
     //    hectopascals 
     //    megapascals 
     //    millimeters of water @ 20 C 
     //    centimeter of water @ 20 C 
     //    meters of water @ 20 C
 
     
         //    CPC 3000 is device 1
                     // Pressure stripchart plot history length
             // Pressure stripchart time axis default width in seconds
             
                             // Pressure stripchart plot Y axis minimum value for pressure (use integer value)
                         
                             // Pressure stripchart plot Y axis maximum value for pressure (use integer value)
                         
                     
         // Definition of human-readable name based on measurement type
                 
                 
                 
                 
                 
                 
                 
                 
                 
         
                 
     
                     
                 
                             
         // Possible pressure controller unit string values:
         //    "psi", 
         //    "inHg 0 \260C", "inHg 60 \260F", 
         //    "inH2O 4 \260C", "inH2O 20 \260C", "inH2O 60 \260F", 
         //    "ftH2O 4 \260C", "ftH2O 20 \260C", "ftH2O 60 \260F", 
         //    "mTorr", "3.5 % salinity inch sea water", "3.5 % salinity feet sea water", 
         //    "atm", "bar", "mbar", 
         //    "mmH2O 4 \260C", "cmH2O 4 \260C", "mH2O 4 \260C", 
         //    "mmHg 0 \260C", "cmHg 0 \260C", 
         //    "Torr", "kPa", "PA", "dy/cm2", "gm/cm2", "kg/cm2", 
         //    "salinity meters of sea water", "OSI", "PSF", "TSF", "FS", 
         //    "uHg 0 \260C", "tsi", "hPa", "MPa", 
         //    "mmH2O 20 \260C", "cmH2O 20 \260C", "mH2O 20 \260C"
             
         
             // default pressure controller units are hPa
             
                     
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                     
                 
                 
                 
                 
                 
         
             //    CPC 3000 is device 2
                     // Pressure stripchart plot history length
             // Pressure stripchart time axis default width in seconds
             
                             // Pressure stripchart plot Y axis minimum value for pressure (use integer value)
                         
                             // Pressure stripchart plot Y axis maximum value for pressure (use integer value)
                         
         
         // Definition of human-readable name based on measurement type
                 
                 
                 
                 
                 
                 
                 
                 
                 
         
                 
     
                 
         
                 
                 
         // Possible pressure controller unit string values:
         //    "psi", 
         //    "inHg 0 \260C", "inHg 60 \260F", 
         //    "inH2O 4 \260C", "inH2O 20 \260C", "inH2O 60 \260F", 
         //    "ftH2O 4 \260C", "ftH2O 20 \260C", "ftH2O 60 \260F", 
         //    "mTorr", "3.5 % salinity inch sea water", "3.5 % salinity feet sea water", 
         //    "atm", "bar", "mbar", 
         //    "mmH2O 4 \260C", "cmH2O 4 \260C", "mH2O 4 \260C", 
         //    "mmHg 0 \260C", "cmHg 0 \260C", 
         //    "Torr", "kPa", "PA", "dy/cm2", "gm/cm2", "kg/cm2", 
         //    "salinity meters of sea water", "OSI", "PSF", "TSF", "FS", 
         //    "uHg 0 \260C", "tsi", "hPa", "MPa", 
         //    "mmH2O 20 \260C", "cmH2O 20 \260C", "mH2O 20 \260C"
             
         
             // default pressure controller units are hPa
             
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                 
                     
                 
                 
                 
                 
                 
             
 
     // Error section CPC3000
     
     
     
         
         
     
         
         
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
 
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     int Pressure_Controller1_Setup()    
     {        
         int        CPC3000_error;
                     
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 3, 1, -13 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }
             
             // CPC3000 device 1            
             int        CPC3000_days_to_calibration;
             /*    EMFT_CPC3000_Connect function parameter description:
                 1. parameter - Mensor CPC3000 IP address        
                 2. parameter - port number
                 3. parameter - timeout in ms
                 4. parameter - Mensor CPC3000 controller name string
             */    
             CPC3000_error = EMFT_CPC3000_Connect("GPIB0::15::INSTR", 0, 11, "MENSOR810617");
             
                 if ( CPC3000_error != 0)    {
                     Log_Error( 3, 1, -1 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         /*    EMFT_CPC3000_Config_Stability function parameter description:
             1. parameter - Mensor CPC3000 controller name string        
             2. parameter - stability buffer size for specified pressure controller - stability buffer configuration is only relevant when NOT in controller mode (otherwise instrument stability flag is used)
             3. parameter - limit value of stability criterion - whenever buffer contents stanard deviation is within this limit (less or equal), the pressure is considered stable
             */        
             CPC3000_error = EMFT_CPC3000_Config_Stability( "MENSOR810617", 10, 1.0    );
             
                 if ( CPC3000_error != 0)    {
                     Log_Error( 3, 1, -2 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         /*    EMFT_CPC3000_GetSerialNr function parameter description:
                 1. parameter - Mensor CPC3000 controller name string
                 2. parameter - Global string variable, which receives the instrument serial number information
             */
             CPC3000_error = EMFT_CPC3000_GetSerialNr( "MENSOR810617", CPC3000_SerialNr);    // read instrument serial number
             
                 if ( CPC3000_error != 0)    {
                     Log_Error( 3, 1, -3 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         puts("CPC3000 DEV 1 serial number:\t"); print(CPC3000_SerialNr); puts("\n");    // refresh CPC3000_SerialNr variable
             
             //Standard is to go to ventilation mode and set setpoint to zero
             
             /*    EMFT_CPC3000_SetInstrumentMode function parameter description:
                 1. parameter - Mensor CPC3000 controller name string
                 2. parameter - Instrument mode letter: 
                 'C' or 'c' set the control mode, 'M' or 'm' set the measure mode, 'V' or 'v' set the vent mode, 'S' or 's' for standby mode
             */
             CPC3000_error = EMFT_CPC3000_SetInstrumentMode( "MENSOR810617", 'V');    // set instrument to measure mode
             
                 if ( CPC3000_error != 0)    {
                     Log_Error( 3, 1, -10 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         
             CPC3000_error = EMFT_CPC3000_SetPressure_SetPt( "MENSOR810617",  0.0);
             
                 if ( CPC3000_error != 0)    {
                     Log_Error( 3, 1, -4 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         
             /*    EMFT_CPC3000_SetActiveSensor function parameter description:
                 1. parameter - Mensor CPC3000 controller name string
                 2. parameter - active sensor channel letter (either 'P' or 'p' for primary sensor channel or 'S' or 's' for secondary sensor channel)
                 3. parameter - active turndown ( can be 1, 2, 3 or 4 )
             */
             CPC3000_error = EMFT_CPC3000_SetActiveSensor( "MENSOR810617", 'P', 1 );
             
                 if ( CPC3000_error != 0)    {
                     Log_Error( 3, 1, -5 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         /*    EMFT_CPC3000_Cal_Status function parameter description:
                 1. parameter - Mensor CPC3000 controller name string
                 returns the days until calibration. If the calibration is already due, the number is negative, representing the number of days since calibration was due
                 NOTE: Active sensor has to be selected first - use EMFT_CPC3000_SetActiveSensor
             */
             CPC3000_days_to_calibration = EMFT_CPC3000_Cal_Status( "MENSOR810617" );
             
                 if ( CPC3000_days_to_calibration < 0 )    {
                     puts("Please recalibrate pressure controller!\n(press 'p' to proceed)\n");    // notify user of failed calibration check status
                     Wait_On_User_Response('p');        
                     Log_Error( 3, 1, -6 );    // log the error onto console and into log file (if available)
                     // dont exit, only report to operator
                     // return ( lc_err_code_nr );        // exit with failure code return
                 }
                         /*    EMFT_CPC3000_SetUnits function parameter description:    
                 1. parameter - Mensor CPC3000 controller name string        
                 2. parameter - Pressure units code according to the definition table above
                 NOTE: Active sensor has to be selected first - use EMFT_CPC3000_SetActiveSensor        
             */    
             CPC3000_error = EMFT_CPC3000_SetUnits( "MENSOR810617",  35 );
             
                 if ( CPC3000_error != 0)    {
                     Log_Error( 3, 1, -7 );    // log the error onto console and into log file (if available)            
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         
                             // EMFT_StripChart_Add_Plot function adds a plot to the stripchart control    
                 // 0. parameter - number of points in the history buffer
                 // 1. parameter - Y axis manual scaling mode minimum
                 // 2. parameter - Y axis manual scaling mode maximum - depending on displayed quantity units and data type
                 // 3. parameter - X axis (time axis) initial window width in seconds
                 // 4. parameter - human-readable name of channel
                 // 5. parameter - human-readable units of channel
                 // 6. parameter - color: [0] = "RED", "GREEN", "BLUE" ,"CYAN", "MAGENTA", "YELLOW", "DARK RED" ,"DARK BLUE", "DARK GREEN", "DARK CYAN", "DARK MAGENTA", "DARK YELLOW", "LIGHT GRAY", "DARK GRAY", "BLACK", "WHITE", "FHG", "LIGHT BLUE"
                 // 7. parameter - Y axis data type = "USHORT", "SHORT", "FLOAT", "DOUBLE" 
                 // 8. parameter - Y axis, used to display the data = "LEFT", "RIGHT"
                 CPC3000_error = EMFT_StripChart_Add_Plot(    100, 
                                                             0.0, 
                                                             500.0, 
                                                             10, 
                                                             "P_OUTLET", 
                                                             "hPa", "DARK MAGENTA", "DOUBLE", "LEFT");
                             return ( 0 );        // exit with success code return
     }
     int Pressure_Controller2_Setup()    
     {        
         int        CPC3000_error;        
                     
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip pressure setting
                 Log_Error( 3, 2, -13 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }
             
             // CPC3000 device 2        
             int        CPC3000_days_to_calibration;
             /*    EMFT_CPC3000_Connect function parameter description:
                 1. parameter - Mensor CPC3000 IP address        
                 2. parameter - port number
                 3. parameter - timeout in ms
                 4. parameter - Mensor CPC3000 controller name string
             */    
             CPC3000_error = EMFT_CPC3000_Connect("GPIB0::16::INSTR", 0, 11, "MENSOR810615");
             
                 if ( CPC3000_error != 0)    {            
                     Log_Error( 3, 2, -1 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         
             /*    EMFT_CPC3000_Config_Stability function parameter description:
             1. parameter - Mensor CPC3000 controller name string        
             2. parameter - stability buffer size for specified pressure controller - stability buffer configuration is only relevant when NOT in controller mode (otherwise instrument stability flag is used)
             3. parameter - limit value of stability criterion - whenever buffer contents stanard deviation is within this limit (less or equal), the pressure is considered stable
             */        
             CPC3000_error = EMFT_CPC3000_Config_Stability( "MENSOR810615", 10, 1.0    );
             
                 if ( CPC3000_error != 0)    {
                     Log_Error( 3, 2, -2 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         
             /*    EMFT_CPC3000_GetSerialNr function parameter description:
                 1. parameter - Mensor CPC3000 controller name string
                 2. parameter - Global string variable, which receives the instrument serial number information
             */
             CPC3000_error = EMFT_CPC3000_GetSerialNr( "MENSOR810615", CPC3000_SerialNr);    // read instrument serial number
             
                 if ( CPC3000_error != 0)    {
                     Log_Error( 3, 2, -3 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         
             puts("CPC3000 DEV 2 serial number:\t"); print(CPC3000_SerialNr); puts("\n");    // refresh CPC3000_SerialNr variable
             
             
             //Standard is to go to ventilation mode and set setpoint to zero
             /*    EMFT_CPC3000_SetInstrumentMode function parameter description:
                 1. parameter - Mensor CPC3000 controller name string
                 2. parameter - Instrument mode letter: 
                 'C' or 'c' set the control mode, 'M' or 'm' set the measure mode, 'V' or 'v' set the vent mode, 'S' or 's' for standby mode
             */
             CPC3000_error = EMFT_CPC3000_SetInstrumentMode( "MENSOR810615", 'V');    // set instrument to ventilation mode
             
                 if ( CPC3000_error != 0)    {
                     Log_Error( 3, 2, -10 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         
             CPC3000_error = EMFT_CPC3000_SetPressure_SetPt( "MENSOR810615",  0.0);
             
                 if ( CPC3000_error != 0)    {
                     Log_Error( 3, 2, -4 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         /*    EMFT_CPC3000_SetActiveSensor function parameter description:
                 1. parameter - Mensor CPC3000 controller name string
                 2. parameter - active sensor channel letter (either 'P' or 'p' for primary sensor channel or 'S' or 's' for secondary sensor channel)
                 3. parameter - active turndown ( can be 1, 2, 3 or 4 )
             */
             CPC3000_error = EMFT_CPC3000_SetActiveSensor( "MENSOR810615", 'P', 1 );
             
                 if ( CPC3000_error != 0)    {
                     Log_Error( 3, 2, -5 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         
             /*    EMFT_CPC3000_Cal_Status function parameter description:
                 1. parameter - Mensor CPC3000 controller name string
                 returns the days until calibration. If the calibration is already due, the number is negative, representing the number of days since calibration was due
                 NOTE: Active sensor has to be selected first - use EMFT_CPC3000_SetActiveSensor
             */
             CPC3000_days_to_calibration = EMFT_CPC3000_Cal_Status( "MENSOR810615" );
             
                 if ( CPC3000_days_to_calibration < 0 )    {
                     puts("Please recalibrate pressure controller!\n(press 'p' to proceed)\n");    // notify user of failed calibration check status
                     Wait_On_User_Response('p');        
                     Log_Error( 3, 2, -6 );    // log the error onto console and into log file (if available)
                     // dont exit, only report to operator
                     // return ( lc_err_code_nr );        // exit with failure code return
                 }
                         
             /*    EMFT_CPC3000_SetUnits function parameter description:    
                 1. parameter - Mensor CPC3000 controller name string        
                 2. parameter - Pressure units code according to the definition table above
                 NOTE: Active sensor has to be selected first - use EMFT_CPC3000_SetActiveSensor        
             */    
             CPC3000_error = EMFT_CPC3000_SetUnits( "MENSOR810615",  35 );
             
                 if ( CPC3000_error != 0)    {
                     Log_Error( 3, 2, -7 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         
                             // EMFT_StripChart_Add_Plot function adds a plot to the stripchart control    
                 // 0. parameter - number of points in the history buffer
                 // 1. parameter - Y axis manual scaling mode minimum
                 // 2. parameter - Y axis manual scaling mode maximum - depending on displayed quantity units and data type
                 // 3. parameter - X axis (time axis) initial window width in seconds
                 // 4. parameter - human-readable name of channel
                 // 5. parameter - human-readable units of channel
                 // 6. parameter - color: [0] = "RED", "GREEN", "BLUE" ,"CYAN", "MAGENTA", "YELLOW", "DARK RED" ,"DARK BLUE", "DARK GREEN", "DARK CYAN", "DARK MAGENTA", "DARK YELLOW", "LIGHT GRAY", "DARK GRAY", "BLACK", "WHITE", "FHG", "LIGHT BLUE"
                 // 7. parameter - Y axis data type = "USHORT", "SHORT", "FLOAT", "DOUBLE" 
                 // 8. parameter - Y axis, used to display the data = "LEFT", "RIGHT"
                 CPC3000_error = EMFT_StripChart_Add_Plot(    100, 
                                                             0.0, 
                                                             500.0, 
                                                             10, 
                                                             "P_INLET", 
                                                             "hPa", "DARK MAGENTA", "DOUBLE", "LEFT");
                             
         return ( 0 );        // exit with success code return
     }
 
     int Pressure_Controller1_SetPressure( double CPC3000_pressure_setpt )    
     {
                     int        CPC3000_error;    
             int     CPC3000_controller_pressure_stable;
             int     CPC3000_pressure_stable;    
             float     t_start, t_now, delta_t;
             
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip pressure setting
                 Log_Error( 3, 1, -13 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }
             
             //    EMFT_CPC3000_SetInstrumentMode function parameter description:
             //    1. parameter - Mensor CPC3000 controller name string
             //    2. parameter - Instrument mode letter: 
             //    'C' or 'c' set the control mode, 'M' or 'm' set the measure mode, 'V' or 'v' set the vent mode, 'S' or 's' for standby mode
             CPC3000_error = EMFT_CPC3000_SetInstrumentMode( "MENSOR810617", 'C');    // set instrument to controller mode        
             
             if ( CPC3000_error != 0)    {
                 Log_Error( 3, 1, -4 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }
                         
             CPC3000_error = EMFT_CPC3000_Config_Stability( "MENSOR810617", 10, 1.0    );
             
                 if ( CPC3000_error != 0)    {
                     Log_Error( 3, 1, -2 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         
             //    EMFT_CPC3000_SetPressure_SetPt function parameter description:    
             //    1. parameter - Mensor CPC3000 controller name string        
             //    2. parameter - Pressure value in user defined units
             //    NOTE: Active sensor has to be selected first - use EMFT_CPC3000_SetActiveSensor
             //    Also note, that user has to set the units prior to setting the pressure!
 
             CPC3000_error = EMFT_CPC3000_SetPressure_SetPt( "MENSOR810617",  CPC3000_pressure_setpt);
             
                 if ( CPC3000_error != 0)    {                
                     Log_Error( 3, 1, -8 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         
             CPC3000_pressure_stable = 0;    // reset stability condition
             CPC3000_controller_pressure_stable = 0;     // reset stability condition
             
             t_start = EMFT_Get_TimeStamp();    // store stabilization loop start time
             
             do {
 
                 //    EMFT_CPC3000_IsControllerPressureStable function parameter description:    
                 //    Evaluates pressure controller stability flag, as parsed from controller response (stable or slewing) (TRUE/FALSE)
                 //    1. parameter - Mensor CPC3000 controller name string            
                 //    NOTE: Active sensor has to be selected first - use EMFT_CPC3000_SetActiveSensor    
                 CPC3000_controller_pressure_stable = EMFT_CPC3000_IsControllerPressureStable( "MENSOR810617" );        // check pressure setpoint stability while in controller mode
 
                 //    EMFT_CPC3000_IsPressureStable function parameter description:    
                 //    Stability response as evaluated from standard deviation of stability buffer readouts 
                 //    Until all buffer readouts aren't within stability std. dev., buffer is unstable.
                 //    1. parameter - Mensor CPC3000 controller name string
                 //    NOTE: Active sensor has to be selected first - use EMFT_CPC3000_SetActiveSensor    
         
                 CPC3000_pressure_stable = EMFT_CPC3000_IsPressureStable( "MENSOR810617" );        // check pressure readout stability while in controller mode
                 
                 t_now = EMFT_Get_TimeStamp();    // store stabilization loop current time
                 
                 delta_t = t_now - t_start;        // check elapsed time against stabilization timeout in ms
                 
             } while ( ( ( (CPC3000_pressure_stable == 0) || (CPC3000_controller_pressure_stable == 0) ) && ( delta_t < 120000.0 ) ) && (Signal_goto_safe_state == 0) );    
             // pressure is stable, whenever controller says 'STABLE' and the stability buffer is stable and the timeout has not occured
                     
                             EMFT_StripChart_Add_Point( "P_OUTLET", CPC3000_pressure_setpt);    // add a point to plot of pressure vs. time            
                         
             if ( delta_t >= 120000.0 )    {            
                 Pressure_Controller1_Stop();        // there is probably a leak in the pressure line - turn off the controller
                 puts( "Pressure stabilization timeout, due to probable pressure leak. Mensor CPC3000 pressure controller was set to sensor mode!\n" );    // signal the timeout error to the user
                 Log_Error( 3, 1, -9 );    // log the error onto console and into log file (if available)                
                 return ( lc_err_code_nr );    // return error code
             }
                 return ( 0 );    // exit with success code return
     }
 
     int Pressure_Controller2_SetPressure( double CPC3000_pressure_setpt )    
     {        
                     int        CPC3000_error;    
             int     CPC3000_controller_pressure_stable;
             int     CPC3000_pressure_stable;    
             float     t_start, t_now, delta_t;
             
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip pressure setting
                 Log_Error( 3, 2, -13 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }
             
             //    EMFT_CPC3000_SetInstrumentMode function parameter description:
             //    1. parameter - Mensor CPC3000 controller name string
             //    2. parameter - Instrument mode letter: 
             //    'C' or 'c' set the control mode, 'M' or 'm' set the measure mode, 'V' or 'v' set the vent mode, 'S' or 's' for standby mode
             CPC3000_error = EMFT_CPC3000_SetInstrumentMode( "MENSOR810615", 'C');    // set instrument to controller mode        
             
                 if ( CPC3000_error != 0)    {                
                     Log_Error( 3, 2, -4 );    // log the error onto console and into log file (if available)                
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         
             CPC3000_error = EMFT_CPC3000_Config_Stability( "MENSOR810615", 10, 1.0    );
             
                 if ( CPC3000_error != 0)    {            
                     Log_Error( 3, 2, -2 );    // log the error onto console and into log file (if available)                
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         //    EMFT_CPC3000_SetPressure_SetPt function parameter description:    
             //    1. parameter - Mensor CPC3000 controller name string        
             //    2. parameter - Pressure value in user defined units
             //    NOTE: Active sensor has to be selected first - use EMFT_CPC3000_SetActiveSensor
             //    Also note, that user has to set the units prior to setting the pressure!
 
             CPC3000_error = EMFT_CPC3000_SetPressure_SetPt( "MENSOR810615",  CPC3000_pressure_setpt);
             
                 if ( CPC3000_error != 0)    {
                     Log_Error( 3, 2, -8 );    // log the error onto console and into log file (if available)                
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                         
             CPC3000_pressure_stable = 0;    // reset stability condition
             CPC3000_controller_pressure_stable = 0;     // reset stability condition
             
             t_start = EMFT_Get_TimeStamp();    // store stabilization loop start time
             
             do {
 
                 //    EMFT_CPC3000_IsControllerPressureStable function parameter description:    
                 //    Evaluates pressure controller stability flag, as parsed from controller response (stable or slewing) (TRUE/FALSE)
                 //    1. parameter - Mensor CPC3000 controller name string            
                 //    NOTE: Active sensor has to be selected first - use EMFT_CPC3000_SetActiveSensor    
                 CPC3000_controller_pressure_stable = EMFT_CPC3000_IsControllerPressureStable( "MENSOR810615" );        // check pressure setpoint stability while in controller mode
 
                 //    EMFT_CPC3000_IsPressureStable function parameter description:    
                 //    Stability response as evaluated from standard deviation of stability buffer readouts 
                 //    Until all buffer readouts aren't within stability std. dev., buffer is unstable.
                 //    1. parameter - Mensor CPC3000 controller name string
                 //    NOTE: Active sensor has to be selected first - use EMFT_CPC3000_SetActiveSensor    
         
                 CPC3000_pressure_stable = EMFT_CPC3000_IsPressureStable( "MENSOR810615" );        // check pressure readout stability while in controller mode
                 
                 t_now = EMFT_Get_TimeStamp();    // store stabilization loop current time
                 
                 delta_t = t_now - t_start;        // check elapsed time against stabilization timeout in ms
                 
             } while ( ( ( (CPC3000_pressure_stable == 0) || (CPC3000_controller_pressure_stable == 0) ) && ( delta_t < 120000.0 ) ) && (Signal_goto_safe_state == 0) );    
             // pressure is stable, whenever controller says 'STABLE' and the stability buffer is stable and the timeout has not occured
                     
                             EMFT_StripChart_Add_Point( "P_INLET", CPC3000_pressure_setpt);    // add a point to plot of pressure vs. time            
                         
             if ( delta_t >= 120000.0 )    {            
                 Pressure_Controller2_Stop();        // there is probably a leak in the pressure line - turn off the controller
                 puts( "Pressure stabilization timeout, due to probable pressure leak. Mensor CPC3000 pressure controller was set to sensor mode!\n" );    // signal the timeout error to the user
                 Log_Error( 3, 2, -9 );    // log the error onto console and into log file (if available)                
                 return ( lc_err_code_nr );    // return error code
             }
                 return ( 0 );    // exit with success code return
     }
 
 
     int Pressure_Controller12_SetPressure( double CPC3000_pressure_setpt1, double CPC3000_pressure_setpt2 )    
     {
                                     int        CPC3000_error;    
                 float     t_start, t_now, delta_t;
 
                 int     CPC3000_controller1_pressure_stable;
                 int     CPC3000_pressure1_stable;    
                 int     CPC3000_controller2_pressure_stable;
                 int     CPC3000_pressure2_stable;    
                 int        all_stable;
 
                 if (Signal_goto_safe_state != 0 )    {
                     // user interrupted the script execution - entirely skip pressure setting
                     Log_Error( 3, 1, -13 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                 
                                 
                 //    EMFT_CPC3000_SetPressure_SetPt function parameter description:    
                 //    1. parameter - Mensor CPC3000 controller name string        
                 //    2. parameter - Pressure value in user defined units
                 //    NOTE: Active sensor has to be selected first - use EMFT_CPC3000_SetActiveSensor
                 //    Also note, that user has to set the units prior to setting the pressure!
                 CPC3000_error = EMFT_CPC3000_SetPressure_SetPt( "MENSOR810617",  CPC3000_pressure_setpt1);
 
                 
                     if ( CPC3000_error != 0)    {                
                         Log_Error( 3, 1, -8 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );    // exit with error code return
                     }
                 
                 //    EMFT_CPC3000_SetInstrumentMode function parameter description:
                 //    1. parameter - Mensor CPC3000 controller name string
                 //    2. parameter - Instrument mode letter: 
                 //    'C' or 'c' set the control mode, 'M' or 'm' set the measure mode, 'V' or 'v' set the vent mode, 'S' or 's' for standby mode
                 CPC3000_error = EMFT_CPC3000_SetInstrumentMode( "MENSOR810617", 'C');    // set instrument to controller mode        
                 
                 if ( CPC3000_error != 0)    {
                     Log_Error( 3, 1, -4 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );    // exit with error code return
                 }
                                 
                 CPC3000_error = EMFT_CPC3000_Config_Stability( "MENSOR810617", 10, 1.0    );
                 
                     if ( CPC3000_error != 0)    {
                         Log_Error( 3, 1, -2 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );    // exit with error code return
                     }
                                     
                 //    EMFT_CPC3000_SetPressure_SetPt function parameter description:    
                 //    1. parameter - Mensor CPC3000 controller name string        
                 //    2. parameter - Pressure value in user defined units
                 //    NOTE: Active sensor has to be selected first - use EMFT_CPC3000_SetActiveSensor
                 //    Also note, that user has to set the units prior to setting the pressure!
 
                 CPC3000_error = EMFT_CPC3000_SetPressure_SetPt( "MENSOR810615",  CPC3000_pressure_setpt2);
                 
                     if ( CPC3000_error != 0)    {
                         Log_Error( 3, 2, -8 );    // log the error onto console and into log file (if available)                
                         return ( lc_err_code_nr );    // exit with error code return
                     }
                 
                 //    EMFT_CPC3000_SetInstrumentMode function parameter description:
                 //    1. parameter - Mensor CPC3000 controller name string
                 //    2. parameter - Instrument mode letter: 
                 //    'C' or 'c' set the control mode, 'M' or 'm' set the measure mode, 'V' or 'v' set the vent mode, 'S' or 's' for standby mode
                 CPC3000_error = EMFT_CPC3000_SetInstrumentMode( "MENSOR810615", 'C');    // set instrument to controller mode        
                 
                     if ( CPC3000_error != 0)    {                
                         Log_Error( 3, 2, -4 );    // log the error onto console and into log file (if available)                
                         return ( lc_err_code_nr );    // exit with error code return
                     }
                                 
                 CPC3000_error = EMFT_CPC3000_Config_Stability( "MENSOR810615", 10, 1.0    );
                 
                     if ( CPC3000_error != 0)    {            
                         Log_Error( 3, 2, -2 );    // log the error onto console and into log file (if available)                
                         return ( lc_err_code_nr );    // exit with error code return
                     }
                 
                 CPC3000_pressure1_stable = 0;    // reset stability condition
                 CPC3000_controller1_pressure_stable = 0;     // reset stability condition
                 CPC3000_pressure2_stable = 0;    // reset stability condition
                 CPC3000_controller2_pressure_stable = 0;     // reset stability condition
         
         
                 t_start = EMFT_Get_TimeStamp();    // store stabilization loop start time
             
                 do {
 
                     //    EMFT_CPC3000_IsControllerPressureStable function parameter description:    
                     //    Evaluates pressure controller stability flag, as parsed from controller response (stable or slewing) (TRUE/FALSE)
                     //    1. parameter - Mensor CPC3000 controller name string            
                     //    NOTE: Active sensor has to be selected first - use EMFT_CPC3000_SetActiveSensor    
                     CPC3000_controller1_pressure_stable = EMFT_CPC3000_IsControllerPressureStable( "MENSOR810617" );        // check pressure setpoint stability while in controller mode
                     CPC3000_controller2_pressure_stable = EMFT_CPC3000_IsControllerPressureStable( "MENSOR810615" );        // check pressure setpoint stability while in controller mode
 
                     //    EMFT_CPC3000_IsPressureStable function parameter description:    
                     //    Stability response as evaluated from standard deviation of stability buffer readouts 
                     //    Until all buffer readouts aren't within stability std. dev., buffer is unstable.
                     //    1. parameter - Mensor CPC3000 controller name string
                     //    NOTE: Active sensor has to be selected first - use EMFT_CPC3000_SetActiveSensor    
             
                     CPC3000_pressure1_stable = EMFT_CPC3000_IsPressureStable( "MENSOR810617" );        // check pressure readout stability while in controller mode
                     CPC3000_pressure2_stable = EMFT_CPC3000_IsPressureStable( "MENSOR810615" );        // check pressure readout stability while in controller mode
                     
                     t_now = EMFT_Get_TimeStamp();    // store stabilization loop current time
                     
                     delta_t = t_now - t_start;        // check elapsed time against stabilization timeout in ms
                     
                     all_stable = 1;
                     
                     if ( ( (CPC3000_pressure1_stable == 0) || (CPC3000_controller1_pressure_stable == 0) ) || ( (CPC3000_pressure2_stable == 0) || (CPC3000_controller2_pressure_stable == 0) ) ) {
                         all_stable = 0;
                     }
                     
                 } while ( ( (all_stable == 0) && ( delta_t < 120000.0 ) ) && (Signal_goto_safe_state == 0) );    
                 // pressure is stable, whenever controller says 'STABLE' and the stability buffer is stable and the timeout has not occured
                         
                                     EMFT_StripChart_Add_Point( "P_OUTLET", CPC3000_pressure_setpt1);    // add a point to plot of pressure vs. time            
                                                     EMFT_StripChart_Add_Point( "P_INLET", CPC3000_pressure_setpt2);    // add a point to plot of pressure vs. time            
                                 
                 if (( delta_t >= 120000.0 )||( delta_t >= 120000.0 ))    {            
                     Pressure_Controller1_Stop();        // there is probably a leak in the pressure line - turn off the controller
                     Pressure_Controller2_Stop();        // there is probably a leak in the pressure line - turn off the controller
                     puts( "Pressure stabilization timeout, due to probable pressure leak. Both Mensor CPC3000 pressure controllers were set to sensor mode!\n" );    // signal the timeout error to the user
                     Log_Error( 3, 1, -9 );    // log the error onto console and into log file (if available)                
                     return ( lc_err_code_nr );    // return error code
                 }
             
                             
                 return ( 0 );    // exit with success code return
     }
 
     int Pressure_Controller1_Stop( int VentilationYN )    
     {        
         int        CPC3000_error;        
                     /*    EMFT_CPC3000_SetInstrumentMode function parameter description:
                 1. parameter - Mensor CPC3000 controller name string
                 2. parameter - Instrument mode letter: 
                 'C' or 'c' set the control mode, 'M' or 'm' set the measure mode, 'V' or 'v' set the vent mode, 'S' or 's' for standby mode
             */
             if ( VentilationYN == 0 ) {
                 CPC3000_error = EMFT_CPC3000_SetInstrumentMode( "MENSOR810617", 'S');    // set instrument to standby mode                    
                 
                     if ( CPC3000_error != 0)    {
                         Log_Error( 3, 1, -11 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );    // exit with error code return
                     }
                             } else {
                 CPC3000_error = EMFT_CPC3000_SetInstrumentMode( "MENSOR810617", 'V');    // set instrument to ventilation mode    
                 
                     if ( CPC3000_error != 0)    {
                         Log_Error( 3, 1, -10 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );    // exit with error code return
                     }
                             };
                 return ( 0 );    // exit with success code return
     }
 
     int Pressure_Controller2_Stop( int Vent_Stdby )
     {        
         int        CPC3000_error;        
                     /*    EMFT_CPC3000_SetInstrumentMode function parameter description:
                 1. parameter - Mensor CPC3000 controller name string
                 2. parameter - Instrument mode letter: 
                 'C' or 'c' set the control mode, 'M' or 'm' set the measure mode, 'V' or 'v' set the vent mode, 'S' or 's' for standby mode
             */
             if ( Vent_Stdby == 0 ) {
                 CPC3000_error = EMFT_CPC3000_SetInstrumentMode( "MENSOR810615", 'S');    // set instrument to standby mode                    
                 
                     if ( CPC3000_error != 0)    {
                         Log_Error( 3, 2, -11 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );    // exit with error code return
                     }
                             } else {
                 CPC3000_error = EMFT_CPC3000_SetInstrumentMode( "MENSOR810615", 'V');    // set instrument to ventilation mode    
                 
                     if ( CPC3000_error != 0)    {
                         Log_Error( 3, 2, -10 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );    // exit with error code return
                     }
                             };
             
                 
         return ( 0 );    // exit with success code return
     }
 
     int Pressure_Controller1_Close()
     {
         int        CPC3000_error;        
                     CPC3000_error = EMFT_CPC3000_Disconnect();        // disconnect all CPC3000 controllers    
             
                 if ( CPC3000_error != 0 )    {            
                     Log_Error( 3, 1, -12 );    // log the error onto console and into log file (if available)                
                     return ( lc_err_code_nr );    // exit with error code return
                 }    
                             return ( 0 );    // exit with success code return
     }
     
     int Pressure_Controller2_Close()
     {
         int        CPC3000_error;        
                     CPC3000_error = EMFT_CPC3000_Disconnect();        // disconnect all CPC3000 controllers
             
                 if ( CPC3000_error != 0 )    {            
                     Log_Error( 3, 2, -12 );    // log the error onto console and into log file (if available)                
                     return ( lc_err_code_nr );    // exit with error code return
                 }    
                             return ( 0 );    // exit with success code return
     }
     
 
         //    define this symbol to use Flowbus device 1 at all
         //    define this symbol to use fmmt measurement on Flowbus device 1
         //    define this symbol to log fmmt measurement on Flowbus device 1
         //    define this symbol to use Yt stripchart plotting option on fmmt measurement on Flowbus device 1 
 
         //    define this symbol to use Flowbus device 2 at all
         //    define this symbol to use fmmt measurement on Flowbus device 2
         //    define this symbol to log fmmt measurement on Flowbus device 2
         //    define this symbol to use Yt stripchart plotting option on fmmt measurement on Flowbus device 2 
 
         //    FlowBus device library for use with LittleC
 
     
         
     // this symbol denotes, that a Flowbus library was already included
     // this symbol defines the version of the FlowBus device library
     
     
     // "PC-L109-08" machine is being used
     
         
         
             //    Bronkhorst device address and serial number list:
         //    Note:    Copy exact string with double quotes into serial number symbol value
         //  The SERIAL_NR string contains backspace character,
         //    which is not visible and is not displayed in simple editors such as Windows Notepad!
         //    Use Programmer's Notepad or Notepad++ for editing
         //    Bronkhorst device on channel: 1 SERIAL_NUMBER:  "SNM16209645B"
         //    Bronkhorst device on channel: 2 SERIAL_NUMBER:  "SNM16209645C"
         //    Bronkhorst device on channel: 3 SERIAL_NUMBER:  "SNM16209645A"
         //    Bronkhorst device on channel: 4 SERIAL_NUMBER:  "SNM16209645D"
         
                 
         
         
                 
                 
                 
                 
                 
         
                 
                 
                 
             
             
                 
         
             
             
                 //    Device channel    
                 //    Device floating point measurement name
                 //    Device integer measurement name
                 //    Device temperature measurement name
                 //    Device density measurement name
                 //    Device channel name (used for user id and plotting purposes)
                 //    Expected device serial number - if the serial number is not found on specified channel, entire FlowBus is searched for the instrument
                 
                 // include library for FlowBus device 1 library
                 //    FlowBus device 1 library for use with LittleC 
 
     
     
     // this symbol denotes, that a FlowBus device 1 library on machine MATEJ-PC for air measurements on MIKROAUG micropumps was already included
 
     char FlB_Dev1_SN[20];
     char FlB_Dev1_DevTyp[8];
     char FlB_Dev1_UserTag[20];    
     int  FlB_Dev1_AlarmInfo;
 
             
         float    FlB_Dev1_fmmt;                // floating-point measurement on Device
         char    FlB_Dev1_fmmt_units[8];        // device floating point readout units    (Bronkhorst parameter number 45)
                 
         float     FlB_Dev1_fmmt_std_dev;    // floating-point measurement standard deviation on Device    
         
             //    Device floating-point stability buffer size 
             //    Device standard floating-point meaasurement deviation, which defines stability
                 
                     // Device stripchart plot history length
             // Device stripchart time axis default width in seconds
             // Device stripchart plot Y axis minimum value for pressure (use integer value)
             // Device stripchart plot Y axis maximum value for pressure (use integer value)
             
     
     
                     //    Device channel    
                 //    Device floating point measurement name
                 //    Device integer measurement name
                 //    Device temperature measurement name
                 //    Device density measurement name
                 //    Device channel name (used for user id and plotting purposes)
                 //    Expected device serial number - if the serial number is not found on specified channel, entire FlowBus is searched for the instrument
                 
                 // include library for FlowBus device 2 library
                 //    FlowBus device 2 library or use with LittleC
 
     
     
     // this symbol denotes, that a FlowBus device 2 library on machine MATEJ-PC for air measurements on MIKROAUG micropumps was already included
 
     char FlB_Dev2_SN[20];
     char FlB_Dev2_DevTyp[8];
     char FlB_Dev2_UserTag[10];    
     int  FlB_Dev2_AlarmInfo;
 
             
         float    FlB_Dev2_fmmt;                // floating-point measurement on Device
         char    FlB_Dev2_fmmt_units[8];        // device floating point readout units    (Bronkhorst parameter number 45)
                 
         float     FlB_Dev2_fmmt_std_dev;    // floating-point measurement standard deviation on Device    
         //    Device floating-point stability buffer size 
         //    Device standard floating-point meaasurement deviation, which defines stability
         
                     // Device stripchart plot history length
             // Device stripchart time axis default width in seconds
             // Device stripchart plot Y axis minimum value for pressure (use integer value)
             // Device stripchart plot Y axis maximum value for pressure (use integer value)
             
     
     
     
             
         
                 
                 
                 
         
                 
     
         
     
     // Error section Bronkhorst
     
 
             // Flowbus device 1 errors
         
 
         
         
         
         
         
 
         
         
 
         
         
 
         
         
 
         
         
 
         
         
 
         
         
 
         
         
 
     
             // Flowbus device 2 errors
         
         
         
         
         
         
         
 
         
         
 
         
         
 
         
         
 
         
         
 
         
         
 
         
         
 
         
         
 
     
         
     
     
     
     int FLB_DEV1_Setup()    
     {
         // Bronkhorst FlowBus devices related variables
         int        FlowBus_err;
                         
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 6, 1, -9 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }
             
             // EMFT_Flowbus_Add_Device function adds the DDE device the specified DDE server
             
             //    0. parameter - DDE server name (i.e. FLOWDDE or FLOWDDE2)
             //    1. parameter - DDE device communication channel min. is 1, max. value is 128 
             //    Note: channel 0 is special! Check (https://www.bronkhorst.com/files/downloads/manuals_english/917067manual_flowdde.pdf, page 17)
             //    2. parameter - expected DDE channel - if a device serial number is not found on specified channel, device will be searched on serial number on first 10 channels
             //    3. parameter - DDE device integer measurement human readable name (for storage purposes) - 10 chars max length
             //    4. parameter - DDE device floating-point measurement human readable name (for storage purposes) - 10 chars max length
             //    5. parameter - DDE device temperature measurement human readable name (for storage purposes) - 10 chars max length
             //    6. parameter - DDE device density measurement human readable name (for storage purposes) - 10 chars max length            
             FlowBus_err = EMFT_Flowbus_Add_Device( "FLOWDDE", 2, "SNM13206719C", "Q1int", "Q1", "T1", "rho1" );    // DDE server will connect to a server and create a device
             
                 if ( FlowBus_err != 0)    {
                     Log_Error( 6, 1, -1 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //    -1 );    // exit with error code return
                 }
                         FlowBus_err = EMFT_Flowbus_Set_Parameter( "FLOWDDE", 2, "UserTag", "Q1");    // specified parameter of type string DDE nr. 115 (user tag) is set to value EMFT
             
                 if ( FlowBus_err != 0)    {
                     Log_Error( 6, 1, -2 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     // -2 );    // exit with error code return
                 }
                         FlowBus_err = EMFT_Flowbus_Get_Parameter( "FLOWDDE", 2, "UserTag");        // specified parameter of type string, DDE nr. 115 (user tag) is printed on output console    
             
                 if ( FlowBus_err != 0)    {
                     Log_Error( 6, 1, -3 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //     -3 );    // exit with error code return
                 }
                         FlowBus_err = EMFT_Flowbus_Retrieve_String_Parameter( "FLOWDDE", 2, "UserTag", FlB_Dev1_UserTag);        // retrieve read parameter value and store to string variable
             
                 if ( FlowBus_err != 0)    {
                     Log_Error( 6, 1, -4 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //     -4 );    // exit with error code return
                 }
                         FlowBus_err = EMFT_Flowbus_Get_Parameter( "FLOWDDE", 2, "DeviceType" );        // specified parameter of device type string is printed on output console        
             
                 if ( FlowBus_err != 0)    {
                     Log_Error( 6, 1, -3 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //     -3 );    // exit with error code return
                 }
                         FlowBus_err = EMFT_Flowbus_Retrieve_String_Parameter( "FLOWDDE", 2, "DeviceType", FlB_Dev1_DevTyp);        // retrieve read parameter value and store to string variable
             
                 if ( FlowBus_err != 0)    {
                     Log_Error( 6, 1, -4 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //     -4 );    // exit with error code return
                 }
                         FlowBus_err = EMFT_Flowbus_Get_Parameter( "FLOWDDE", 2, "identstrng" );        // specified parameter of type string, DDE nr. 1 (Identification string) is printed on output console        
             
                 if ( FlowBus_err != 0)    {
                     Log_Error( 6, 1, -3 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //     -3 );    // exit with error code return
                 }
                         FlowBus_err = EMFT_Flowbus_Retrieve_String_Parameter( "FLOWDDE", 2, "identstrng", FlB_Dev1_SN);        // retrieve read parameter value and store to string variable
             
                 if ( FlowBus_err != 0)    {
                     Log_Error( 6, 1, -4 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //     -4 );    // exit with error code return
                 }
                         FlowBus_err = EMFT_Flowbus_Get_Parameter( "FLOWDDE", 2, "alarminfo");    // specified parameter of type char, DDE nr. 28 (Alarm info) is printed on output console
             
             if ( FlowBus_err != 0)    {
                 Log_Error( 6, 1, -3 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //     -3 );    // exit with error code return
             }
                         FlB_Dev1_AlarmInfo = EMFT_Flowbus_Retrieve_Float_Parameter( "FLOWDDE", 2, "alarminfo");    // retrieve read parameter value and store            
             
                         
                 FlowBus_err = EMFT_Flowbus_Get_Parameter( "FLOWDDE", 2, "capunitstr" );        // specified parameter of type string, DDE nr. 45 (readout units) is printed on output console        
                 
                     if ( FlowBus_err != 0)    {
                         Log_Error( 6, 1, -3 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //     -3 );    // exit with error code return
                     }
                                 FlowBus_err = EMFT_Flowbus_Retrieve_String_Parameter( "FLOWDDE", 2, "capunitstr", FlB_Dev1_fmmt_units);        // retrieve read parameter value and store to string variable
                 
                     if ( FlowBus_err != 0)    {
                         Log_Error( 6, 1, -4 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //     -4 );    // exit with error code return
                     }
                                 // EMFT_Flowbus_Config_Float_Mmt_Stability function configures the floating-point measurement stability buffer for the DDE device the specified DDE server
                 // Note: this function also resets the floating-point measurement stability buffer to zero
                 //    0. parameter - DDE server name
                 //    1. parameter - DDE device communication channel
                 //    2. parameter - DDE device float measurement buffer history length (default value is 10) 
                 //    3. parameter - DDE device float measurement buffer limit of standard deviation criterion (default value is 1E-3)
                 FlowBus_err = EMFT_Flowbus_Config_Float_Mmt_Stability( "FLOWDDE", 2, 20, 1.0E-1 );
                 
                     if ( FlowBus_err != 0)    {
                         Log_Error( 6, 1, -5 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //     -5 );    // exit with error code return
                     }
                                                     // EMFT_StripChart_Add_Plot function adds a plot to the stripchart control    
                     // 0. parameter - number of points in the history buffer
                     // 1. parameter - Y axis manual scaling mode minimum
                     // 2. parameter - Y axis manual scaling mode maximum - depending on displayed quantity units and data type
                     // 3. parameter - X axis (time axis) initial window width in seconds
                     // 4. parameter - human-readable name of channel
                     // 5. parameter - human-readable units of channel
                     // 6. parameter - color: [0] = "RED", "GREEN", "BLUE" ,"CYAN", "MAGENTA", "YELLOW", "DARK RED" ,"DARK BLUE", "DARK GREEN", "DARK CYAN", "DARK MAGENTA", "DARK YELLOW", "LIGHT GRAY", "DARK GRAY", "BLACK", "WHITE", "FHG", "LIGHT BLUE"
                     // 7. parameter - Y axis data type = "USHORT", "SHORT", "FLOAT", "DOUBLE" 
                     // 8. parameter - Y axis, used to display the data = "LEFT", "RIGHT"                        
                     FlowBus_err = EMFT_StripChart_Add_Plot(    100, 
                                                             0, 
                                                             1, 
                                                             10, 
                                                             "Q1", 
                                                             FlB_Dev1_fmmt_units, "DARK BLUE", "FLOAT", "RIGHT");        // Note: input variable type must be the same as variable being plotted
                                         
                         
                         
                         
                 
         return ( 0 );
     }
     
     int FLB_DEV2_Setup()    
     {
         // Bronkhorst FlowBus devices related variables
         int        FlowBus_err;
                                 
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 6, 2, -9 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }
             
             // EMFT_Flowbus_Add_Device function adds the DDE device the specified DDE server
             //    0. parameter - DDE server name (i.e. FLOWDDE or FLOWDDE2)
             //    1. parameter - DDE device communication channel min. is 1, max. value is 128 
             //    Note: channel 0 is special! Check (https://www.bronkhorst.com/files/downloads/manuals_english/917067manual_flowdde.pdf, page 17)            
             //    2. parameter - expected DDE channel - if a device serial number is not found on specified channel, device will be searched on serial number on first 10 channels
             //    3. parameter - DDE device integer measurement human readable name (for storage purposes) - 10 chars max length
             //    4. parameter - DDE device floating-point measurement human readable name (for storage purposes) - 10 chars max length
             //    5. parameter - DDE device temperature measurement human readable name (for storage purposes) - 10 chars max length
             //    6. parameter - DDE device density measurement human readable name (for storage purposes) - 10 chars max length            
             FlowBus_err = EMFT_Flowbus_Add_Device( "FLOWDDE", 5, "SNM13206719D", "Q2int", "Q2", "T2", "rho2" );    // DDE server will connect to a server and create a device
             
                 if ( FlowBus_err != 0)    {
                     Log_Error( 6, 2, -1 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //     -1 );    // exit with error code return
                 }
                         FlowBus_err = EMFT_Flowbus_Set_Parameter( "FLOWDDE", 5, "UserTag", "Q2");    // specified parameter of type string DDE nr. 115 (user tag) is set to value EMFT
             
                 if ( FlowBus_err != 0)    {
                     Log_Error( 6, 2, -2 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //     -2 );    // exit with error code return
                 }
                         FlowBus_err = EMFT_Flowbus_Get_Parameter( "FLOWDDE", 5, "UserTag");        // specified parameter of type string, DDE nr. 115 (user tag) is printed on output console    
             
                 if ( FlowBus_err != 0)    {
                     Log_Error( 6, 2, -3 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //     -3 );    // exit with error code return
                 }
                         FlowBus_err = EMFT_Flowbus_Retrieve_String_Parameter( "FLOWDDE", 5, "UserTag", FlB_Dev2_UserTag);        // retrieve read parameter value and store to string variable
             
                 if ( FlowBus_err != 0)    {
                     Log_Error( 6, 2, -4 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //     -4 );    // exit with error code return
                 }
                         FlowBus_err = EMFT_Flowbus_Get_Parameter( "FLOWDDE", 5, "DeviceType" );        // specified parameter of device type string is printed on output console        
             
                 if ( FlowBus_err != 0)    {
                     Log_Error( 6, 2, -3 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //     -3 );    // exit with error code return
                 }
                         FlowBus_err = EMFT_Flowbus_Retrieve_String_Parameter( "FLOWDDE", 5, "DeviceType", FlB_Dev2_DevTyp);        // retrieve read parameter value and store to string variable
             
                 if ( FlowBus_err != 0)    {
                     Log_Error( 6, 2, -4 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //     -4 );    // exit with error code return
                 }
                         FlowBus_err = EMFT_Flowbus_Get_Parameter( "FLOWDDE", 5, "identstrng" );        // specified parameter of type string, DDE nr. 1 (Identification string) is printed on output console        
             
                 if ( FlowBus_err != 0)    {
                     Log_Error( 6, 2, -3 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //     -3 );    // exit with error code return
                 }
                         FlowBus_err = EMFT_Flowbus_Retrieve_String_Parameter( "FLOWDDE", 5, "identstrng", FlB_Dev2_SN);        // retrieve read parameter value and store to string variable
             
                 if ( FlowBus_err != 0)    {
                     Log_Error( 6, 2, -4 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //     -4 );    // exit with error code return
                 }
                         FlowBus_err = EMFT_Flowbus_Get_Parameter( "FLOWDDE", 5, "alarminfo");    // specified parameter of type char, DDE nr. 28 (Alarm info) is printed on output console
             
                 if ( FlowBus_err != 0)    {
                     Log_Error( 6, 2, -3 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //     -3 );    // exit with error code return
                 }
                         FlB_Dev2_AlarmInfo = EMFT_Flowbus_Retrieve_Float_Parameter( "FLOWDDE", 5, "alarminfo");    // retrieve read parameter value and store            
                         
             
                         
                 FlowBus_err = EMFT_Flowbus_Get_Parameter( "FLOWDDE", 5, "capunitstr" );        // specified parameter of type string, DDE nr. 45 (readout units) is printed on output console        
                 
                     if ( FlowBus_err != 0)    {
                         Log_Error( 6, 2, -3 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //     -3 );    // exit with error code return
                     }
                                 FlowBus_err = EMFT_Flowbus_Retrieve_String_Parameter( "FLOWDDE", 5, "capunitstr", FlB_Dev2_fmmt_units);        // retrieve read parameter value and store to string variable
                 
                     if ( FlowBus_err != 0)    {
                         Log_Error( 6, 2, -4 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //     -4 );    // exit with error code return
                     }
                                 // EMFT_Flowbus_Config_Float_Mmt_Stability function configures the floating-point measurement stability buffer for the DDE device the specified DDE server
                 // Note: this function also resets the floating-point measurement stability buffer to zero
                 //    0. parameter - DDE server name
                 //    1. parameter - DDE device communication channel
                 //    2. parameter - DDE device float measurement buffer history length (default value is 10) 
                 //    3. parameter - DDE device float measurement buffer limit of standard deviation criterion (default value is 1E-3)
                 FlowBus_err = EMFT_Flowbus_Config_Float_Mmt_Stability( "FLOWDDE", 5, 20, 1.0E-1 );
                 
                     if ( FlowBus_err != 0)    {
                         Log_Error( 6, 2, -5 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //     -5 );    // exit with error code return
                     }
                                                     // EMFT_StripChart_Add_Plot function adds a plot to the stripchart control    
                     // 0. parameter - number of points in the history buffer
                     // 1. parameter - Y axis manual scaling mode minimum
                     // 2. parameter - Y axis manual scaling mode maximum - depending on displayed quantity units and data type
                     // 3. parameter - X axis (time axis) initial window width in seconds
                     // 4. parameter - human-readable name of channel
                     // 5. parameter - human-readable units of channel
                     // 6. parameter - color: [0] = "RED", "GREEN", "BLUE" ,"CYAN", "MAGENTA", "YELLOW", "DARK RED" ,"DARK BLUE", "DARK GREEN", "DARK CYAN", "DARK MAGENTA", "DARK YELLOW", "LIGHT GRAY", "DARK GRAY", "BLACK", "WHITE", "FHG", "LIGHT BLUE"
                     // 7. parameter - Y axis data type = "USHORT", "SHORT", "FLOAT", "DOUBLE" 
                     // 8. parameter - Y axis, used to display the data = "LEFT", "RIGHT"                        
                     FlowBus_err = EMFT_StripChart_Add_Plot(    100, 
                                                             0, 
                                                             1, 
                                                             10, 
                                                             "Q2", 
                                                             FlB_Dev2_fmmt_units, "DARK BLUE", "FLOAT", "RIGHT");        // Note: input variable type must be the same as variable being plotted
 
                                         
                         
                         
                         
             
                 
         return ( 0 );        
     }
 
     int FLB_DEV3_Setup()    
     {
         // Bronkhorst FlowBus devices related variables
         int        FlowBus_err;
                 
         return ( 0 );        
         
     }
     
     int FLB_DEV1_Measure_Until_FMMT_Stable( int reinit_stab_buf )
     {    
                     int    FlowBus_err;            
             int FlB_Dev1_fmmt_is_stable;                
                             
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 6, 1, -9 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }
             
             if ( reinit_stab_buf != 0 )     {
                 // user requested reinitialization of stability buffer on Flowbus device 1
                 
                 FlB_Dev1_fmmt_is_stable = 0;    // reset stability status (0 - not stable)
                 FlB_Dev1_fmmt = 0.0;            // reset floating point measurement
                 
                 // EMFT_Flowbus_Config_Float_Mmt_Stability function configures the floating-point measurement stability buffer for the DDE device the specified DDE server
                 // Note: this function also resets the floating-point measurement stability buffer to zero
                 //    0. parameter - DDE server name
                 //    1. parameter - DDE device communication channel
                 //    2. parameter - DDE device float measurement buffer history length (default value is 10) 
                 //    3. parameter - DDE device float measurement buffer limit of standard deviation criterion (default value is 1E-3)
                 FlowBus_err = EMFT_Flowbus_Config_Float_Mmt_Stability( "FLOWDDE", 2, 20, 1.0E-1 );
                 
                     if ( FlowBus_err != 0)    {
                         Log_Error( 6, 1, -5 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //     -5 );    // exit with error code return
                     }
                             }
             
             // Wait until the measurements on both devices become within specified interval
             do {
 
                 FlB_Dev1_fmmt = EMFT_Flowbus_Float_Mmt( "FLOWDDE", 2 );        // DDE client software will trigger a single float (fmeasure) measurement and return the result to the script
                 
                 FlB_Dev1_fmmt_std_dev = EMFT_Flowbus_Float_Mmt_StdDeviation( "FLOWDDE", 2 );        // DDE client software will return the standard deviation result to the script
                 
                                     EMFT_StripChart_Add_Point( "Q1", FlB_Dev1_fmmt);    // add a point to plot of flow vs. time
                                 
                 // This function queries the stability status on a given DDE device, specified by channel parameter- result is either 0 (not stable) or 1 (stable)
                 // Note: Stability is evaluated as a standard deviation on entire history buffer for a DDE device, specified by channel parameter.
                 // Until the history buffer is full (i.e. the number of iterations is equal or greater than history buffer size), the stability criterion is not evaluated (i.e. remains not stable)!
                 // Whenever the calculated standard deviation is less or equal than the limit value, which is set in EMFT_Flowbus_Add_Device function, the stability criterion becomes stable.        
                 //    0. parameter - DDE server name (i.e. FLOWDDE or FLOWDDE2
                 //    1. parameter - DDE device communication channel min. is 0, max. value is 128
                 FlB_Dev1_fmmt_is_stable = EMFT_Flowbus_Is_Float_Mmt_Stable ("FLOWDDE", 2);
                 
             } while( ( FlB_Dev1_fmmt_is_stable == 0 ) && (Signal_goto_safe_state == 0) );    // repeat measurement until fmmt is stable
             
                         
                         
             return FlB_Dev1_fmmt_is_stable;
             
             }
 
     int FLB_DEV1_Measure_Once()
     {    
                     int    FlowBus_err;
                             
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 6, 1, -9 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }
             
             FlB_Dev1_fmmt = 0.0;            // reset floating point measurement
             
 
             FlB_Dev1_fmmt = EMFT_Flowbus_Float_Mmt( "FLOWDDE", 2 );        // DDE client software will trigger a single float (fmeasure) measurement and return the result to the script
                 
                             EMFT_StripChart_Add_Point( "Q1", FlB_Dev1_fmmt);    // add a point to plot of flow vs. time
                         
                         
                         
             return 1;
             
             }
 
     int FLB_DEV2_Measure_Until_FMMT_Stable( int reinit_stab_buf )
     {    
                     int    FlowBus_err;            
             int FlB_Dev2_fmmt_is_stable;                
                             
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 6, 2, -9 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }
             
             if ( reinit_stab_buf != 0 )     {
                 // user requested reinitialization of stability buffer on Flowbus device 2
                 FlB_Dev2_fmmt_is_stable = 0;    // reset stability status (0 - not stable)
                 FlB_Dev2_fmmt = 0.0;            // reset floating point measurement
                 
                 // EMFT_Flowbus_Config_Float_Mmt_Stability function configures the floating-point measurement stability buffer for the DDE device the specified DDE server
                 // Note: this function also resets the floating-point measurement stability buffer to zero
                 //    0. parameter - DDE server name
                 //    1. parameter - DDE device communication channel
                 //    2. parameter - DDE device float measurement buffer history length (default value is 10) 
                 //    3. parameter - DDE device float measurement buffer limit of standard deviation criterion (default value is 1E-3)
                 FlowBus_err = EMFT_Flowbus_Config_Float_Mmt_Stability( "FLOWDDE", 5, 20, 1.0E-1 );
                 
                     if ( FlowBus_err != 0)    {
                         Log_Error( 6, 2, -5 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //     -5 );    // exit with error code return
                     }
                             }
             
             // Wait until the measurements on device become within specified interval
             do {
 
                 FlB_Dev2_fmmt = EMFT_Flowbus_Float_Mmt( "FLOWDDE", 5 );        // DDE client software will trigger a single float (fmeasure) measurement and return the result to the script
                 
                 FlB_Dev2_fmmt_std_dev = EMFT_Flowbus_Float_Mmt_StdDeviation( "FLOWDDE", 5 );        // DDE client software will return the standard deviation result to the script
                 
                                     EMFT_StripChart_Add_Point( "Q2", FlB_Dev2_fmmt);    // add a point to plot of flow vs. time
                                 
                 // This function queries the stability status on a given DDE device, specified by channel parameter- result is either 0 (not stable) or 1 (stable)
                 // Note: Stability is evaluated as a standard deviation on entire history buffer for a DDE device, specified by channel parameter.
                 // Until the history buffer is full (i.e. the number of iterations is equal or greater than history buffer size), the stability criterion is not evaluated (i.e. remains not stable)!
                 // Whenever the calculated standard deviation is less or equal than the limit value, which is set in EMFT_Flowbus_Add_Device function, the stability criterion becomes stable.        
                 //    0. parameter - DDE server name (i.e. FLOWDDE or FLOWDDE2
                 //    1. parameter - DDE device communication channel min. is 0, max. value is 128
                 FlB_Dev2_fmmt_is_stable = EMFT_Flowbus_Is_Float_Mmt_Stable ("FLOWDDE", 5);
                 
             } while( ( FlB_Dev2_fmmt_is_stable == 0 ) && (Signal_goto_safe_state == 0) );    // repeat measurement until fmmt is stable
             
                         
                         
             return FlB_Dev2_fmmt_is_stable;
             
             }
 
     int FLB_DEV2_Measure_Once()
     {    
                     int    FlowBus_err;
             
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 6, 2, -9 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }
             
             FlB_Dev2_fmmt = 0.0;            // reset floating point measurement
             
             FlB_Dev2_fmmt = EMFT_Flowbus_Float_Mmt( "FLOWDDE", 5 );        // DDE client software will trigger a single float (fmeasure) measurement and return the result to the script
                 
                 
                             EMFT_StripChart_Add_Point( "Q2", FlB_Dev2_fmmt);    // add a point to plot of flow vs. time
                             
             
                         
                         
             return 1;
             
             }    
 
     int FLB_DEV3_Measure_Until_FMMT_Stable( int reinit_stab_buf )
     {    
                     return 1;    // Device fmmt is not used, return stable
             }
 
     int FLB_DEV3_Measure_Once()
     {    
                     return 1;    // Device fmmt is not used, return stable
             }
     
     int FLB_DEV12_Measure_Until_FMMT_Stable( int reinit_stab_buf )
     {    
                     
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 6, 1, -9 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }
             
                             // evaluate stability on Flowbus devices 1 and 2
                 int    FlowBus_err;
                 
                 int FlB_Dev1_fmmt_is_stable;                                
                 int FlB_Dev2_fmmt_is_stable;                
                 
                 if ( reinit_stab_buf != 0 )     {
                     // user requested reinitialization of stability buffer on Flowbus devices 1 and 2
                     FlB_Dev1_fmmt_is_stable = 0;    // reset stability status (0 - not stable)
                     FlB_Dev1_fmmt = 0.0;            // reset floating point measurement
                     
                     FlB_Dev2_fmmt_is_stable = 0;    // reset stability status (0 - not stable)
                     FlB_Dev2_fmmt = 0.0;            // reset floating point measurement
                     
                     // EMFT_Flowbus_Config_Float_Mmt_Stability function configures the floating-point measurement stability buffer for the DDE device the specified DDE server
                     // Note: this function also resets the floating-point measurement stability buffer to zero
                     //    0. parameter - DDE server name
                     //    1. parameter - DDE device communication channel
                     //    2. parameter - DDE device float measurement buffer history length (default value is 10) 
                     //    3. parameter - DDE device float measurement buffer limit of standard deviation criterion (default value is 1E-3)
                     FlowBus_err = EMFT_Flowbus_Config_Float_Mmt_Stability( "FLOWDDE", 2, 20, 1.0E-1 );
                     
                         if ( FlowBus_err != 0)    {
                             Log_Error( 6, 1, -5 );    // log the error onto console and into log file (if available)
                             return ( lc_err_code_nr );     //     -5 );    // exit with error code return
                         }
                                         FlowBus_err = EMFT_Flowbus_Config_Float_Mmt_Stability( "FLOWDDE", 5, 20, 1.0E-1 );
                     
                         if ( FlowBus_err != 0)    {
                             Log_Error( 6, 2, -5 );    // log the error onto console and into log file (if available)
                             return ( lc_err_code_nr );     //     -5 );    // exit with error code return
                         }
                                     }
                 
                 // Wait until the measurements on device become within specified interval
                 do {
 
                     FlB_Dev1_fmmt = EMFT_Flowbus_Float_Mmt( "FLOWDDE", 2 );        // DDE client software will trigger a single float (fmeasure) measurement and return the result to the script
                     
                     FlB_Dev1_fmmt_std_dev = EMFT_Flowbus_Float_Mmt_StdDeviation( "FLOWDDE", 2 );        // DDE client software will return the standard deviation result to the script
                     
                                             EMFT_StripChart_Add_Point( "Q1", FlB_Dev1_fmmt);    // add a point to plot of flow vs. time
                                         
                     // This function queries the stability status on a given DDE device, specified by channel parameter- result is either 0 (not stable) or 1 (stable)
                     // Note: Stability is evaluated as a standard deviation on entire history buffer for a DDE device, specified by channel parameter.
                     // Until the history buffer is full (i.e. the number of iterations is equal or greater than history buffer size), the stability criterion is not evaluated (i.e. remains not stable)!
                     // Whenever the calculated standard deviation is less or equal than the limit value, which is set in EMFT_Flowbus_Add_Device function, the stability criterion becomes stable.        
                     //    0. parameter - DDE server name (i.e. FLOWDDE or FLOWDDE2
                     //    1. parameter - DDE device communication channel min. is 0, max. value is 128
                     FlB_Dev1_fmmt_is_stable = EMFT_Flowbus_Is_Float_Mmt_Stable ("FLOWDDE", 2);
 
                     FlB_Dev2_fmmt = EMFT_Flowbus_Float_Mmt( "FLOWDDE", 5 );        // DDE client software will trigger a single float (fmeasure) measurement and return the result to the script
                     
                     FlB_Dev2_fmmt_std_dev = EMFT_Flowbus_Float_Mmt_StdDeviation( "FLOWDDE", 5 );        // DDE client software will return the standard deviation result to the script
                     
                                             EMFT_StripChart_Add_Point( "Q2", FlB_Dev2_fmmt);    // add a point to plot of flow vs. time
                                         
                     // This function queries the stability status on a given DDE device, specified by channel parameter- result is either 0 (not stable) or 1 (stable)
                     // Note: Stability is evaluated as a standard deviation on entire history buffer for a DDE device, specified by channel parameter.
                     // Until the history buffer is full (i.e. the number of iterations is equal or greater than history buffer size), the stability criterion is not evaluated (i.e. remains not stable)!
                     // Whenever the calculated standard deviation is less or equal than the limit value, which is set in EMFT_Flowbus_Add_Device function, the stability criterion becomes stable.        
                     //    0. parameter - DDE server name (i.e. FLOWDDE or FLOWDDE2
                     //    1. parameter - DDE device communication channel min. is 0, max. value is 128
                     FlB_Dev2_fmmt_is_stable = EMFT_Flowbus_Is_Float_Mmt_Stable ("FLOWDDE", 5);
                     
                 } while ( ( ( FlB_Dev1_fmmt_is_stable == 0 ) || (FlB_Dev2_fmmt_is_stable == 0) ) && (Signal_goto_safe_state == 0) );    // repeat measurement until both flow measurements are stable (until either of the two is unstable)
                 
                                 
                                 
                                 
                                 
                 return ( FlB_Dev1_fmmt_is_stable && FlB_Dev2_fmmt_is_stable);        // if both are stable, return stable, otherwise non-stable
                         }
 
     int FLB_DEV1_Measure_Until_IMMT_Stable( int reinit_stab_buf )
     {    
                     return 1;    // Device fmmt is not used, return stable
             }
 
     int FLB_DEV1_Close()
     {        
                     EMFT_Flowbus_Remove_Device( "FLOWDDE", 2 );            // disconnect device
                 return ( 0 );
     }
     
     int FLB_DEV2_Close()
     {        
                     EMFT_Flowbus_Remove_Device( "FLOWDDE", 5 );            // disconnect device
                 return ( 0 );
     }
 
     int FLB_DEV3_Close()
     {        
                 return ( 0 );
     }
 
 
 
         //    define this symbol to plot frequency trace of HP33120A generator over time
         //  frequency of function generator is being logged        
         // use sinus flank signal waveform
         // Frequency generator (HP33120A) connected to a piezo amplifier (SVR 500 or SVR 1000-3)
 
     
         
     // this symbol denotes, that a HP33120A library was already included
     // this symbol defines the version of the HP33120A library
     
     
     
     
             // instrument address (default = 23)    
         // define this macro, if OUTP:OFF or ON is supported (not on HP33120A)
         
         
         // high-voltage piezo amplifier amplification (V/V)
         // target impedance is 50 ohm    
         // generator (source) impedance is 50 ohm
         
     
     
         
         
     // default value for output impedance of 50 ohm
     // default value for output high-impedance
     // default value for target impedance of 50 ohm
     // default value for target high-impedance
     // sinus-flank signal draw mode - abrupt
     // sinus-flank signal draw mode - continuous 
     
     
         // has user overridden default frequency setting?    
         // frequency - floating point (Hz)                
         
         
     
         // slew rate rising edge - floating point (V/us) - steepest value is 784 mV/us on open-circuit termination
         
         
         
     
         // slew rate falling edge - floating point (V/us) - steepest value is 784 mV/us on open-circuit termination
         
         
         
     // duty cycle in percent - valid values in range 20 ... 80 % for sinus-flank or trapezoid setting
 
     //  general trigger Source - (0: "IMM" 1: "EXT" 2: "BUS")
     
     
     
     //  output control - (0: "OUTP:OFF" 1: "OUTP:ON")
     
 
     //*****************************************************************************************************
     //**********************************    BURST MODULATION CONFIGURATION TABLE **************************
     //*****************************************************************************************************
     
         
     // External trigger output enabled or disabled
     
 
         
         // frequency stripchart plot history length
         // frequency stripchart time axis default width in seconds
         
                     // frequency stripchart plot Y axis minimum value for frequency (use integer value)
                 
                     // frequency stripchart plot Y axis maximum value for frequency (use integer value)
                 
         // frequency name for plotting purposes
         // frequency units for plotting purposes
         
     
                 // voltage stripchart plot Y axis minimum value for voltage (use integer value)
                 
                     // voltage stripchart plot Y axis maximum value for voltage (use integer value)
                 
         // high level voltage name for plotting purposes
         // high level voltage units for plotting purposes
         
     
                 // low level voltage stripchart plot Y axis minimum value for voltage (use integer value)
                 
                     // low level voltage stripchart plot Y axis maximum value for voltage (use integer value)
                 
         // low level voltage name for plotting purposes
         // low level voltage units for plotting purposes
         
     
     // Error section HP33120A
     
     
     
     // HP33120A related errors    
     
     // set  error message macro value - no more than 250 characters!
     
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
 
     EMFT_ERR_CPC3000_DEV1
     
     // HP33120A function generator related variables
     int HP33120A_last_err;
     char HP33120A_SerialNr[60];    // serial number string
 
     int uPumps_Excitation_Setup()    
     {
         
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip setting the generator with new frequency
             Log_Error( 4, 1, -12 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
 
         // this function initializes the instrument (i.e. performs *RST, does not query identification (NO *IDN? is sent ) and acquires the instrument handle
         HP33120A_last_err = EMFT_HP33120B_init( 10 );
         
             if ( HP33120A_last_err != 0)    {
                 Log_Error( 4, 1, -1 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );         // -1 );
             }
                 EMFT_HP33120B_clear( 10 );        // clear the instrument    
 
         /* EMFT_hp33120b_serial_number function parameter description                
             1. parameter - instrument address
             2. parameter - Global string variable, which receives the instrument serial number information
         */
         HP33120A_last_err = EMFT_hp33120b_serial_number( 10, HP33120A_SerialNr);
         
             if ( HP33120A_last_err != 0)    {
                 Log_Error( 4, 1, -3 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );         // -3 );
             }
                 
         puts("HP33120 serial number:\t"); print(HP33120A_SerialNr); puts("\n");    // refresh HP33120A_SerialNr variable
         
         /* EMFT_HP33120B_out_impedance function parameter description                
             1. parameter - instrument address
             2. parameter - output impedance: 0 - 50 ohm termination, 1 - Hi-Z termination        
         */
         
         HP33120A_last_err = EMFT_HP33120B_out_impedance( 10, 1 );
         
             if ( HP33120A_last_err != 0)    {
                 Log_Error( 4, 1, -2 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );         // -2 );
             }
                 
                     // EMFT_StripChart_Add_Plot function adds a plot to the stripchart control    
             // 0. parameter - number of points in the history buffer
             // 1. parameter - Y axis manual scaling mode minimum
             // 2. parameter - Y axis manual scaling mode maximum - depending on displayed quantity units and data type
             // 3. parameter - X axis (time axis) initial window width in seconds
             // 4. parameter - human-readable name of channel
             // 5. parameter - human-readable units of channel
             // 6. parameter - color: [0] = "RED", "GREEN", "BLUE" ,"CYAN", "MAGENTA", "YELLOW", "DARK RED" ,"DARK BLUE", "DARK GREEN", "DARK CYAN", "DARK MAGENTA", "DARK YELLOW", "LIGHT GRAY", "DARK GRAY", "BLACK", "WHITE", "FHG", "LIGHT BLUE"
             // 7. parameter - Y axis data type = "USHORT", "SHORT", "FLOAT", "DOUBLE" 
             // 8. parameter - Y axis, used to display the data = "LEFT", "RIGHT"
             HP33120A_last_err = EMFT_StripChart_Add_Plot(    100, 
                                                             5.0, 
                                                             70.0, 
                                                             10, 
                                                             "f", 
                                                             "Hz", "BLACK", "FLOAT", "LEFT");
                                                             
             
                 if ( HP33120A_last_err != 0)    {            
                     Log_Error( 4, 1, -4 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );         // -4 );
                 }
                             
                 
                 
         return ( 0 );    
     }
 
     int uPumps_Excitation_SetOutput( char output_state )
     {    
                     
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip setting the generator with new frequency
                 Log_Error( 4, 1, -12 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }
             
             HP33120A_last_err = EMFT_HP33120B_set_output( 10, output_state );    // set generator output to desired state
             
                 if ( HP33120A_last_err != 0)    {
                     Log_Error( 4, 1, -10 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );         // -10 );
                 }
                             return ( 0 );
     }
     
     int uPumps_Excitation_FreqStart( float freq, char trig_source )    
     {
         double HP33120A_amplitude;
         double HP33120A_peak_to_peak; 
         double HP33120A_offset;
             
         uPumps_Excitation_Stop();    // stop micropump excitation before setting up new frequency value
 
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip setting the generator with new frequency
             Log_Error( 4, 1, -12 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         HP33120A_peak_to_peak = (90.0 - -30.0) / 100.0;    // calculate peak-to-peak on the HP33120a side
         HP33120A_amplitude = HP33120A_peak_to_peak / 2;    // calculate amplitude value on the HP33120a side
         HP33120A_offset = ( -30.0 / 100.0 ) + HP33120A_amplitude;    // calculate offset voltage on the HP33120a side
         
         //    Note: If the target device input impedance differs from the one specified, 
         //    the slew-rate factors will differ by the factor of two or by one-half!
 
         /* EMFT_HP33120B_sinus_flank_wf function parameter description                
             1. parameter - peak-to-peak value - floating point (V) 
             2. parameter - offset - floating point (V)
             3. parameter - frequency - floating point (Hz)
             4. parameter - slew rate rising edge - floating point (V/us) - steepest value is 784 mV/us on open-circuit termination
             5. parameter - slew rate falling edge - floating point (V/us) - steepest value is 784 mV/us on open-circuit termination
             6. parameter - duty cycle in percent - valid values in range 20 ... 80 %
             7. parameter - target impedance: 50 - 50 ohm termination at target input (50), 9.9E+37 - Hi-Z termination at target input (9.9E+37)
             8. parameter - sinus-flank signal draw mode: 0 - abrupt (0), 1 - continuous (1)
         */    
         //    target impedance is: 9.9E+37
         HP33120A_last_err = EMFT_HP33120B_sinus_flank_wf(    10, HP33120A_peak_to_peak, HP33120A_offset, 
                                                             freq, 1.0E-3, 1.0E-3, 
                                                             50.0, 9.9E+37, 1 );
         
             if ( HP33120A_last_err != 0)    {
                 Log_Error( 4, 1, -5 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );         // -5 );
             }
                 /* EMFT_hp33120b_config_trigger_source function parameter description                
             1. parameter - instrument address
             2. parameter - trigger source: 0 - IMMediate, 1 - EXTernal, 2 - BUS        
         */    
         HP33120A_last_err = EMFT_hp33120b_config_trigger_source( 10, trig_source );    // configure the trigger source to immediate on selected module
         
             if ( HP33120A_last_err != 0)    {
                 Log_Error( 4, 1, -9 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );         // -9 );
             }
                 
         uPumps_Excitation_SetOutput(1);     // set generator output on
 
                     EMFT_StripChart_Add_Point( "f", freq);    // add a point to plot of frequency vs. time
                 
         return ( 0 );    
     }
 
     int uPumps_Excitation_BurstMod_Setup()    
     {
                 
         return ( 0 );    
     }
 
     int uPumps_Excitation_BurstMod_Stop()
     {
                 
         return ( 0 );    
     }
 
     int uPumps_Excitation_Trigger()    
     {
 
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip triggering of generator with any settings
             Log_Error( 4, 1, -12 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         /* EMFT_hp33120b_send_trig function parameter description        
             1. parameter - instrument address number        
         */    
         HP33120A_last_err = EMFT_hp33120b_send_trig( 10 );    // sends the *TRG command to selected module
         
             if ( HP33120A_last_err != 0)    {
                 Log_Error( 4, 1, -8 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );         // -8 );
             }
                 
         return ( 0 );    
     }
     
     int uPumps_Excitation_VoltStart( float Vmax, float Vmin, char trig_source )    
     {
         // In all trigger modes (IMM, EXT, BUS), be sure to set the output to ON using uPumps_Excitation_SetOutput(1) after calling this function and setting optional modulation parameters
         // When in BUS trigger mode, actual output will NOT be generated until uPumps_Excitation_Trigger(); is issued  after calling this function
         double HP33120A_amplitude;
         double HP33120A_peak_to_peak; 
         double HP33120A_offset;
             
         uPumps_Excitation_Stop();    // stop micropump excitation before setting up new voltage value
 
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip setting the generator with new voltage
             Log_Error( 4, 1, -12 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
 
         HP33120A_peak_to_peak = (Vmax - Vmin) / 100.0;    // calculate peak-to-peak on the HP33120a side
         HP33120A_amplitude = HP33120A_peak_to_peak / 2;    // calculate amplitude value on the HP33120a side
         HP33120A_offset = ( Vmin / 100.0 ) + HP33120A_amplitude;    // calculate offset voltage on the HP33120a side
         
         //    Note: If the target device input impedance differs from the one specified, 
         //    the slew-rate factors will differ by the factor of two or by one-half!
 
         /* EMFT_HP33120B_sinus_flank_wf function parameter description                
             1. parameter - peak-to-peak value - floating point (V) 
             2. parameter - offset - floating point (V)
             3. parameter - frequency - floating point (Hz)
             4. parameter - slew rate rising edge - floating point (V/us) - steepest value is 784 mV/us on open-circuit termination
             5. parameter - slew rate falling edge - floating point (V/us) - steepest value is 784 mV/us on open-circuit termination
             6. parameter - duty cycle in percent - valid values in range 20 ... 80 %
             7. parameter - target impedance: 50 - 50 ohm termination at target input (50), 9.9E+37 - Hi-Z termination at target input (9.9E+37)
             8. parameter - sinus-flank signal draw mode: 0 - abrupt (0), 1 - continuous (1)
         */    
         //    target impedance is: 9.9E+37
         HP33120A_last_err = EMFT_HP33120B_sinus_flank_wf(    10, HP33120A_peak_to_peak, HP33120A_offset, 
                                                             100.0, 1.0E-3, 1.0E-3, 
                                                             50.0, 9.9E+37, 1 );
         
             if ( HP33120A_last_err != 0)    {
                 Log_Error( 4, 1, -5 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );         // -5 );
             }
                 
         /* EMFT_hp33120b_config_trigger_source function parameter description                
             1. parameter - instrument address
             2. parameter - trigger source: 0 - IMMediate, 1 - EXTernal, 2 - BUS        
         */    
         HP33120A_last_err = EMFT_hp33120b_config_trigger_source( 10, trig_source );    // configure the trigger source to immediate on selected module
         
             if ( HP33120A_last_err != 0)    {
                 Log_Error( 4, 1, -9 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );         // -9 );
             }
                 
         uPumps_Excitation_SetOutput(1);     // set generator output on
         
                 
                 
         return ( 0 );    
     }
 
     int uPumps_Excitation_Stop()    
     {
 
         HP33120A_last_err = uPumps_Excitation_SetOutput( 0 );    // set generator output off
         
         /* EMFT_HP33120B_wf_config function parameter description
         1. parameter - waveform shape: "DC", "Sinewave", "Squarewave", "Triangular", "Ramp", "Noise", "Volatile", "Sinc", "Negative ramp", "Exponential Rise", "Exponential Fall", "Cardiac"        
         2. parameter - Not available - name of user setup, stored in the generator
         3. parameter - frequency (10 mHz to 15 MHz)
         4. parameter - peak-to-peak value (50 mVpp to 10 Vpp)
         5. parameter - offset (-10 V to 10 V)
         6. parameter - waveform unit: "VPP", // Volts Peak-To-Peak "VRMS", // Volts rms, "DBM" // dBm ( Note: units change the meaning of amplitude voltage entry! )
         7. parameter - duty cycle in percent - valid values in range 20 ... 80 % for squarewave setting only                
         */        
         HP33120A_last_err = EMFT_HP33120B_wf_config( 10, "DC", "", 1.0E-1, 5.0E-1, 0.0, "VPP", 50.0);    // turn the output off (as much as we can with DC mode and offset 0.0V, since 33120A does not feature output off function)
         
             if ( HP33120A_last_err != 0)    {
                 Log_Error( 4, 1, -10 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );         // -10 );
             }
                 
         /* EMFT_hp33120b_config_trigger_source function parameter description                
             1. parameter - instrument address
             2. parameter - trigger source: 0 - IMMediate, 1 - EXTernal, 2 - BUS        
         */    
         HP33120A_last_err = EMFT_hp33120b_config_trigger_source( 10, 0 );    // configure the trigger source to immediate on selected module        
         
             if ( HP33120A_last_err != 0)    {
                 Log_Error( 4, 1, -9 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );         // -9 );
             }
                 return ( 0 );    
     }
         
     int uPumps_Excitation_Close()
     {
         HP33120A_last_err = EMFT_hp33120b_close( 10 );        // close the reference ID, do not alter the state of instrument
         
             if ( HP33120A_last_err != 0)    {
                 Log_Error( 4, 1, -11 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );         // -11 );
             }
                 return ( 0 );    
     }
 
     
 
 
     
         
         
         
         
     
     
     
     /*    logfile routines library for use with LittleC */
 
     // logfile library definitions are being processed
     
         
     // this symbol denotes, that a logfile library was already included
     // this symbol defines the version of the logfile library
 
     // Error section LOGFILE
     
     
         
     // log file related errors    
     
     // set  error message macro value - no more than 250 characters!
     
     
     
 
     
     
     
     
     
     
     
     
     
     char    fname[250];            // declaration of global constant array (string as 1D char array)
     char    remotefname[250];            // declaration of global constant array (string as 1D char array)
     char    script_fname[250];        // declaration of global constant array (string as 1D char array)
     char    target_folder[250];    // target folder for storing the results onto remote drive, whenever measurements are complete
     char    temp_buffer[250];    // temporary line buffer, used to process file names
     char    wafer_name[20];
     char    dev_name[20];
     int        main_mmt_loop_nr;                // loop number for iterations within the same measurement
     
     // main measurement number, as reported in LIB_CONFIGURATION by macro 1
     int        meas_iteration_nr;        // measurement repetition index from Log file (will increment once per repetition of the same measurement)
     int     SQL_iteration_nr;        // measurement repetition index from SQL database (will increment once per repetition of the same measurement)
 
     int        lot_nr;    
     char    logfile_line_buffer[100];    // log file line buffer, used for general storage of log file line-by-line parsing (as in the case of EMFT_File_FindLine function )
     char    logfile_replace_line_buffer[100];    // log file replacement line buffer, used for general storage of log file line-by-line parsing (as in the case of EMFT_File_ReplaceLine function in SQL library)
     char    logfile_HdrRow_UserVarNames[100];    // log file header row user-defined variable names buffer
     char    logfile_HdrRow_UserVarUnits[100];    // log file header row user-defined variable units buffer
     
     int LogFile_Setup_Open()    
     {
         
         int     resp_len;                        // response length, when in user entry mode
         int        file_handle;
         
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 1, 1, -4 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         resp_len = 0;
         file_handle = 0;
         
                     lot_nr = 6762;
             EMFT_VSnPrintf( dev_name, "%s", "C1003" );        // store constant string into array variable
             EMFT_VSnPrintf( wafer_name, "%s", "W328D2" );    // store constant string into array variable    
         
         EMFT_VSnPrintf( fname, "%s\\MNo%03d_LCS%04d_&%s&_VC%04d_%s_%s.log", "C:\\LittleC_Temp", 1, 1147, "PG017-V1-GK-006", lot_nr, wafer_name, dev_name );    //generate log file name
         
                     EMFT_VSnPrintf( remotefname, "%s\\MNo%03d_LCS%04d_&%s&_VC%04d_%s_%s.log", "T:\\MAF_Durchlauf_Doku\\RR_Chargen\\Alle_Si_Pumpen\\VC6762\\W328D2\\C1003\\LittleC", 1, 1147, "PG017-V1-GK-006", lot_nr, wafer_name, dev_name );    //generate log file name        
             LogFile_CmpLocalRmt();    // compare measurement iteration numbers in local and remote log files        
                 
         file_handle = emft_open_file( fname );     // open local measurement log file
         
         if ( file_handle < 1 )    {
             // invalid file handle, file was not open
             Log_Error( 1, 1, -1 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );         // -1 );
         }
         
         EMFT_VSnPrintf( script_fname, "%s\\MNo%03d_LCS%04d_&%s&_VC%04d_%s_%s.c", "C:\\LittleC_Temp", 1, 1147, "PG017-V1-GK-006", lot_nr, wafer_name, dev_name );    //generate log file name
 
         EMFT_Save_Script_To_File( script_fname );        // store processed LittleC script to results file folder
         
         return ( 0 );    // file open successfully
     }
 
     // Compares measurement iteration numbers, found in local and remote log files
     // this function will return an updated (+1) measurement iteration number
     int LogFile_CmpLocalRmt()    {
     
                     // remote location of log file exists
             
             int copy_status;        
             int local_logfile_mmt_iteration_nr;
             int rmt_logfile_mmt_iteration_nr;
             int err;
             
             copy_status = 0; // reset copy error
             local_logfile_mmt_iteration_nr = 0;
             rmt_logfile_mmt_iteration_nr = 0;
             err = 0;    
             
             EMFT_strcpy( logfile_line_buffer, "iteration:" );        // form line buffer string to be found in the results log file
             // Function EMFT_File_FindLine will find the last occurrence of the string, specified by line buffer string and return the occurrence in the same variable    
             // 1. parameter - file path and name
             // 2. parameter - line buffer string    
             // 3. parameter - return mode ( 0 - line string, starting from specified line buffer string is returned, 1 - entire line, containing line buffer string    is returned
             // 4. parameter - match number ( 0 - invalid value, -1 - last match, 1 - first match, i (positive) i-th match )
             // HIRET Return error values: 
             // HIRET Success 0: line was found and its contents returned in the line buffer string according to specified mode
             // HIRET Error -1: log file does not exist, i.e. was not open by LogFile_Setup_Open routine)
             // Error -2: log file is empty - this is used to detect measurement iteration 1 - line buffer string is not affected
             // Error -3: no occurrences of line buffer string were found in the file - line buffer string is not affected
             // Error -4: no starting terminator occurrences were found in mode 1 - i.e. invalid mode - may be the first (or only) line of the file, so use mode 0
             // Error -5: no ending terminator occurrences were found - file has only a single line
             // Error -6: invalid search number (cannot be zero)
             err = EMFT_File_FindLine( fname, logfile_line_buffer, 0, -1 );        // find the last occurrence of the line, containing string in logfile_line_buffer, return result in logfile_line_buffer
 
             if ( err != 0 )    {
                 // an error occurred
                 if ( ( ( err == -1 ) || ( err == -2 ) )  || ( err == -3 ) )    {
                     // specified file does not exist, is empty or no last occurrence of string was found in the file
                     meas_iteration_nr = 0;    // measurement iteration is 0
                 }
                 else {
                     // some other error occurred - exit
                     Log_Error( 1, 1, -3 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );         // -3 );
                 }
             }
             else {
                 // iteration line was found normally
                 EMFT_VSScanf( logfile_line_buffer, "%*10s%d", meas_iteration_nr);    // scan single integer argument - measurement repetition index
             }
             
             local_logfile_mmt_iteration_nr = meas_iteration_nr;    // store local log file iteration number
                                 
             // repeat the same search procedure in remote log file
             EMFT_strcpy( logfile_line_buffer, "iteration:" );        // form line buffer string to be found in the results log file
             err = EMFT_File_FindLine( remotefname, logfile_line_buffer, 0, -1 );        // find the last occurrence of the line, containing string in logfile_line_buffer, return result in logfile_line_buffer
 
             if ( err != 0 )    {
                 // an error occurred
                 if ( ( ( err == -1 ) || ( err == -2 ) ) || ( err == -3 ) )    {
                     // specified file does not exist, is empty or no last occurrence of string was found in the file
                     meas_iteration_nr = 0;    // measurement iteration is 0
                 }
                 else {
                     // some other error occurred - exit
                     Log_Error( 1, 1, -3 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );         // -3 );
                 }
             }
             else {
                 // iteration line was found normally
                 EMFT_VSScanf( logfile_line_buffer, "%*10s%d", meas_iteration_nr);    // scan single integer argument - measurement repetition index
             }
             
             rmt_logfile_mmt_iteration_nr = meas_iteration_nr;    // store remote log file iteration number
             
             if ( local_logfile_mmt_iteration_nr == 0 )    {
                 // local log file does not exist (may have been deleted)
                 if  ( rmt_logfile_mmt_iteration_nr > 0 ) {
                     // remote log file exists - copy remote log file to local log file
                     EMFT_VSnPrintf( target_folder, "%s", "C:\\LittleC_Temp" );    //form target results folder as local folder
                     copy_status = EMFT_Copy_File( remotefname, target_folder);
                     meas_iteration_nr = rmt_logfile_mmt_iteration_nr + 1;    // new measurement iteration number is taken from remote log file
                 }
                 else    {
                     // neither local, nor remote log file exist - this is a completely new measurement
                     meas_iteration_nr = 1;    // reset measurement iteration number
                 }
 
             } 
             else {
                 // local log file exists:
                 if  ( local_logfile_mmt_iteration_nr < rmt_logfile_mmt_iteration_nr ) {
                     // local log file contains less iterations as remote log file - copy remote log file to local location    
                     //EMFT_VSnPrintf( target_folder, "%s", "C:\\LittleC_Temp" );    //form target results folder as local folder
                     
                     copy_status = EMFT_Append_Files( fname, remotefname, fname );    
                         
                     //copy_status = EMFT_Copy_File( remotefname, target_folder);
                     meas_iteration_nr = rmt_logfile_mmt_iteration_nr + 1;    // new measurement iteration number is taken from remote log file
                     
                 }
                 else {
                     // local log file contains more or same iterations as remote log file - copy local log file to remote location    
                     EMFT_VSnPrintf( target_folder, "%s", "T:\\MAF_Durchlauf_Doku\\RR_Chargen\\Alle_Si_Pumpen\\VC6762\\W328D2\\C1003\\LittleC" );        // form target results folder as remote folder
                     copy_status = EMFT_Copy_File( fname, target_folder);    // copy local log file to remote log file                                    
                     meas_iteration_nr = local_logfile_mmt_iteration_nr + 1;    // new measurement iteration number is taken from local log file                
                     
                 }
                 
             }
             
                 
         return ( 0 );    // file copied successfully
 
     }
 
     int LogFile_Copy_Results()    
     {        
                 
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 1, 1, -4 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }
             
             // remote folder was specified, copy the files to remote location
             int copy_status;
         
             copy_status = 0; // reset copy error
             
             EMFT_VSnPrintf( script_fname, "%s\\MNo%03d_LCS%04d_&%s&_VC%04d_%s_%s*.*", "C:\\LittleC_Temp", 1, 1147, "PG017-V1-GK-006", lot_nr, wafer_name, dev_name );    //form source results copy string
             
             EMFT_VSnPrintf( target_folder, "%s", "T:\\MAF_Durchlauf_Doku\\RR_Chargen\\Alle_Si_Pumpen\\VC6762\\W328D2\\C1003\\LittleC" );    //form target results folder
             
             copy_status = EMFT_Copy_File( script_fname, target_folder);        // store processed LittleC results to specified file folder on remote drive
             
             if ( copy_status != 0)    {
                 Log_Error( 1, 1, -2 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );         // -2 );
             }
             
                 
         return ( 0 );    // file copied successfully
     }
 
     int LogFile_GetMmtIterationNr()    {
         
         int err;    
         err = 0;
         
         EMFT_strcpy( logfile_line_buffer, "iteration:" );        // form line buffer string to be found in the results log file
             // Function EMFT_File_FindLine will find the last occurrence of the string, specified by line buffer string and return the occurrence in the same variable    
             // 1. parameter - file path and name (i.e. log file name and path)
             // 2. parameter - line buffer string    
             // 3. parameter - return mode ( 0 - line string, starting from specified line buffer string is returned, 1 - entire line, containing line buffer string    is returned
             // 4. parameter - match number ( 0 - invalid value, -1 - last match, 1 - first match, i (positive) i-th match )
             // HIRET Return error values: 
             // HIRET Success 0: line was found and its contents returned in the line buffer string according to specified mode
             // HIRET Error -1: log file does not exist, i.e. was not open by LogFile_Setup_Open routine)
             // Error -2: log file is empty - this is used to detect measurement iteration 1 - line buffer string is not affected
             // Error -3: no occurrences of line buffer string were found in the file - line buffer string is not affected
             // Error -4: no starting terminator occurrences were found in mode 1 - i.e. invalid mode - may be the first (or only) line of the file, so use mode 0
             // Error -5: no ending terminator occurrences were found - file has only a single line
             // Error -6: invalid search number (cannot be zero)
         err = EMFT_File_FindLine( fname, logfile_line_buffer, 0, -1 );        // find the last occurrence of the line, containing string in logfile_line_buffer, return result in logfile_line_buffer
 
         if ( err != 0 )    {
             // an error occurred
             if ( ( err == -2 ) || ( err == -3 ) )    {
                 // specified file is empty or no last occurrence of string was found in the file
                 meas_iteration_nr = 1;    // measurement iteration is 1
             }
             else {
                 // some other error occurred - exit
                 Log_Error( 1, 1, -3 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );         // -3 );
             }
         }
         else {
             // iteration line was found normally - increment it
             EMFT_VSScanf( logfile_line_buffer, "%*10s%d", meas_iteration_nr);    // scan single integer argument - measurement repetition index
             meas_iteration_nr = meas_iteration_nr + 1;    // increment measurement repetition index
         }
         
         return ( 0 );    // measurement iteration number
     }
 
     int LogFile_WriteHeader()
     {    double HiVolt;
         double LoVolt;
         
         int err;    
         err = 0;
         
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 1, 1, -4 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         // get current measurement iteration number
         //LogFile_GetMmtIterationNr();
         
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t*****\tMeasurement:\t");    emft_write_string("FLOW VS BACK PRESSURE AND EXCITATION FREQUENCY WITH UNDERPRESSURE FOR WATER"); emft_write_string("\t*****\r\n");
         
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\tMeasurement number:\t");    emft_write_var(1); emft_write_string(", iteration:\t");    emft_write_var(meas_iteration_nr); emft_write_string("\r\n");
 
 
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t1\tTest environment:\r\n");
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t1.1\tRun by:\t");        emft_write_string("pc-l109n08");                 emft_write_string("\r\n");
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t1.2\tRun on:\t");        emft_write_string("PC-L109-08");            emft_write_string("\r\n");
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t1.3\tIP address:\t");    emft_write_string("169.254.142.73");    emft_write_string("\r\n");
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t1.4\tRun using:\t");    emft_write_string("Little C scripter -- Ver.: 1.0.0.0, built on: Jul 17 2020 at 14:22:28");                emft_write_string("\r\n");
 
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t1.5\tScript:\r\n");
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t1.5.1\tName:\t");        emft_write_string("T:/MAF_Durchlauf_Doku/ArbPl_Mess_und_Prozessequipment/Scripte/LittleC_SCRIPTS_2/LCS1147.c");                 emft_write_string("\r\n");        
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t1.5.2\tVersion:\t");    emft_write_string("MM1_MW1");         emft_write_string("\r\n");                
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t1.5.3\tLoad time:\t");    emft_write_string("2021_03_15_08_54_54");         emft_write_string("\r\n");
         
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t1.6\tLibrary versions:\r\n");        
                     emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t1.6.1\tCommon:\t");    emft_write_string("MM7_MW5_AK1"); emft_write_string("\r\n");
                 
                     emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t1.6.2\tMicropumps:\t");    emft_write_string("MM5_MW8"); emft_write_string("\r\n");
                 
                     emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t1.6.3\tMENSOR CPC3000 pressure regulator:\t");    emft_write_string("MM5_MW6"); emft_write_string("\r\n");
                 
                     emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t1.6.4\tHP33120 frequency generator:\t");    emft_write_string("MM4_MW2"); emft_write_string("\r\n");
                 
                 
                     emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t1.6.6\tBronkhorst-FlowBus:\t");    emft_write_string("MM5_MW1"); emft_write_string("\r\n");
                 
                 
                 
                     emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t1.6.8\tBeckhoff valves:\t");    emft_write_string("MM1_MW3"); emft_write_string("\r\n");
                 
                     emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t1.6.8\tBeckhoff pressure sensors:\t");    emft_write_string("MM1"); emft_write_string("\r\n");
                 
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2\tMeasurement site:\t"); emft_write_string("PC-L109-08"); emft_write_string("\r\n");
         
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1\tInstruments used:\r\n");
         
                     emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.1.1\tBronkhorst DEV 1:\r\n");
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.1.1.1\tUser Tag:\t");         emft_write_string(FlB_Dev1_UserTag);    emft_write_string("\r\n");
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.1.1.2\tDevice Type:\t");     emft_write_string(FlB_Dev1_DevTyp);        emft_write_string("\r\n");
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.1.1.3\tSerial number:\t");     emft_write_string(FlB_Dev1_SN);            emft_write_string("\r\n");
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.1.1.4\tAlarm Info:\t");         emft_write_var(FlB_Dev1_AlarmInfo);     emft_write_string("\r\n");
                             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.1.1.5\tFMMT units:\t");     emft_write_string(FlB_Dev1_fmmt_units);            emft_write_string("\r\n");            
                         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.1.1.6\tStability buffer:\r\n");
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.1.1.6.1\tSize:\t");     emft_write_var(20);    emft_write_string("\r\n");    
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.1.1.6.2\tStd. deviation:\t");     emft_write_var(1.0E-1);    emft_write_string("\r\n");    
             
         
                     emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.1.2\tBronkhorst DEV 2:\r\n");
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.1.2.1\tUser Tag:\t");         emft_write_string(FlB_Dev2_UserTag);    emft_write_string("\r\n");
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.1.2.2\tDevice Type:\t");     emft_write_string(FlB_Dev2_DevTyp);        emft_write_string("\r\n");
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.1.2.3\tSerial number:\t");     emft_write_string(FlB_Dev2_SN);            emft_write_string("\r\n");
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.1.2.4\tAlarm Info:\t");         emft_write_var(FlB_Dev2_AlarmInfo);     emft_write_string("\r\n");
                             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.1.2.5\tFMMT units:\t");     emft_write_string(FlB_Dev2_fmmt_units);            emft_write_string("\r\n");            
                         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.1.2.6\tStability buffer:\r\n");
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.1.2.6.1\tSize:\t");     emft_write_var(20);    emft_write_string("\r\n");    
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.1.2.6.2\tStd. deviation:\t");     emft_write_var(1.0E-1);    emft_write_string("\r\n");    
             
                 
                 
                 
             
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.2.1\tMensor CPC3000 pressure controller DEV 1:\r\n");
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.2.1.1\tName:\t");     emft_write_string("P_OUTLET");    emft_write_string("\r\n");
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.2.1.2\tSerial number:\t");     emft_write_string("MENSOR810617");    emft_write_string("\r\n");    
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.2.1.3\tStability buffer:\r\n");
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.2.1.3.1\tSize:\t");     emft_write_var(10);    emft_write_string("\r\n");    
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.2.1.3.2\tStd. deviation:\t");     emft_write_var(1.0);    emft_write_string("\r\n");    
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.2.1.3.3\tTimeout:\t");     emft_write_var(120000.0);    emft_write_string(" ms\r\n");
 
                         
             
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.2.2\tMensor CPC3000 pressure controller DEV 2:\r\n");                
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.2.2.1\tName:\t");     emft_write_string("P_INLET");    emft_write_string("\r\n");
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.2.2.2\tSerial number:\t");     emft_write_string("MENSOR810615");    emft_write_string("\r\n");
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.2.2.3\tStability buffer:\r\n");
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.2.2.3.1\tSize:\t");     emft_write_var(10);    emft_write_string("\r\n");    
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.2.2.3.2\tStd. deviation:\t");     emft_write_var(1.0);    emft_write_string("\r\n");    
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.2.2.3.3\tTimeout:\t");     emft_write_var(120000.0);    emft_write_string(" ms\r\n");
 
                         
                 
                     emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.3\tHP33120A frequency generator:\r\n");
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.3.1\tSerial number:\t");     emft_write_string(HP33120A_SerialNr);    emft_write_string("\r\n");
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.4\tHigh voltage amplifier:\r\n");
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.4.1\tModel:\t");             emft_write_string("SVR-500");     emft_write_string("\r\n");                                    
                 
                 
         
     
             
             
             
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.7.3\tBeckhoff Line B, PS1:\r\n");
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.7.3.1\tCh.:\t");     emft_write_var(2);         emft_write_string("\r\n");
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.7.3.2\tCal. Date:\t");     emft_write_string("04.02.2020");         emft_write_string("\r\n");
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.7.3.3\tCal. Exp. Date:\t");     emft_write_string("01.01.2022");         emft_write_string("\r\n");
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.7.4.4\tStability buffer:\r\n");
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.7.4.4.1\tSize:\t");     emft_write_var(10);    emft_write_string("\r\n");    
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.7.4.4.2\tStd. deviation:\t");     emft_write_var(5);    emft_write_string("\r\n");    
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.7.4.4.3\tTimeout:\t");     emft_write_var( 50000 );    emft_write_string(" ms\r\n");
             
             
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.7.4\tBeckhoff Line B, PS2:\r\n");
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.7.4.1\tCh.:\t");     emft_write_var(3);         emft_write_string("\r\n");
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.7.4.2\tCal. Date:\t");     emft_write_string("04.02.2020");         emft_write_string("\r\n");
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.7.4.3\tCal. Exp. Date:\t");     emft_write_string("01.01.2022");         emft_write_string("\r\n");
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.7.4.4\tStability buffer:\r\n");
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.7.4.4.1\tSize:\t");     emft_write_var(10);    emft_write_string("\r\n");    
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.7.4.4.2\tStd. deviation:\t");     emft_write_var(5);    emft_write_string("\r\n");    
                 emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t2.1.7.4.4.3\tTimeout:\t");     emft_write_var( 50000 );    emft_write_string(" ms\r\n");
                     
                 
         
                     emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t3\tMicropump-under-test:\r\n");
                 
         
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t3.1\tType:\t");    emft_write_string("uP029_M30_K200_sl4"); emft_write_string("\r\n");
                 
         
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t3.2\tTest medium:\t");    emft_write_string("WATER"); emft_write_string("\r\n");
                 
         
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t3.3\tMaterial:\t");    emft_write_string("SILICON"); emft_write_string("\r\n");
                 
                     HiVolt = 90.0;
             LoVolt = -30.0;
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t3.4\tActuation:\r\n");
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t3.4.1\tHiLevel:\t");    emft_write_var(HiVolt); emft_write_string(" V\r\n");
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t3.4.2\tLoLevel:\t");    emft_write_var(LoVolt); emft_write_string(" V\r\n");
                 
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t3.5\tDevice ID: \t");        emft_write_string(dev_name);                 emft_write_string("\r\n");
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t3.6\tLot ID:\t");             emft_write_var(lot_nr);                     emft_write_string("\r\n");
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t3.7\tWafer ID:\t");         emft_write_string(wafer_name);                 emft_write_string("\r\n");            
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t*****\tStart of measurement:\t");    emft_write_string("FLOW VS BACK PRESSURE AND EXCITATION FREQUENCY WITH UNDERPRESSURE FOR WATER");     emft_write_string("\t*****\r\n");
         
         return ( 0 );    // header written successfully
     }
     
     int LogFile_WritePiezoData()
     {
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 1, 1, -4 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
                     // log the high-voltage piezo amplifier maximum voltage, minimum voltage, amplification
             emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\tAmplifier "); emft_write_string("SVR-500");
             emft_write_string(" configured:\t Vmax= 90.0 V\t Vmin = -30.0 V\t Au = 100.0 V/V\r\n");    
             
         return ( 0 );
     }
     
     int Log2Float( float a, float b )    {
     
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 1, 1, -4 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         emft_write_current_timestamp();    emft_write_string(" \t");
         emft_write_var( meas_iteration_nr );     emft_write_string(" \t");
         emft_write_var( main_mmt_loop_nr );     emft_write_string(" \t"); 
         emft_write_var( a );     emft_write_string(" \t");     
         emft_write_var( b );    emft_write_string(" \t");    
                 emft_write_string("\r\n");
         return ( 0 );    
     }
 
     int Log3Float( float a, float b, float c )    {
         
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 1, 1, -4 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         emft_write_current_timestamp();    emft_write_string(" \t");
         emft_write_var( meas_iteration_nr );     emft_write_string(" \t");
         emft_write_var( main_mmt_loop_nr );     emft_write_string(" \t"); 
         emft_write_var( a );     emft_write_string(" \t");     
         emft_write_var( b );     emft_write_string(" \t");     
         emft_write_var( c );    emft_write_string(" \t");    
                 emft_write_string("\r\n");
         return ( 0 );    
     }
 
     int Log4Float( float a, float b, float c, float d )    {
     
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 1, 1, -4 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         emft_write_current_timestamp();    emft_write_string(" \t");
         emft_write_var( meas_iteration_nr );     emft_write_string(" \t");
         emft_write_var( main_mmt_loop_nr );     emft_write_string(" \t"); 
         emft_write_var( a );     emft_write_string(" \t");     
         emft_write_var( b );     emft_write_string(" \t");     
         emft_write_var( c );     emft_write_string(" \t");     
         emft_write_var( d );    emft_write_string(" \t");
                 emft_write_string("\r\n");        
         return ( 0 );    
     }
 
     int Log5Float( float a, float b, float c, float d, float e )    {
     
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 1, 1, -4 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         emft_write_current_timestamp();    emft_write_string(" \t"); 
         emft_write_var( meas_iteration_nr );     emft_write_string(" \t");
         emft_write_var( main_mmt_loop_nr );     emft_write_string(" \t");
         emft_write_var( a );     emft_write_string(" \t");     
         emft_write_var( b );     emft_write_string(" \t");     
         emft_write_var( c );     emft_write_string(" \t");     
         emft_write_var( d );     emft_write_string(" \t");         
         emft_write_var( e );    emft_write_string(" \t");
                 emft_write_string("\r\n");
         return ( 0 );    
     }
 
     int Log6Float( float a, float b, float c, float d, float e, float f )    {
     
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 1, 1, -4 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         emft_write_current_timestamp();    emft_write_string(" \t");
         emft_write_var( meas_iteration_nr );     emft_write_string(" \t");
         emft_write_var( main_mmt_loop_nr );     emft_write_string(" \t"); 
         emft_write_var( a );     emft_write_string(" \t");     
         emft_write_var( b );     emft_write_string(" \t");     
         emft_write_var( c );     emft_write_string(" \t");     
         emft_write_var( d );     emft_write_string(" \t");     
         emft_write_var( e );     emft_write_string(" \t");     
         emft_write_var( f );    emft_write_string(" \t");        
                 emft_write_string("\r\n");
         return ( 0 );    
     }
 
     int Log7Float( float a, float b,  float c, float d, float e, float f, float g )    {
     
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 1, 1, -4 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         emft_write_current_timestamp();    emft_write_string(" \t");
         emft_write_var( meas_iteration_nr );     emft_write_string(" \t");
         emft_write_var( main_mmt_loop_nr );     emft_write_string(" \t");
         emft_write_var( a );     emft_write_string(" \t"); 
         emft_write_var( b );    emft_write_string(" \t");
         emft_write_var( c );    emft_write_string(" \t"); 
         emft_write_var( d );    emft_write_string(" \t"); 
         emft_write_var( e );    emft_write_string(" \t"); 
         emft_write_var( f );    emft_write_string(" \t");     
         emft_write_var( g );    emft_write_string(" \t");
                 emft_write_string("\r\n");    
         return ( 0 );    
     }
 
     int Log1Dbl2Float( double a, float b,  float c )    {
     
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 1, 1, -4 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         emft_write_current_timestamp();    emft_write_string(" \t"); 
         emft_write_var( meas_iteration_nr );     emft_write_string(" \t");
         emft_write_var( main_mmt_loop_nr );     emft_write_string(" \t");
         emft_write_var( a );     emft_write_string(" \t"); 
         emft_write_var( b );    emft_write_string(" \t");    
         emft_write_var( c );    emft_write_string(" \t");    
                 emft_write_string("\r\n");
         return ( 0 );    
     }
 
     int Log1Dbl3Float( double a, float b,  float c, float d )    {
     
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 1, 1, -4 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         emft_write_current_timestamp();    emft_write_string(" \t");         
         emft_write_var( meas_iteration_nr );     emft_write_string(" \t");
         emft_write_var( main_mmt_loop_nr );     emft_write_string(" \t");
         emft_write_var( a );     emft_write_string(" \t"); 
         emft_write_var( b );    emft_write_string(" \t");
         emft_write_var( c );    emft_write_string(" \t"); 
         emft_write_var( d );    emft_write_string(" \t");
                 emft_write_string("\r\n");
         return ( 0 );    
     }
 
     int Log1Dbl4Float( double a, float b,  float c, float d, float e )    {
     
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 1, 1, -4 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         emft_write_current_timestamp();    emft_write_string(" \t");         
         emft_write_var( meas_iteration_nr );     emft_write_string(" \t");
         emft_write_var( main_mmt_loop_nr );     emft_write_string(" \t");
         emft_write_var( a );     emft_write_string(" \t"); 
         emft_write_var( b );    emft_write_string(" \t");
         emft_write_var( c );    emft_write_string(" \t"); 
         emft_write_var( d );    emft_write_string(" \t"); 
         emft_write_var( e );    emft_write_string(" \t");
                 emft_write_string("\r\n");
         return ( 0 );    
     }
     int Log1Dbl5Float( double a, float b,  float c, float d, float e, float f )    {
     
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 1, 1, -4 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         emft_write_current_timestamp();    emft_write_string(" \t");         
         emft_write_var( meas_iteration_nr );     emft_write_string(" \t");
         emft_write_var( main_mmt_loop_nr );     emft_write_string(" \t");
         emft_write_var( a );     emft_write_string(" \t"); 
         emft_write_var( b );    emft_write_string(" \t");
         emft_write_var( c );    emft_write_string(" \t"); 
         emft_write_var( d );    emft_write_string(" \t"); 
         emft_write_var( e );    emft_write_string(" \t");
         emft_write_var( f );    emft_write_string(" \t");
                 emft_write_string("\r\n");
         return ( 0 );    
     }    
 
     int Log1Dbl6Float( double a, float b,  float c, float d, float e, float f, float g )    {
     
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 1, 1, -4 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         emft_write_current_timestamp();    emft_write_string(" \t");         
         emft_write_var( meas_iteration_nr );     emft_write_string(" \t");
         emft_write_var( main_mmt_loop_nr );     emft_write_string(" \t");
         emft_write_var( a );     emft_write_string(" \t"); 
         emft_write_var( b );    emft_write_string(" \t");
         emft_write_var( c );    emft_write_string(" \t"); 
         emft_write_var( d );    emft_write_string(" \t"); 
         emft_write_var( e );    emft_write_string(" \t");
         emft_write_var( f );    emft_write_string(" \t");
         emft_write_var( g );    emft_write_string(" \t");        
                 emft_write_string("\r\n");
         return ( 0 );    
     }    
     
     int Log1Dbl7Float( double a, float b,  float c, float d, float e, float f, float g, float h  )    {
     
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 1, 1, -4 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         emft_write_current_timestamp();    emft_write_string(" \t");         
         emft_write_var( meas_iteration_nr );     emft_write_string(" \t");
         emft_write_var( main_mmt_loop_nr );     emft_write_string(" \t");
         emft_write_var( a );     emft_write_string(" \t"); 
         emft_write_var( b );    emft_write_string(" \t");
         emft_write_var( c );    emft_write_string(" \t"); 
         emft_write_var( d );    emft_write_string(" \t"); 
         emft_write_var( e );    emft_write_string(" \t");
         emft_write_var( f );    emft_write_string(" \t");
         emft_write_var( g );    emft_write_string(" \t");
         emft_write_var( h );    emft_write_string(" \t");
                 emft_write_string("\r\n");
         return ( 0 );    
     }        
 
     int LogMmtHeaderRow()    {
         
         int logfile_HdrRow_UserVarNamesLen;
         int logfile_HdrRow_UserVarUnitsLen;
         
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 1, 1, -4 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         // form header of the measurement results file
         //1. row name of columns
         emft_write_current_timestamp();    emft_write_string("\tIterNr\tMmtLoopNr\t");
                 
         // no HP33120A voltage scan was defined - micropump amplitude is fixed
                     // script has a frequency scan
             emft_write_string( "f" ); emft_write_string("\t");
             
                 
                 
                     // Mensor CPC3000 device 1 library was included
             emft_write_string( "P_OUTLET" ); emft_write_string("\t");    
                 
         
                 
         
         // FlowBus device 1 is used
                     // FlowBus device 1 floating point measurement is used
             emft_write_string( "Q1" ); emft_write_string("\t"); 
                 
         // FlowBus device 2 is used
                     // FlowBus device 2 floating point measurement is used
             emft_write_string( "Q2" ); emft_write_string("\t"); 
                 
                 
         
         
         
                     
                 
                 
                 
                     // Beckhoff pressure sensor 1 on Line B was included
             emft_write_string( "B_PS1" ); emft_write_string("\t");    
         
                     // Beckhoff pressure sensor 2 on Line B was included
             emft_write_string( "B_PS2" ); emft_write_string("\t");
                         
                 
         logfile_HdrRow_UserVarNamesLen = EMFT_strlen(logfile_HdrRow_UserVarNames);
         
         if ( logfile_HdrRow_UserVarNamesLen > 0 )    {
             // append the user variable names string, if there were appended previously
             emft_write_string(logfile_HdrRow_UserVarNames);
         }
         
         emft_write_string("\r\n"); // finalize header line
 
         emft_write_current_timestamp();    emft_write_string("\t\t\t");    // start units header line, skip mmt iteration number and main loop iteration number
         
         // no HP33120A voltage scan was defined - micropump amplitude is fixed
                     // script has a frequency scan
             emft_write_string("[");    emft_write_string( "Hz" ); emft_write_string("]\t"); 
                 
         
                     
                     // Mensor CPC3000 device 1 library was included
             emft_write_string("[");    emft_write_string( "hPa" ); emft_write_string("]\t");    
                 
                 
                 
                 
                     // FlowBus device 1 floating point measurement is used    
             emft_write_string("["); emft_write_string(FlB_Dev1_fmmt_units); emft_write_string("]\t");     
                 
                     // FlowBus device 2 floating point measurement is used    
             emft_write_string("["); emft_write_string(FlB_Dev2_fmmt_units); emft_write_string("]\t");     
                 
                 
         
         
         
         
         
                 
                 
                     // Beckhoff pressure sensor 1 on Line B was included
             emft_write_string("[");    emft_write_string( "hPa" ); emft_write_string("]\t");    
                 
                     // Beckhoff pressure sensor 2 on Line B was included
             emft_write_string("[");    emft_write_string( "hPa" ); emft_write_string("]\t");    
                         
                 
         logfile_HdrRow_UserVarUnitsLen = EMFT_strlen(logfile_HdrRow_UserVarUnits);
         
         if ( logfile_HdrRow_UserVarUnitsLen > 0 )    {
             // append the user variable units string, if there were appended previously
             emft_write_string(logfile_HdrRow_UserVarUnits);
         }
         
         emft_write_string("\r\n"); // finalize header units line    
         
         return ( 0 );    
     }
 
     int LogFile_MarkHeaderStop()
     {        
         int linecount;
         
         if (Signal_goto_safe_state != 0 )    {
             // user interrupted the script execution - entirely skip action
             Log_Error( 1, 1, -4 );    // log the error onto console and into log file (if available)
             return ( lc_err_code_nr );    // exit with error code return
         }
         
         linecount = EMFT_Get_File_LineCount();
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\tHeaderStop:\t");    emft_write_var(linecount); emft_write_string("\r\n");
         return ( 0 );    
     }
     
     int LogFile_Close()    
     {
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t*****\tEXIT ERROR NUMBER:\t");    emft_write_var(lc_err_code_nr); emft_write_string("\t*****\r\n");
         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t*****\tEnd of measurement:\t");    emft_write_string("FLOW VS BACK PRESSURE AND EXCITATION FREQUENCY WITH UNDERPRESSURE FOR WATER"); emft_write_string("\t*****\r\n");
         emft_close_file();    
         return ( 0 );    
     }
 
     // SIGNAL library -    asynchronous signal routines library for use with LittleC
 
     
         
     // this symbol denotes, that a SIGNAL library was already included
     // this symbol defines the version of the SIGNAL library
     
     // Error section SIGNAL
     
     
     
     // SIGNAL related errors    
     
     // set  error message macro value - no more than 250 characters!
     
     // panel key press event handler number
 
     // Signal library related variables
     int Signal_err;
     int Signal_goto_safe_state;
 
     // Panel keypress event handler
     // Lower byte represents an ASCII key code, upper byte represents virtual key
     // Virtual keys are: 
     //    DELETE = 0x0100        BACKSPACE = 0x0200    ESC = 0x0300         TAB = 0x0400         ENTER = 0x0500
     //    UP_ARROW = 0x0600    DOWN_ARROW = 0x0700    LEFT_ARROW = 0x0800    RIGHT_ARROW = 0x0900
     //    INSERT = 0x0A00         HOME = 0x0B00         END = 0x0C00         PAGE_UP = 0x0D00    PAGE_DOWN = 0x0E00
     //    F1 = 0x0F00    F2 = 0x1000    F3 = 0x1100    F4 = 0x1200    F5 = 0x1300    F6 = 0x1400    F7 = 0x1500    F8 = 0x1600    F9 = 0x1700    F10 = 0x1800    F11 = 0x1900    F12 = 0x1A00
 
     int Signal_Keypress_Handler( int key )    {
         // Panel keypress event handler
         if ( key == 'x' )    {            
             // set the global exit variable
             Signal_goto_safe_state = 1;
             
                             uPumps_Excitation_Stop();    // stop micropump excitation                    
                         
                             Pressure_Controller1_Stop(1);        // set standby mode on the controller - do not apply pressure on the micropump
                         
                             Pressure_Controller2_Stop(1);        // set standby mode on the controller - do not apply pressure on the micropump
                         
 //            while ( 1 );     // sit here until user decides to abort the program
         }
         
         return ( 0 );
     }
     
     int Signal_Setup()        {        
         // reset the global exit variable and install a new panel keypress handler
         Signal_goto_safe_state = 0;    // reset the global exit variable
         
         // install a new panel keypress handler
         Signal_err = EMFT_Signal( 124, Signal_Keypress_Handler );
 
         
             if ( Signal_err != 0)    {
                 Log_Error( 14, 1, -1 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );         // -1 );
             }
                 
         return ( 0 );    
     }
 
 
     int Signal_SetSafeState()        {
         // safely stop all excitation devices, which might damage the DUT
         if ( Signal_goto_safe_state != 0 )    {
         
             puts("Script execution interrupted!\n");
                 
                             uPumps_Excitation_Stop();    // stop micropump excitation                    
                         
                             Pressure_Controller1_Stop(1);        // set standby mode on the controller - do not apply pressure on the micropump
                         
                             Pressure_Controller2_Stop(1);        // set standby mode on the controller - do not apply pressure on the micropump
                             
             
                 if ( Signal_err != 0)    {
                     Log_Error( 14, 1, -1 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );         // -1 );
                 }
                         
         }
         
         return ( 0 );    
     }
 
     
 
     
 
 
     // MEASUREMENT DEFINITIONS, INDEPENDENT OF MEASUREMENT PUMP, FLOW AND SITE
     // downward pressure direction control constant
     // no pressure change control constant
     // upward pressure direction control
 
 /*    logfile routines library for use with LittleC */
 
     // SQL library definitions are being processed
     
         
     // this symbol denotes, that a SQL library was already included
     // this symbol defines the version of the SQL library
 
     
     
     
     
             // Water measurement station L1.09
         // define this symbol to use sql connection at all
         // use localhost or 127.0.0.1 for current machine, otherwise remote machine ip
         
         
         // EMFT test database name
 
     
     // client connection flag, which allows multiple statements (separated by semicolon) per single query
     // EMFT test database name, use parentheses and + operator to perform or operation between flags e.g. 65536
     // EMFT TCP connection port number - use 0 for default port 3306, actual port is listed in my.ini file
 
             // (if not using named connection, assign empty string)    
         
             // pipe name not defined - force default named pipe value
             
             
     // EMFT test database, table test_stations connection identification string
     // EMFT test database, table test_setups connection identification string
     // EMFT test database, table chargen connection identification string
     // EMFT test database, table wafer connection identification string
     // EMFT test database, table waferstacks connection identification string
     // EMFT test database, table messinfo connection identification string
     // EMFT test database, table devices connection identification string
     // EMFT test database, table devtypen connection identification string
     // EMFT test database, table skripte connection identification string
     // EMFT test database, table messungen connection identification string
     // EMFT test database, table messwertelittlec connection identification string
 
     // Error section SQL
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
 
     
     
     
     
     
 
     
     
     
     
     
 
     
     
 
     
     
 
     
     
 
     
     
     
     
     
     
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
     
     
     
 
     
     
 
     
     
 
     
     
         
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
 
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
 
     
     
 
     
     
     
     
     
     
     char    sql_query[3000];                    // general purpose SQL query buffer string (max. length supported by query is 5000)
     char    sql_string_macro[255];                // general purpose temporary string buffer string used for storing macro
     char    sql_string_macro1[255];                // another general purpose temporary string buffer string used for storing macro
     float    sql_float_macro;                    // general purpose temporary floating point value used for storing macros
 
     int        sql_chargen_id;
     int        sql_wafer_id;
     int        sql_waferstacks_id;
     int        sql_dev_types_id;                // index FROM table devicetypen (e.g. MIKROAUG micropump type )
     int        sql_devices_id;                    // index FROM table devices (formed from unique device type, wafer id and charge id)
     int        sql_script_id;                    // index FROM table skripte (e.g. LCS0130)
     int        sql_mmt_data_id;                // index FROM table messungen (based on unique index from test setup (optional)
     int        sql_mmt_values_id;                // index FROM table messwertelittlec (based on unique index from messungen
 
     int        sql_test_station_id;            // index FROM table teststations (formed from LittleC macro "PC-L109-08")
     int        sql_test_setup_id;                // index FROM table testsetups
 
     int SQL_EstablishConns()    {
         
         int SQL_err;
                 
                             
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 8, 1, -49 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }        
             
             // reset all indices
             sql_chargen_id = 0;        sql_wafer_id = 0;        sql_dev_types_id = 0;    sql_devices_id = 0;        sql_script_id = 0;        sql_mmt_data_id = 0;    sql_test_setup_id = 0;        sql_mmt_values_id = 0;    sql_waferstacks_id = 0;
             
             // EMFT_SQL_Connect function connects to a predefined server using specified user name, password and tSQL_arget database
             // 1. parameter - SQL connection ID string
             // 2. parameter - SQL host id string
             // 3. parameter - SQL UserName string
             // 4. parameter - SQL password string
             // 5. parameter - SQL database string
             // 6. parameter - SQL port number
             // 7. parameter - SQL unix socket string
             // 8. parameter - SQL client connection flags
             //    All parameters may be a constant text value in double-quotes or a global string variable. 
             //    May contain special characters: '\a', '\b', '\t', '\n', '\v', '\f', '\r', '\"', '\'', '\?', '\\', '\0'
 
             SQL_err = EMFT_SQL_Connect( "test_setups", "dosdb.pc.muc.loc", "DOS_MESSKNECHT", "DerGoldschatz!!", "dos_datenbank", 0, "", 0 );        // open connection to test_stations table
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -2 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -2 );    // exit with error code, error message is reported on the console 
             }
 
             SQL_err = EMFT_SQL_Connect( "test_stations", "dosdb.pc.muc.loc", "DOS_MESSKNECHT", "DerGoldschatz!!", "dos_datenbank", 0, "", 0 );        // open connection to test_stations table
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -1 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -1 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_err = EMFT_SQL_Connect( "chargen", "dosdb.pc.muc.loc", "DOS_MESSKNECHT", "DerGoldschatz!!", "dos_datenbank", 0, "", 0 );        // open connection to chargen table
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -3 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -3 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_err = EMFT_SQL_Connect( "wafer", "dosdb.pc.muc.loc", "DOS_MESSKNECHT", "DerGoldschatz!!", "dos_datenbank", 0, "", 0 );    // open connection to wafer table
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -4 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -4 );    // exit with error code, error message is reported on the console 
             }
 
             SQL_err = EMFT_SQL_Connect( "waferstacks", "dosdb.pc.muc.loc", "DOS_MESSKNECHT", "DerGoldschatz!!", "dos_datenbank", 0, "", 0 );    // open connection to waferstacks table
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -4 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -4 );    // exit with error code, error message is reported on the console 
             }
 
             SQL_err = EMFT_SQL_Connect( "mess_info", "dosdb.pc.muc.loc", "DOS_MESSKNECHT", "DerGoldschatz!!", "dos_datenbank", 0, "", 0 );    // open connection to measurement information table
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -5 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -5 );    // exit with error code, error message is reported on the console 
             }
 
             SQL_err = EMFT_SQL_Connect( "devices", "dosdb.pc.muc.loc", "DOS_MESSKNECHT", "DerGoldschatz!!", "dos_datenbank", 0, "", 0 );    // open connection to devices table
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -6 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -6 );    // exit with error code, error message is reported on the console 
             }
 
             SQL_err = EMFT_SQL_Connect( "device_types", "dosdb.pc.muc.loc", "DOS_MESSKNECHT", "DerGoldschatz!!", "dos_datenbank", 0, "", 0 );    // open connection to device types table
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -7 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -7 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_err = EMFT_SQL_Connect( "scripts", "dosdb.pc.muc.loc", "DOS_MESSKNECHT", "DerGoldschatz!!", "dos_datenbank", 0, "", 0 );    // open connection to skripte table
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -8 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -8 );    // exit with error code, error message is reported on the console 
             }
 
             SQL_err = EMFT_SQL_Connect( "mmt_hdr", "dosdb.pc.muc.loc", "DOS_MESSKNECHT", "DerGoldschatz!!", "dos_datenbank", 0, "", 0 );    // open connection to messungen table
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -9 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -9 );    // exit with error code, error message is reported on the console 
             }
 
             SQL_err = EMFT_SQL_Connect( "mmt_data", "dosdb.pc.muc.loc", "DOS_MESSKNECHT", "DerGoldschatz!!", "dos_datenbank", 0, "", 0 );    // open connection to messwertelittlec table
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -10 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -10 );    // exit with error code, error message is reported on the console 
             }
         
                 
         return ( 0 );    // connections established
     }
 
     /*
         This routine queries the table test_stations for a predefined index, which matches in macro value "PC-L109-08"
         If the macro value "PC-L109-08" exists in the database, the ID key, pointing to the field is returned
         into global variable sql_test_station_id.
         If the macro value "PC-L109-08" does not exist in the database, it is inserted at the end, and the 
         insertion ID key is returned into global variable sql_test_station_id.
     */
     int SQL_Get_Test_Station_Id()    {
         
         int SQL_err;
         int SQL_nr_parsed_SQL_args;
             
         SQL_nr_parsed_SQL_args = 0;
         
                                 
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 8, 1, -49 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }        
             
             EMFT_VSnPrintf( sql_query, "SELECT id FROM teststations WHERE SCRIPT_COMP_NAME='%s'", "PC-L109-08" );    // form SQL query
             
             SQL_err = EMFT_SQL_Query( "test_stations", sql_query );        // execute SQL query
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -12 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -12 );    // exit with error code, error message is reported on the console 
             }
                 
             SQL_err = EMFT_SQL_StoreResult( "test_stations" );
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -11 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -11 );    // exit with error code, error message is reported on the console
             }
             
             SQL_nr_parsed_SQL_args = EMFT_SQL_FetchRow( "test_stations", sql_test_station_id );        // store test station id into sql_test_station_id variable for further use 
 
             // result set was returned
             SQL_err = EMFT_SQL_FreeResult( "test_stations" );    // release returned result set
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -13 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -13 );    // exit with error code, error message is reported on the console 
             }
             
             if ( SQL_nr_parsed_SQL_args == 0 )    {
                         
                 // result set is empty - the test station does not exist in test_stations table
                 EMFT_VSnPrintf( sql_query, "INSERT INTO teststations SET SCRIPT_COMP_NAME='%s'", "PC-L109-08" );    // this macro is already enclosed in double quotes
                 
                 // form conditional SQL query, based on existence of LittleC macros
                                 
                                 
                 
                     SQL_err = EMFT_GetMacroValue( "EMFT_LOCAL_RESULTS_FILE_FOLDER", sql_string_macro );    // obtain macro name
                     SQL_err = EMFT_EscapeFilePath( sql_string_macro );            // replace slash characters with backslashes and single backslashes with double backslashes, ready for insertion into SQL database
                     EMFT_VSnPrintf( sql_query, "%s, LITTLEC_LOCAL_RESULTS_ROOT_FOLDER='%s'", sql_query, sql_string_macro );                
                                 
                 
                     SQL_err = EMFT_GetMacroValue( "EMFT_REMOTE_RESULTS_FILE_FOLDER", sql_string_macro );    // obtain macro name
                     SQL_err = EMFT_EscapeFilePath( sql_string_macro );            // replace slash characters with backslashes and single backslashes with double backslashes, ready for insertion into SQL database
                     EMFT_VSnPrintf( sql_query, "%s, LITTLEC_REMOTE_RESULTS_ROOT_FOLDER='%s'", sql_query, sql_string_macro );
                                 
                 
                     SQL_err = EMFT_GetMacroValue( "EMFT_LITTLEC_SCRIPT_LIB_FOLDER", sql_string_macro );    // obtain macro name
                     SQL_err = EMFT_EscapeFilePath( sql_string_macro );            // replace slash characters with backslashes and single backslashes with double backslashes, ready for insertion into SQL database
                     EMFT_VSnPrintf( sql_query, "%s, LITTLEC_SCRIPT_LIB_FOLDER='%s'", sql_query, sql_string_macro );                
                                 
                                 
                 
                     SQL_err = EMFT_GetMacroValue( "EMFT_LITTLEC_SCRIPT_CONFIG_LIB_FOLDER", sql_string_macro );    // obtain macro name
                     SQL_err = EMFT_EscapeFilePath( sql_string_macro );            // replace slash characters with backslashes and single backslashes with double backslashes, ready for insertion into SQL database
                     EMFT_VSnPrintf( sql_query, "%s, LITTLEC_SCRIPT_CONFIG_LIB_FOLDER='%s'", sql_query, sql_string_macro );                
                                 
                 
                 
                     SQL_err = EMFT_GetMacroValue( "EMFT_CAL_RESULTS_FOLDER", sql_string_macro );    // obtain macro name
                     SQL_err = EMFT_EscapeFilePath( sql_string_macro );            // replace slash characters with backslashes and single backslashes with double backslashes, ready for insertion into SQL database
                     EMFT_VSnPrintf( sql_query, "%s, CAL_RESULTS_FOLDER='%s'", sql_query,  sql_string_macro );                
                 
                                 
                 SQL_err = EMFT_SQL_Query( "test_stations", sql_query );        // execute SQL query
                 
                 if ( SQL_err != 0 )    {
                     Log_Error( 8, 1, -14 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -14 );    // exit with error code, error message is reported on the console 
                 }
                 
                 sql_test_station_id = EMFT_SQL_LastInsertedId( "test_stations" );    // get last inserted index for teststations table connection
                 
                 if ( sql_test_station_id == 0 )    {
                     Log_Error( 8, 1, -15 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -15 );    // invalid insertion index, do not proceed
                 }
                 
             }
         
                 
         return ( 0 );    // id query successful
     }
 
     /*
         This routine queries table chargen for a predefined lot number value, stored in macro value 6762
         If the macro value 6762 exists in the database, the ID key, pointing to the field is returned
         into global variable sql_chargen_id.
         If the macro value 6762 does not exist in the database, it is inserted at the end, and the 
         insertion ID key is returned into global variable sql_chargen_id.
     */
     int SQL_Get_LotId()    {
         
         int SQL_err;
         int SQL_nr_parsed_SQL_args;
 
         SQL_nr_parsed_SQL_args = 0;
                             
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 8, 1, -49 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }        
             
             EMFT_VSnPrintf( sql_query, "SELECT id FROM chargen WHERE NUMMER='VC%d'", 6762 );    // form SQL query
             
             SQL_err = EMFT_SQL_Query( "chargen", sql_query );        // execute SQL query
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -16 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -16 );    // exit with error code, error message is reported on the console 
             }
                 
             SQL_err = EMFT_SQL_StoreResult( "chargen" );
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -11 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -11 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_nr_parsed_SQL_args = EMFT_SQL_FetchRow( "chargen", sql_chargen_id );        // store charge id into sql_chargen_id variable for further use 
 
             // result set was returned
             SQL_err = EMFT_SQL_FreeResult( "chargen" );    // release returned result set
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -13 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -13 );    // exit with error code, error message is reported on the console 
             }
             
             if ( SQL_nr_parsed_SQL_args == 0 )    {
                         
                 // result set is empty - the lot number does not exist in chargen tables
                 EMFT_VSnPrintf( sql_query, "INSERT INTO chargen SET NUMMER='VC%d'", 6762 );    // form SQL query    
                 
                 SQL_err = EMFT_SQL_Query( "chargen", sql_query );        // execute SQL query
                 
                 if ( SQL_err != 0 )    {
                     Log_Error( 8, 1, -17 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -17 );    // exit with error code, error message is reported on the console 
                 }
                 
                 sql_chargen_id = EMFT_SQL_LastInsertedId( "chargen" );    // get last inserted index for chargen table connection
                 
                 if ( sql_chargen_id == 0 )    {
                     Log_Error( 8, 1, -15 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -15 );    // invalid insertion index, do not proceed
                 }
                 
             }
         
                 
         return ( 0 );    // id query successful
     }
 
     /*
         This routine queries table chargen for a predefined lot number value, stored in macro value 6762
         If the macro value 6762 exists in the database, the ID key, pointing to the field is returned
         into global variable sql_chargen_id.
         If the macro value 6762 does not exist in the database, it is inserted at the end, and the 
         insertion ID key is returned into global variable sql_chargen_id.
     */
     int SQL_Get_WaferId_For_LotId()    {
         
         int SQL_err;
         int SQL_nr_parsed_SQL_args;
         
                             
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 8, 1, -49 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }        
             
             SQL_err = SQL_Get_LotId();        // first, get the lot number id, otherwise create one
 
             SQL_nr_parsed_SQL_args = 0;            // reset number of parsed SQL_arguments
             
             EMFT_VSnPrintf( sql_query, "SELECT id FROM wafer WHERE WAFERNUMMER='%s' AND CHARGE_ID='%d'", "W328D2", sql_chargen_id );    // form SQL query
             
             SQL_err = EMFT_SQL_Query( "wafer", sql_query );        // execute SQL query
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -18 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -18 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_err = EMFT_SQL_StoreResult( "wafer" );
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -11 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -11 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_nr_parsed_SQL_args = EMFT_SQL_FetchRow( "wafer", sql_wafer_id );        // store wafer id into sql_wafer_id variable for further use 
             
             // result set was returned
             SQL_err = EMFT_SQL_FreeResult( "wafer" );    // release returned result set
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -13 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -13 );    // exit with error code, error message is reported on the console 
             }    
             
             if ( SQL_nr_parsed_SQL_args == 0 )    {
             
                 // result set is empty - the wafer number does not exist in wafer tables for specified lot number
                 EMFT_VSnPrintf( sql_query, "INSERT INTO wafer SET WAFERNUMMER='%s', CHARGE_ID='%d'", "W328D2", sql_chargen_id );    // form SQL query
                 
                 SQL_err = EMFT_SQL_Query( "wafer", sql_query );        // execute SQL query
                 
                 if ( SQL_err != 0 )    {
                     Log_Error( 8, 1, -19 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -19 );    // exit with error code, error message is reported on the console 
                 }
                 
                 sql_wafer_id = EMFT_SQL_LastInsertedId( "wafer" );    // get last inserted index for wafer table connection
                 
                 if ( sql_wafer_id == 0 )    {
                     Log_Error( 8, 1, -15 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -15 );    // invalid insertion index, do not proceed
                 }
                 
             }
             
                 
         return ( 0 );    // id query successful
     }
 
     /*
         This routine queries table chargen for a predefined lot number value, stored in macro value 6762
         If the macro value 6762 exists in the database, the ID key, pointing to the field is returned
         into global variable sql_chargen_id.
         If the macro value 6762 does not exist in the database, it is inserted at the end, and the 
         insertion ID key is returned into global variable sql_chargen_id.
     */
     int SQL_Get_WaferStackId_For_LotId()    {
         
         int SQL_err;
         int SQL_nr_parsed_SQL_args;
 
                                 
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 8, 1, -49 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }        
             
             SQL_err = SQL_Get_LotId();        // first, get the lot number id, otherwise create one
 
             SQL_nr_parsed_SQL_args = 0;            // reset number of parsed SQL_arguments
             
             EMFT_VSnPrintf( sql_query, "SELECT id FROM waferstacks WHERE WAFERNUMMER='%s' AND CHARGE_ID='%d'", "W328D2", sql_chargen_id );    // form SQL query
             
             SQL_err = EMFT_SQL_Query( "waferstacks", sql_query );        // execute SQL query
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -18 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -18 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_err = EMFT_SQL_StoreResult( "waferstacks" );
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -11 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -11 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_nr_parsed_SQL_args = EMFT_SQL_FetchRow( "waferstacks", sql_waferstacks_id );        // store wafer id into sql_waferstacks_id variable for further use 
             
             // result set was returned
             SQL_err = EMFT_SQL_FreeResult( "waferstacks" );    // release returned result set
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -13 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -13 );    // exit with error code, error message is reported on the console 
             }    
             
             if ( SQL_nr_parsed_SQL_args == 0 )    {
             
                 // result set is empty - the wafer number does not exist in wafer tables for specified lot number
                 EMFT_VSnPrintf( sql_query, "INSERT INTO waferstacks SET WAFERNUMMER='%s', CHARGE_ID='%d'", "W328D2", sql_chargen_id );    // form SQL query
                 
                 SQL_err = EMFT_SQL_Query( "waferstacks", sql_query );        // execute SQL query
                 
                 if ( SQL_err != 0 )    {
                     Log_Error( 8, 1, -19 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -19 );    // exit with error code, error message is reported on the console 
                 }
                 
                 sql_waferstacks_id = EMFT_SQL_LastInsertedId( "waferstacks" );    // get last inserted index for wafer table connection
                 
                 if ( sql_waferstacks_id == 0 )    {
                     Log_Error( 8, 1, -15 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -15 );    // invalid insertion index, do not proceed
                 }
                 
             }
             
                 
         return ( 0 );    // id query successful
     }
 
     /*
         This routine queries table devicetypen for a predefined device type value, stored in macro value "uP029_M30_K200_sl4"
         If the macro value "uP029_M30_K200_sl4" exists in the database, the ID key, pointing to the field is returned
         into global variable sql_chargen_id.
         If the macro value 6762 does not exist in the database, it is inserted at the end, and the 
         insertion ID key is returned into global variable sql_chargen_id.
     */
     int SQL_Get_DeviceType()    {
         
         int SQL_err;
         int SQL_nr_parsed_SQL_args;
         
         SQL_nr_parsed_SQL_args = 0;            // reset number of parsed SQL_arguments
         
                             
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 8, 1, -49 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }        
             
             EMFT_VSnPrintf( sql_query, "SELECT id FROM devicetypen WHERE BEZEICHNUNG='%s'", "uP029_M30_K200_sl4" );    // form SQL query
             
             SQL_err = EMFT_SQL_Query( "device_types", sql_query );        // execute SQL query
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -20 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -20 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_err = EMFT_SQL_StoreResult( "device_types" );
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -11 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -11 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_nr_parsed_SQL_args = EMFT_SQL_FetchRow( "device_types", sql_dev_types_id );        // store device type id into sql_dev_types_id variable for further use 
             
             // result set was returned
             SQL_err = EMFT_SQL_FreeResult( "device_types" );    // release returned result set
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -13 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -13 );    // exit with error code, error message is reported on the console 
             }    
             
             if ( SQL_nr_parsed_SQL_args == 0 )    {
             
                 // result set is empty - the device type does not exist in devtypen table
                 EMFT_VSnPrintf( sql_query, "INSERT INTO devicetypen SET BEZEICHNUNG='%s', UNTERTYP='%s', VARIANTE='%s', ART='%s'", "uP029_M30_K200_sl4", "uP029_M30_K200_sl4", "uP029_M30_K200_sl4", "uP029_M30_K200_sl4" );    // form SQL query
                 
                 SQL_err = EMFT_SQL_Query( "device_types", sql_query );        // execute SQL query
                 
                 sql_dev_types_id= EMFT_SQL_LastInsertedId( "device_types" );    // get last inserted index for chargen table connection
                 
                 if ( sql_dev_types_id == 0 )    {
                     Log_Error( 8, 1, -15 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -15 );    // invalid insertion index, do not proceed
                 }
             }
                 
         return ( 0 );    // id query successful
     }
 
     /*
         This routine queries table devices for a predefined device name value, stored in macro value "C1003",
         which corresponds to previously queried wafer_id and device type id.
         If the macro value "C1003" exists in the database, the ID key, pointing to the field is returned
         into global variable sql_devices_id.
         If the macro value "C1003" does not exist in the database, it is inserted at the end, and the 
         insertion ID key is returned into global variable sql_devices_id.
     */
     int SQL_Get_Device_For_DevType_And_WaferId()    {
         
         int SQL_err;
         int SQL_nr_parsed_SQL_args;
         
         
             
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 8, 1, -49 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }        
                     
             SQL_err  = SQL_Get_WaferStackId_For_LotId();            // get the waferstacks id for a given lot id, otherwise create one
             SQL_err  = SQL_Get_DeviceType();                        // get the device type id, otherwise create one    
 
             SQL_nr_parsed_SQL_args = 0;            // reset number of parsed SQL_arguments
 
             EMFT_VSnPrintf( sql_query, "SELECT id FROM devices WHERE DEVICENAME='%s' AND WAFERSTACK_ID='%d' AND DEVICETYP_ID='%d'", "C1003", sql_waferstacks_id, sql_dev_types_id );    // form SQL query
             
             SQL_err = EMFT_SQL_Query( "devices", sql_query );        // execute SQL query    
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -21 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -21 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_err = EMFT_SQL_StoreResult( "devices" );
                 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -11 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -11 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_nr_parsed_SQL_args = EMFT_SQL_FetchRow( "devices", sql_devices_id );        // store device type id into sql_devices_id variable for further use 
 
             SQL_err = EMFT_SQL_FreeResult( "devices" );    // release returned result set
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -13 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -13 );    // exit with error code, error message is reported on the console 
             }
                 
             if ( SQL_nr_parsed_SQL_args == 0 )    {
             
                 // result set is empty - the device type does not exist in devtypen table at all
                 EMFT_VSnPrintf( sql_query, "INSERT INTO devices SET DEVICENAME='%s', WAFERSTACK_ID='%d', DEVICETYP_ID='%d'", "C1003", sql_waferstacks_id, sql_dev_types_id  );    // form SQL query
                 
                 SQL_err = EMFT_SQL_Query( "devices", sql_query );        // execute SQL query
                         
                 if ( SQL_err != 0 )    {
                     Log_Error( 8, 1, -22 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -22 );    // exit with error code, error message is reported on the console 
                 }
                 
                 sql_devices_id = EMFT_SQL_LastInsertedId( "devices" );    // get last inserted index for devices table connection
                 
                 if ( sql_devices_id == 0 )    {
                     Log_Error( 8, 1, -15 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -15 );    // invalid insertion index, do not proceed
                 }    
             }
         
                 
         return ( 0 );    // id query successful
     }
 
     /*
         This routine queries table skripte for a predefined script value, stored in macro value 1147
         If the macro value 1147 exists in the database, the ID key, pointing to the field is returned
         into global variable sql_chargen_id.
         If the macro value 6762 does not exist in the database, it is inserted at the end, and the 
         insertion ID key is returned into global variable sql_chargen_id.
     */
     int SQL_Get_Script()    {
         
         int SQL_err;
         int SQL_nr_parsed_SQL_args;
 
         SQL_nr_parsed_SQL_args = 0;            // reset number of parsed SQL_arguments
         
                             
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 8, 1, -49 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }        
             
             EMFT_VSnPrintf( sql_query, "SELECT id FROM skripte WHERE NUMMER= 'LCS%04d'", 1147 );    // form SQL query
             
             SQL_err = EMFT_SQL_Query( "scripts", sql_query );        // execute SQL query
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -23 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -23 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_err = EMFT_SQL_StoreResult( "scripts" );
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -11 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -11 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_nr_parsed_SQL_args = EMFT_SQL_FetchRow( "scripts", sql_script_id );        // store script id into sql_script_id variable for further use 
             
             SQL_err = EMFT_SQL_FreeResult( "scripts" );    // release returned result set
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -13 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -13 );    // exit with error code, error message is reported on the console 
             }
             
             if ( SQL_nr_parsed_SQL_args == 0 )    {
             
                 // result set is empty - the device type does not exist in devtypen table at all
                 EMFT_VSnPrintf( sql_query, "INSERT INTO skripte SET NUMMER='LCS%04d', BEZEICHNUNG='LCS%04d'", 1147, 1147);    // form SQL query
                 
                 SQL_err = EMFT_SQL_Query( "scripts", sql_query );        // execute SQL query
                 
                 if ( SQL_err != 0 )    {
                     Log_Error( 8, 1, -24 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -24 );    // exit with error code, error message is reported on the console 
                 }
                 
                 sql_script_id = EMFT_SQL_LastInsertedId( "scripts" );    // get last inserted index for chargen table connection
                 
                 if ( sql_script_id == 0 )    {
                     Log_Error( 8, 1, -15 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -15 );    // invalid insertion index, do not proceed
                 }
             }
 
                 
         return ( 0 );    // id query successful
     }
 
     int SQL_AutoIncrement_Mmt_Nr()    {
         int SQL_err;    
         int SQL_nr_parsed_SQL_args;
 
         int log_file_err;
         
         log_file_err = 0;                    // reset log file error number
         SQL_nr_parsed_SQL_args = 0;            // reset number of parsed SQL_arguments
         
         
                 
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 8, 1, -49 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }        
             
             EMFT_VSnPrintf( sql_query, "SELECT NUMMER FROM messungen WHERE NUMMER LIKE 'MNo%03d%%' and DEVICE_ID = %d ORDER by id DESC LIMIT 1", 1, sql_devices_id);    // form SQL query
 
             // get the last nummer field
             SQL_err = EMFT_SQL_Query( "mmt_hdr", sql_query);        // execute SQL query
             
             //if no answer ==> use number from log file
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -25 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -25 );    // exit with error code, error message is reported on the console 
             }    
             
             SQL_err = EMFT_SQL_StoreResult( "mmt_hdr" );
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -11 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -11 );    // exit with error code, error message is reported on the console 
             }
 
             SQL_nr_parsed_SQL_args = EMFT_SQL_FetchRow( "mmt_hdr", sql_query );        // store last file measurement number into sql_query variable for further use 
 
             // result set was returned
             SQL_err = EMFT_SQL_FreeResult( "mmt_hdr" );    // release returned result set
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -13 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -13 );    // exit with error code, error message is reported on the console 
             }
             
             if ( SQL_nr_parsed_SQL_args > 0 )    {                
                 // response in format MNo003-003
                 EMFT_VSScanf( sql_query, "%*7s%d", SQL_iteration_nr);    // scan last three digits - single integer SQL_argument - measurement number                
                 SQL_iteration_nr = SQL_iteration_nr + 1;    // increment measurement number from SQL
             }
             else {
                 // No measurement iterations were performed using this measurement number - reset the SQL reported number to one
                 SQL_iteration_nr = 1;    
             }
                         
             // Compare measurement iteration numbers from SQL (SQL_iteration_nr) and the value from LogFile (meas_iteration_nr):
             // Option 1: Some of measurements were taken without SQL insertion taking place, 
             // therefore meas_iteration_nr from log file is ahead of iteration number (SQL_iteration_nr) from SQL
             // Action 1: Update the iteration number from SQL with current value from log file (sync both). 
             if ( meas_iteration_nr > SQL_iteration_nr )    {                
                 // use higher iteration value from logfile, so that the iteration number from log file and SQL entry match from now on 
                 SQL_iteration_nr = meas_iteration_nr;
             }
             
             // Option 2: Someone deleted the log file, while the results of SQL insertion remained in the database!
             // therefore meas_iteration_nr from log file is behind iteration number (SQL_iteration_nr) from SQL
             // Action 2: Update the iteration number from log file with current value from SQL file (sync both).
             if  ( meas_iteration_nr < SQL_iteration_nr )    {
                 // use higher iteration value from SQL, so that the iteration number from log file and SQL entry match from now on 
                 meas_iteration_nr = SQL_iteration_nr + 1 ;    // update iteration number in the log file with next free number from SQL
                 
                 EMFT_VSnPrintf( logfile_replace_line_buffer, "iteration:\t%d", meas_iteration_nr );        // form replacement line buffer string to be replaced in the results log file
     
                 // Function EMFT_File_ReplaceLine will replace the entire line, specified (first, x-th, last) occurrence of the string, 
                 // with replacement line buffer string
                 // 1. parameter - line buffer string    
                 // 2. parameter - replace line buffer string    
                 // 3. parameter - match number ( 0 - invalid value, -1 - last match, 1 - first match, i (positive) i-th match )
                 // Return error values: 
                 // Success 0: line was found and its contents returned in the line buffer string according to specified mode
                 // Error -1: log file does not exist, i.e. was not open by LogFile_Setup_Open routine)
                 // Error -2: log file is empty - this error code is used to detect measurement iteration 1 - line buffer string is not affected
                 // Error -3: no occurrences of line buffer string were found in the file - line buffer string is not affected
                 // Error -4: file write access mode could not be changed from overwrite to append and vice-versa (file may be locked, non-existent ...)
                 // Error -5: no ending terminator occurrences were found - file has only a single line
                 // Error -6: invalid search number (cannot be zero - can be -1 or positive, up to expected number of occurrences)
                 log_file_err = EMFT_File_ReplaceLine( logfile_line_buffer, logfile_replace_line_buffer, -1 );        // replace the last occurrence of the line, containing string in logfile_line_buffer and replace with logfile_replace_line_buffer
                 
                 if ( log_file_err != 0 )    {
                     // user interrupted the script execution - entirely skip action
                     Log_Error( 1, 1, -5 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );    // exit with error code return
                 }
             }
             
                 
         return ( 0 );    // id query successful
         
     }
 
 
 
     int SQL_Get_TestSetup()    {
         
         int SQL_err;
         int SQL_nr_parsed_SQL_args;
         int SQL_macro_defined;
         
         SQL_nr_parsed_SQL_args = 0;
         
                                 
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 8, 1, -49 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }        
             
                             return ( 0 );    // id query successful
         
     }
 
     /*
         This routine inserts the measurement header into table messungen for a predefined script value, stored in macro value 1147
         If the macro value 1147 exists in the database, the ID key, pointing to the field is returned
         into global variable sql_chargen_id.
         If the macro value 6762 does not exist in the database, it is inserted at the end, and the 
         insertion ID key is returned into global variable sql_chargen_id.
     */
     int SQL_New_Mmt_Header()    {
         
         int SQL_nr_parsed_SQL_args;        
         int SQL_err;
                 
                 
             SQL_err = SQL_AutoIncrement_Mmt_Nr();        // Increment measurement number    
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -51 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -51 );    // exit with error code, error message is reported on the console 
             }
                     
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 8, 1, -49 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }        
             
             SQL_err = EMFT_SQL_Query( "mmt_hdr", "SET AUTOCOMMIT=ON" );        // execute SQL query
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -28 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -28 );    // exit with error code, error message is reported on the console 
             }
             
             // check if the index of last inserted measurement already exists - avoid duplicates, which will cause an error
             if ( sql_test_setup_id == 0 )    {
                 // user is trying to update the measurement completion time without previously defined test setup (NULL testsetup id )        
                 EMFT_VSnPrintf( sql_query, "SELECT ID FROM messungen WHERE NUMMER='MNo%03d-%03d' AND DEVICE_ID='%d' AND SKRIPT_ID='%d' AND TESTSETUP_ID IS NULL ORDER BY ID DESC LIMIT 1", 1, SQL_iteration_nr, sql_devices_id, sql_script_id );    // form SQL query
             }
             else    {
                 // test setup was obtained
                 EMFT_VSnPrintf( sql_query, "SELECT ID FROM messungen WHERE NUMMER='MNo%03d-%03d' AND DEVICE_ID='%d' AND SKRIPT_ID='%d' AND TESTSETUP_ID='%d' ORDER BY ID DESC LIMIT 1",  1, SQL_iteration_nr, sql_devices_id, sql_script_id, sql_test_setup_id );    // form SQL query
             }
             
             SQL_err = EMFT_SQL_Query( "mmt_hdr", sql_query );        // execute SQL query
             
             if ( SQL_err != 0 )    {
                 return ( lc_err_code_nr );     //  -30 );    // exit with error code, error message is reported on the console 
             }
                 
             SQL_err = EMFT_SQL_StoreResult( "mmt_hdr" );
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -11 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -11 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_nr_parsed_SQL_args = EMFT_SQL_FetchRow( "mmt_hdr", sql_mmt_data_id );        // store test station id into sql_mmt_data_id variable for further use 
             
             // result set was returned
             SQL_err = EMFT_SQL_FreeResult( "mmt_hdr" );    // release returned result set
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -13 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -13 );    // exit with error code, error message is reported on the console 
             }
             
             if ( ( SQL_nr_parsed_SQL_args > 0 ) && ( sql_mmt_data_id != 0 ) )    {
                 return ( 0 );    // skip insertion of a new index, since an entry already exists
             }
                         
             
                 SQL_err = EMFT_GetMacroValue( "EMFT_LOCAL_RESULTS_FILE_FOLDER", sql_string_macro );    // obtain macro name
                 SQL_err = EMFT_EscapeFilePath( sql_string_macro );            // replace slash characters with backslashes and single backslashes with double backslashes, ready for insertion into SQL database                    
                             
             
                 SQL_err = EMFT_GetMacroValue( "EMFT_REMOTE_RESULTS_FILE_FOLDER", sql_string_macro1 );    // obtain macro name
                 SQL_err = EMFT_EscapeFilePath( sql_string_macro1 );            // replace slash characters with backslashes and single backslashes with double backslashes, ready for insertion into SQL database                
                         
             if ( sql_test_setup_id == 0 )    {
                 // user is trying to update the measurement completion time without previously defined test setup
                 EMFT_VSnPrintf( sql_query, "INSERT INTO messungen SET NUMMER='MNo%03d-%03d', MESSDATEI='MNo%03d_LCS%04d_&%s&_VC%04d_%s_%s.log', HOUSING='%s', PFAD_MESSDATEI_LOKAL='%s', PFAD_MESSDATEI='%s', DEVICE_ID='%d', SKRIPT_ID='%d'",
                                                                                                                                                                                                 1, 
                                                                                                                                                                                                 SQL_iteration_nr,
                                                                                                                                                                                                 1, 
                                                                                                                                                                                                 1147, 
                                                                                                                                                                                                 "PG017-V1-GK-006", 
                                                                                                                                                                                                 6762, 
                                                                                                                                                                                                 "W328D2", 
                                                                                                                                                                                                 "C1003", 
                                                                                                                                                                                                 "PG017-V1-GK-006", 
                                                                                                                                                                                                 sql_string_macro, 
                                                                                                                                                                                                 sql_string_macro1, 
                                                                                                                                                                                                 sql_devices_id, 
                                                                                                                                                                                                 sql_script_id);    // form SQL query
             }
             else    {
                 // test setup id is defined
                 EMFT_VSnPrintf( sql_query, "INSERT INTO messungen SET NUMMER='MNo%03d-%03d', MESSDATEI='MNo%03d_LCS%04d_&%s&_VC%04d_%s_%s.log', HOUSING='%s',  PFAD_MESSDATEI_LOKAL='%s', PFAD_MESSDATEI='%s', DEVICE_ID='%d', SKRIPT_ID='%d', TESTSETUP_ID='%d'",
                                                                                                                                                                                                 1, 
                                                                                                                                                                                                 SQL_iteration_nr, 
                                                                                                                                                                                                 1, 
                                                                                                                                                                                                 1147, 
                                                                                                                                                                                                 "PG017-V1-GK-006", 
                                                                                                                                                                                                 6762, 
                                                                                                                                                                                                 "W328D2", 
                                                                                                                                                                                                 "C1003", 
                                                                                                                                                                                                 "PG017-V1-GK-006", 
                                                                                                                                                                                                 sql_string_macro, 
                                                                                                                                                                                                 sql_string_macro1, 
                                                                                                                                                                                                 sql_devices_id, 
                                                                                                                                                                                                 sql_script_id, 
                                                                                                                                                                                                 sql_test_setup_id);    // form SQL query    
             }
             // immediately reserve measurement id
             SQL_err = EMFT_SQL_Query( "mmt_hdr", sql_query );        // execute SQL query
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -31 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -31 );    // exit with error code, error message is reported on the console 
             }
 
             // now, obtain the index of last inserted measurement 
             if ( sql_test_setup_id == 0 )    {
                 // user is trying to update the measurement completion time without previously defined test setup (NULL testsetup id )        
                 EMFT_VSnPrintf( sql_query, "SELECT ID FROM messungen WHERE DEVICE_ID='%d' AND SKRIPT_ID='%d' AND TESTSETUP_ID IS NULL ORDER BY ID DESC LIMIT 1", sql_devices_id, sql_script_id );    // form SQL query
             }
             else    {
                 // test setup was obtained
                 EMFT_VSnPrintf( sql_query, "SELECT ID FROM messungen WHERE DEVICE_ID='%d' AND SKRIPT_ID='%d' AND TESTSETUP_ID='%d' ORDER BY ID DESC LIMIT 1", sql_devices_id, sql_script_id, sql_test_setup_id );    // form SQL query
             }
             
             SQL_err = EMFT_SQL_Query( "mmt_hdr", sql_query );        // execute SQL query
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -30 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -30 );    // exit with error code, error message is reported on the console 
             }    
             
             SQL_err = EMFT_SQL_StoreResult( "mmt_hdr" );
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -11 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -11 );    // exit with error code, error message is reported on the console 
             }
 
             SQL_nr_parsed_SQL_args = EMFT_SQL_FetchRow( "mmt_hdr", sql_mmt_data_id );        // store the index of last inserted measurement for further use 
             
             if ( SQL_nr_parsed_SQL_args == 0 )    {
                 Log_Error( 8, 1, -36 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -36 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_err = EMFT_SQL_FreeResult( "mmt_hdr" );    // release returned result set
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -13 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -13 );    // exit with error code, error message is reported on the console 
             }    
 
             // now the same for data insertion into messwerte table
             SQL_err = EMFT_SQL_Query( "mmt_data", "SET AUTOCOMMIT=OFF" );        // execute SQL query
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -28 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -28 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_err = EMFT_SQL_Query( "mmt_data", "START TRANSACTION" );        // execute SQL query
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -29 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -29 );    // exit with error code, error message is reported on the console 
             }
             
         
                 
         return ( 0 );    // id query successful
     }
 
     /*
         This routine finalizes the measurement header and data insertion process into table messungen 
         for a last inserted mmt index, defined by sql_mmt_data_id.    
         For valid measurements, call this function to signal successful measurement execution.
         For invalid measurements, do not call this function! Invalid measurements don't have a timestamp
     */
     int SQL_Reject_Mmt_Header_And_Data()    {
         
         int SQL_err;
         
                             
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 8, 1, -49 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }        
         
             SQL_err = EMFT_SQL_Query( "mmt_data", "ROLLBACK" );        // execute SQL query
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -32 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -32 );    // exit with error code, error message is reported on the console 
             }    
 
             SQL_err = EMFT_SQL_Query( "mmt_data", "SET AUTOCOMMIT=ON" );        // execute SQL query
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -33 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -33 );    // exit with error code, error message is reported on the console 
             }    
 
                 
         return ( 0 );    // id query successful
     }
 
 
 
     /*
         This routine finalizes the measurement data insertion process into table messwertelittlec 
         for a last inserted mmt index, defined by sql_mmt_data_id.    
     */
     int SQL_Commit_Mmt_Data()    {
         
         int SQL_err;
         
         int SQL_nr_parsed_SQL_args;
                             
 /*             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 8, 1, -49 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }        
  */            
             SQL_nr_parsed_SQL_args = 0;            // reset number of parsed SQL_arguments
             
             SQL_err = EMFT_SQL_Query( "mmt_data", "COMMIT" );        // execute SQL query
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -34 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -34 );    // exit with error code, error message is reported on the console 
             }    
             
                 
         return ( 0 );    // id query successful
     }
     /*
         This routine finalizes the measurement data insertion process into table messungen 
         for a last inserted mmt index, defined by sql_mmt_data_id.    
     */
     int SQL_Commit_Mmt_EndTime_And_Info()    {
         
         int SQL_err;
         
         int SQL_nr_parsed_SQL_args;
                             
              if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 8, 1, -49 );    // log the error onto console and into log file (if available)
 //                return ( lc_err_code_nr );    // exit with error code return
             }        
             
         
             SQL_err = EMFT_SQL_Query( "mmt_data", "SET AUTOCOMMIT=ON" );        // execute SQL query
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -33 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -33 );    // exit with error code, error message is reported on the console 
             }        
             
             SQL_err = SQL_Update_Mmt_EndTime_Info();        // Finalize measurement
 
             //SQL_Update_Mmt_Id();        // update last inserted measurement id
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -35 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -35 );    // exit with error code, error message is reported on the console 
             }    
             
                 
         return ( 0 );    // id query successful
     }
 
     int SQL_Update_Mmt_EndTime_Info()    {
         int SQL_err;
             
         int SQL_nr_parsed_SQL_args;
         
                             
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 8, 1, -49 );    // log the error onto console and into log file (if available)
                 
 //                return ( lc_err_code_nr );    // exit with error code return
             }        
             
             SQL_nr_parsed_SQL_args = 0;            // reset number of parsed SQL_arguments
             
             // when all is successfully done, update the measurement timestamp
             EMFT_VSnPrintf( sql_query, "UPDATE messungen SET MESSUNG_VOLLSTAENDIG = CURRENT_TIMESTAMP() WHERE ID='%d'", sql_mmt_data_id );    // form SQL query
             
             SQL_err = EMFT_SQL_Query( "mmt_hdr", sql_query );        // execute SQL query
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -37 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -37 );    // exit with error code, error message is reported on the console 
             }
 
             // update messung_id index of last selected measurement values in messwertelittlec table
             //EMFT_VSnPrintf( sql_query, "UPDATE messwertelittlec SET MESSUNG_ID='%d' WHERE MESSUNG_ID IS NULL", sql_mmt_data_id );    // form SQL query
             
             //SQL_err = EMFT_SQL_Query( "mmt_data", sql_query );        // execute SQL query
             
             // if ( SQL_err != 0 )    {
                 // Log_Error( 8, 1, -38 );    // log the error onto console and into log file (if available)
                 // return ( lc_err_code_nr );     //  -38 );    // exit with error code, error message is reported on the console 
             // }
             
             // insert measurement information based on obtained last selected messung table index
             SQL_err = SQL_Update_MmtInfo();
 
             EMFT_VSnPrintf( sql_query, "SELECT ID FROM messwertelittlec WHERE MESSUNG_ID='%d' ORDER BY ID DESC LIMIT 1", sql_mmt_data_id );    // form SQL query
             
             SQL_err = EMFT_SQL_Query( "mmt_data", sql_query );        // execute SQL query
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -39 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -39 );    // exit with error code, error message is reported on the console 
             }    
             
             SQL_err = EMFT_SQL_StoreResult( "mmt_data" );
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -11 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -11 );    // exit with error code, error message is reported on the console 
             }
 
             SQL_nr_parsed_SQL_args = EMFT_SQL_FetchRow( "mmt_data", sql_mmt_values_id );        // store the index of last inserted measurement values for further use 
             
             if ( SQL_nr_parsed_SQL_args == 0 )    {
                 Log_Error( 8, 1, -36 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -36 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_err = EMFT_SQL_FreeResult( "mmt_data" );    // release returned result set
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -13 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -13 );    // exit with error code, error message is reported on the console 
             }
             
                 
         return ( 0 );    // id query successful
     }
     
     int SQL_Update_MmtInfo()    {
         int SQL_err;
         int SQL_param_length;
         
                             
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 8, 1, -49 );    // log the error onto console and into log file (if available)
 //                return ( lc_err_code_nr );    // exit with error code return
             }        
             
             // insert messinfo information
                         
             EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='SCRIPT_USER', WERT='%s', MESSUNG_ID='%d'", "pc-l109n08", sql_mmt_data_id);    // form SQL query                
             SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
             }    
             
             EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='SCRIPT_COMP_NAME', WERT='%s', MESSUNG_ID='%d'", "PC-L109-08", sql_mmt_data_id);    // form SQL query                
             SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
             }    
             
             EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='SCRIPT_COMP_PRIM_IP_ADDR', WERT='%s', MESSUNG_ID='%d'", "169.254.142.73", sql_mmt_data_id);    // form SQL query                
             SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
             }    
             
             EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='LITTLEC_SW_VERSION', WERT='%s', MESSUNG_ID='%d'", "Little C scripter -- Ver.: 1.0.0.0, built on: Jul 17 2020 at 14:22:28", sql_mmt_data_id);    // form SQL query                
             SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
             }    
                 
             SQL_err = EMFT_GetMacroValue( "EMFT_SCRIPT_NAME", sql_string_macro );    // obtain macro name
             SQL_err = EMFT_EscapeFilePath( sql_string_macro );            // replace slash characters with backslashes and single backslashes with double backslashes, ready for insertion into SQL database                                    
             EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='SCRIPT_NAME', WERT='%s', MESSUNG_ID='%d'", sql_string_macro, sql_mmt_data_id);    // form SQL query            
             SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
             }    
 
             EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='TEST_SCRIPT_VERSION', WERT='%s', MESSUNG_ID='%d'", "MM1_MW1", sql_mmt_data_id);    // form SQL query                
             SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
             }    
 
             EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='SCRIPT_LOAD_TSTAMP', WERT='%s', MESSUNG_ID='%d'", "2021_03_15_08_54_54", sql_mmt_data_id);    // form SQL query                
             SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
             }    
             
             
                 EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='COMMON_LIB_VERSION', WERT='%s', MESSUNG_ID='%d'", "MM7_MW5_AK1", sql_mmt_data_id);    // form SQL query                
                 SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                            
                 if ( SQL_err != 0 )    {
                     Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                 }    
                     
             
                 EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='EMFT_UPUMP_LIB_VERSION', WERT='%s', MESSUNG_ID='%d'", "MM5_MW8", sql_mmt_data_id);    // form SQL query                
                 SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                 if ( SQL_err != 0 )    {
                     Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                 }
                     
             
                 EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='CPC3000_LIB_VERSION', WERT='%s', MESSUNG_ID='%d'", "MM5_MW6", sql_mmt_data_id);    // form SQL query                
                 SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                 if ( SQL_err != 0 )    {
                     Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                 }
                     
             
                 EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='HP33120A_LIB_VERSION', WERT='%s', MESSUNG_ID='%d'", "MM4_MW2", sql_mmt_data_id);    // form SQL query                
                 SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                 if ( SQL_err != 0 )    {
                     Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                 }
                     
                         
             
                 EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='FLOWBUS_LIB_VERSION', WERT='%s', MESSUNG_ID='%d'", "MM5_MW1", sql_mmt_data_id);    // form SQL query                
                 SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                 if ( SQL_err != 0 )    {
                     Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                 }
                     
                     
             
                 EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='SQL_LIB_VERSION', WERT='%s', MESSUNG_ID='%d'", "MM2_MW5", sql_mmt_data_id);    // form SQL query                
                 SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                 if ( SQL_err != 0 )    {
                     Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                 }
                         
             
                 EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='VALVES_BECKHOFF_LIB_VERSION', WERT='%s', MESSUNG_ID='%d'", "MM1_MW3", sql_mmt_data_id);    // form SQL query                
                 SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                 if ( SQL_err != 0 )    {
                     Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                 }
                         
             
                 EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PS_BECKHOFF_LIB_VERSION', WERT='%s', MESSUNG_ID='%d'", "MM1", sql_mmt_data_id);    // form SQL query                
                 SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                 if ( SQL_err != 0 )    {
                     Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                 }
                         
                         
                                     
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='FLOWBUS_DEVICE1_USER_TAG', WERT='%s', MESSUNG_ID='%d'", FlB_Dev1_UserTag, sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='FLOWBUS_DEVICE1_DEV_TYPE', WERT='%s', MESSUNG_ID='%d'", FlB_Dev1_DevTyp, sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='FLOWBUS_DEVICE1_SERIAL_NUMBER', WERT='%s', MESSUNG_ID='%d'", FlB_Dev1_SN, sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='FLOWBUS_DEVICE1_ALARM_INFO', WERT='%d', MESSUNG_ID='%d'", FlB_Dev1_AlarmInfo, sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                 
                                             EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='FLOWBUS_DEVICE1_FMMT_UNITS', WERT='%s', MESSUNG_ID='%d'", FlB_Dev1_fmmt_units, sql_mmt_data_id);    // form SQL query                                    
                         SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                            
                         if ( SQL_err != 0 )    {
                             Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                             return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                         }
                     
                     EMFT_VSnPrintf( sql_query,  "INSERT INTO messinfo SET NAME='FLOWBUS_DEVICE1_FMMT_STAB_BUF_SIZE', WERT='20', MESSUNG_ID='%d'", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }    
 
                     EMFT_VSnPrintf( sql_query,   "INSERT INTO messinfo SET NAME='FLOWBUS_DEVICE1_FMMT_STAB_STD_DEV', WERT='1.0E-1', MESSUNG_ID='%d'", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }            
                 
                 
                                 
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='FLOWBUS_DEVICE2_USER_TAG', WERT='%s', MESSUNG_ID='%d'", FlB_Dev2_UserTag, sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='FLOWBUS_DEVICE2_DEV_TYPE', WERT='%s', MESSUNG_ID='%d'", FlB_Dev2_DevTyp, sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='FLOWBUS_DEVICE2_SERIAL_NUMBER', WERT='%s', MESSUNG_ID='%d'", FlB_Dev2_SN, sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='FLOWBUS_DEVICE2_ALARM_INFO', WERT='%d', MESSUNG_ID='%d'", FlB_Dev2_AlarmInfo, sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                 
                                             EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='FLOWBUS_DEVICE2_FMMT_UNITS', WERT='%s', MESSUNG_ID='%d'", FlB_Dev2_fmmt_units, sql_mmt_data_id);    // form SQL query                                    
                         SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                            
                         if ( SQL_err != 0 )    {
                             Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                             return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                         }
                     
                     EMFT_VSnPrintf( sql_query,  "INSERT INTO messinfo SET NAME='FLOWBUS_DEVICE2_FMMT_STAB_BUF_SIZE', WERT='20', MESSUNG_ID='%d'", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }    
 
                     EMFT_VSnPrintf( sql_query,   "INSERT INTO messinfo SET NAME='FLOWBUS_DEVICE2_FMMT_STAB_STD_DEV', WERT='1.0E-1', MESSUNG_ID='%d'", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }            
                 
                             
                 
                         
             
                                 
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_CONTROLLER_DEV1_DRIVER_PRESSURE_NAME', WERT='%s', MESSUNG_ID='%d'", "P_OUTLET", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }                    
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_CONTROLLER_DEV1_SERIAL_NUMBER', WERT='%s', MESSUNG_ID='%d'", "MENSOR810617", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_CONTROLLER_DEV1_UNITS', WERT='%s', MESSUNG_ID='%d'", "hPa", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_CONTROLLER_DEV1_STAB_BUFFER_SIZE', WERT='10', MESSUNG_ID='%d'", sql_mmt_data_id);    // form SQL query
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_CONTROLLER_DEV1_STAB_LIMIT_STD_DEV', WERT='1.0', MESSUNG_ID='%d'", sql_mmt_data_id);    // form SQL query
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_CONTROLLER_DEV1_DRIVER_STAB_TIMEOUT', WERT='120000.0', MESSUNG_ID='%d'", sql_mmt_data_id);    // form SQL query
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     
                                 
                                 
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_CONTROLLER_DEV2_DRIVER_PRESSURE_NAME', WERT='%s', MESSUNG_ID='%d'", "P_INLET", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_CONTROLLER_DEV2_SERIAL_NUMBER', WERT='%s', MESSUNG_ID='%d'", "MENSOR810615", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_CONTROLLER_DEV2_UNITS', WERT='%s', MESSUNG_ID='%d'", "hPa", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }                    
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_CONTROLLER_DEV2_STAB_BUFFER_SIZE', WERT='10', MESSUNG_ID='%d'", sql_mmt_data_id);    // form SQL query
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_CONTROLLER_DEV2_STAB_LIMIT_STD_DEV', WERT='1.0', MESSUNG_ID='%d'", sql_mmt_data_id);    // form SQL query
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_CONTROLLER_DEV2_DRIVER_STAB_TIMEOUT', WERT='120000.0', MESSUNG_ID='%d'", sql_mmt_data_id);    // form SQL query
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
 
                                 
                         
             
                 EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='HP33120A_SERIAL_NUMBER', WERT='%s', MESSUNG_ID='%d'", HP33120A_SerialNr, sql_mmt_data_id);    // form SQL query                                    
                 SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                 if ( SQL_err != 0 )    {
                     Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                     return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                 }
                 
 
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='HP33120A_WAVEFORM', WERT='SINUS-FLANK', MESSUNG_ID='%d'", sql_mmt_data_id);    // form SQL query                                    
                         SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                         if ( SQL_err != 0 )    {
                             Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                             return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                         }
                                         
                                         
                                 
                                 
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PIEZO_AMPLIFIER_MODEL_NAME', WERT='%s', MESSUNG_ID='%d'", "SVR-500", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                                 
                                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='UPUMP_HI_VOLTAGE', WERT='90.0', MESSUNG_ID='%d'", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                                
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                                 
                                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='UPUMP_LO_VOLTAGE', WERT='-30.0', MESSUNG_ID='%d'", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                                
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                                 
                         
                         
             
                         
             
                 
                         
                 
                 
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_SENSOR_BECKHOFF_B_PS1_CH_NR', WERT='2', MESSUNG_ID='%d'", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_SENSOR_BECKHOFF_B_PS1_DATE_OF_CAL', WERT='%s', MESSUNG_ID='%d'", "04.02.2020", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_SENSOR_BECKHOFF_B_PS1_CAL_EXP_DATE', WERT='%s', MESSUNG_ID='%d'", "01.01.2022", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_SENSOR_BECKHOFF_B_PS1_CAL_UNIT', WERT='%s', MESSUNG_ID='%d'", "hPa", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_SENSOR_BECKHOFF_B_PS1_STABILITY_BUFFER_SIZE', WERT='10', MESSUNG_ID='%d'", sql_mmt_data_id);        // execute SQL query                            
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }        
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_SENSOR_BECKHOFF_B_PS1_STABILITY_BUFFER_STD_DEVIATION', WERT='5', MESSUNG_ID='%d'", sql_mmt_data_id);        // execute SQL query                            
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_SENSOR_BECKHOFF_B_PS1_RAW_STABILITY_TIMEOUT_MS', WERT='50000', MESSUNG_ID='%d'", sql_mmt_data_id);        // execute SQL query                            
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     
                 
                 
                 
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_SENSOR_BECKHOFF_B_PS2_CH_NR', WERT='3', MESSUNG_ID='%d'", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_SENSOR_BECKHOFF_B_PS2_DATE_OF_CAL', WERT='%s', MESSUNG_ID='%d'", "04.02.2020", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_SENSOR_BECKHOFF_B_PS2_CAL_EXP_DATE', WERT='%s', MESSUNG_ID='%d'", "01.01.2022", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_SENSOR_BECKHOFF_B_PS2_CAL_UNIT', WERT='%s', MESSUNG_ID='%d'", "hPa", sql_mmt_data_id);    // form SQL query                                    
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_SENSOR_BECKHOFF_B_PS2_STABILITY_BUFFER_SIZE', WERT='10', MESSUNG_ID='%d'", sql_mmt_data_id);        // execute SQL query                            
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_SENSOR_BECKHOFF_B_PS2_STABILITY_BUFFER_STD_DEVIATION', WERT='5', MESSUNG_ID='%d'", sql_mmt_data_id);        // execute SQL query                            
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='PRESSURE_SENSOR_BECKHOFF_B_PS2_RAW_STABILITY_TIMEOUT_MS', WERT='50000', MESSUNG_ID='%d'", sql_mmt_data_id);        // execute SQL query                            
                     SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query            
                     if ( SQL_err != 0 )    {
                         Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                         return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
                     }
                     
                 
             
             
             EMFT_VSnPrintf( sql_query, "INSERT INTO messinfo SET NAME='EXECUTION_ERROR_NUMBER', WERT='%d', MESSUNG_ID='%d'", lc_err_code_nr ,sql_mmt_data_id);    // form SQL query                                    
             SQL_err = EMFT_SQL_Query( "mess_info", sql_query );        // execute SQL query                            
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -48 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -48 );    // exit with error code, error message is reported on the console 
             }
                 
             
             return ( 0 );    // measurement info table insert successful
     }
     
     /*
         This routine updates the log file contents of the measurement
         In order to test the function SQL_Update_LogFile, field log_file (mediumtext) has to exist in the messwertelittlec table
     */
     
     int SQL_Update_LogFile()    {
         
         int SQL_err;
         int SQL_file_name_len;
         
                     
             if ( sql_mmt_values_id == 0 )    {
                 Log_Error( 8, 1, -41 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -41 );    // exit with error code, error message is reported on the console 
             }    
             
             EMFT_strcpy( sql_query, "UPDATE messwertelittlec SET log_file=? WHERE ID=?" );    // form a prepared SQL update query
 
             SQL_file_name_len = EMFT_strlen( fname );        // get the log file name string
             
             if ( SQL_file_name_len == 0 )    {
                 Log_Error( 8, 1, -40 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -40 );    // exit with error code, error message is reported on the console 
             }    
             
             // EMFT_SQL_PrepareStatement prepares an SQL statement  or updates a long (far longer than max_allowed_packet.value) binary file stream into BLOB type field. 
             // Empty files are not supported!
             // 1. parameter - SQL connection id string - an insert or update string may be used
             // 2. parameter - SQL query string - has to be in a global string variable or a constant string
             // 3. parameter - SQL file name/path to be sent to SQL - has to be in a global string variable or a constant string
                         
             SQL_err = EMFT_SQL_PrepareStatement( "mmt_data", sql_query );        // prepare an SQL query
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -42 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -42 );    // exit with error code, error message is reported on the console 
             }    
             
             // EMFT_SQL_BindStatement binds the parameters to the corresponding ? positions on the prepared statement
             // The benefit of prepared statement over standard query is the size of the data - standard query statement
             // supports query length up to max_allowed_packet.value
             // This may become too small, especially in case of inserting a binary or text file into BLOB or TEXT type SQL field.
             // 1. parameter - SQL connection id string - an insert or update string may be used
             // 2. parameter - variadic SQL parameter list - SQL prepared statement variable values (for order, see the EMFT_SQL_PrepareStatement query string)
             // Among variadic parameter list, there may also be a single file path and name global LittleC variable
             // In case this variable represents an existing file, the file contents are read in binary form:
             // If the file type is .log or .txt or .c, the file contents are converted from system encoding table to UTF-8            
             // and the contents are inserted as a text stream in 100k chunks, by repetitive calling the mysql_stmt_send_long_data function.
             // TEXT SQL data type is expected as target table field type.
             // If the file type is not text (other than specified above), binary stream is used and BLOB SQL data type is expected as target table field type.
             // In both cases, the size of the file is limited only by the SQL type size ( for LONGBLOB or LONGTEXT type - approx. 4 GB ).
             SQL_err = EMFT_SQL_BindStatement( "mmt_data", fname, sql_mmt_values_id );        // bind the data into prepared SQL query
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -43 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -43 );    // exit with error code, error message is reported on the console 
             }    
             
             // EMFT_SQL_ExecStatement executes a prepared and binded statement            
             // 1. parameter - SQL connection id string - an insert or update string may be used
             SQL_err = EMFT_SQL_ExecStatement( "mmt_data" );        // execute a prepared SQL query
 
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -44 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -44 );    // exit with error code, error message is reported on the console 
             }    
             
             // EMFT_SQL_CloseStatement closes a prepared statement            
             // 1. parameter - SQL connection id string - an insert or update string may be used
             SQL_err = EMFT_SQL_CloseStatement( "mmt_data" );        // close a prepared SQL query
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -45 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -45 );    // exit with error code, error message is reported on the console 
             }    
             
                 
         return ( 0 );    // id query successful
     }    
     
     /*
         This routine inserts the measurement data into table messwertelittlec for a predefined measurement type, stored in macro value "FLOW VS BACK PRESSURE AND EXCITATION FREQUENCY WITH UNDERPRESSURE FOR WATER"    
         In different scripts, there may be several sequences, where same variable refers to a different context (e.g. LCS244 or LCS166).
     */
     
     int SQL_Insert_Mmt_Data( char stage )    {
         
         int SQL_err;
         int macro1_defined;
         int macro2_defined;
         int macro3_defined;
         int macro4_defined;
         int macro5_defined;
         
         macro1_defined = 0;
         macro2_defined = 0;
         macro3_defined = 0;
         macro4_defined = 0;
         macro5_defined = 0;
         
                     
             // if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 // Log_Error( 8, 1, -49 );    // log the error onto console and into log file (if available)
                 // return ( lc_err_code_nr );    // exit with error code return
             // }        
             
             SQL_err = EMFT_strftime("%Y-%m-%d %H:%M:%S", sql_string_macro);    // get current date-time structure and parse it into SQL datetime format
             
                         
                         
             
             
             
             
                         
                             
                         
                         
                         
                         
             //    "WATER" = "WATER"     
             
                         
                         
                         
                             
                 EMFT_VSnPrintf( sql_query, "INSERT INTO messwertelittlec SET MESSUNG_ID='%d', DATE_TIME='%s', ACTORHILEVEL='90.0', ACTORLOLEVEL='-30.0', ACTORFREQ='%f', OUTLETPRESSURE='%f', INLETPRESSURE='-10.0'",sql_mmt_data_id , sql_string_macro, upump_exc_freq, upump_backpressure );    // start forming conditional SQL query
                         
                                     EMFT_VSnPrintf( sql_query, "%s, ACTORWAVE='1'", sql_query );    // conditional fill of SQL query
                     
                     
                         // when using sinus-flank frequency generator configuration, also define rising edge of sinus-flank
                         EMFT_VSnPrintf( sql_query, "%s, ACTORFLANKRISING='1.0E-3'", sql_query );    // conditional fill of SQL query
                                         
                     
                         // when using sinus-flank frequency generator configuration, also define rising edge of sinus-flank
                         EMFT_VSnPrintf( sql_query, "%s, ACTORFLANKFALLING='1.0E-3'", sql_query );    // conditional fill of SQL query
                                         
                                 
                                 
                                     // using Beckhoff device 1
                     EMFT_VSnPrintf( sql_query, "%s, FLOW1_WATER='%f'", sql_query, FlB_Dev1_fmmt );    // conditional fill of SQL query
                                 
                                     // using Beckhoff device 2
                     EMFT_VSnPrintf( sql_query, "%s, FLOW2_WATER='%f'", sql_query, FlB_Dev2_fmmt );    // conditional fill of SQL query
                                     
                                 
                                     // using Beckhoff valve line B
                                             // using Beckhoff valve line B, sensor 1
                         EMFT_VSnPrintf( sql_query, "%s,  PS1_WATER='%f'", sql_query, Beckhoff_B_PS1_mmt );    // conditional fill of SQL query
                                         
                                             // using Beckhoff valve line B, sensor 2
                         EMFT_VSnPrintf( sql_query, "%s,  PS2_WATER='%f'", sql_query, Beckhoff_B_PS2_mmt );    // conditional fill of SQL query
                                         
                                 
                 EMFT_VSnPrintf( sql_query, "%s;", sql_query );    // terminate filling of SQL query
             
                         
                         
                         
                         
                         
             SQL_err = EMFT_SQL_Query( "mmt_data", sql_query );        // execute SQL query
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -46 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -46 );    // exit with error code, error message is reported on the console 
             }
             
             SQL_err = SQL_Commit_Mmt_Data();    // automatically commit data to measurement table messwertelittlec
             
             if ( SQL_err != 0 )    {
                 Log_Error( 8, 1, -50 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );     //  -50 );    // exit with error code, error message is reported on the console 
             }
             
                 
         return ( 0 );    // id query successful
     }
 
 
     int SQL_Setup_Open()    {
 
         int SQL_err;
 
                     
             if (Signal_goto_safe_state != 0 )    {
                 // user interrupted the script execution - entirely skip action
                 Log_Error( 8, 1, -49 );    // log the error onto console and into log file (if available)
                 return ( lc_err_code_nr );    // exit with error code return
             }        
             
             SQL_err = SQL_EstablishConns();        // establish communications
             
             if ( SQL_err != 0 )    {
                 return ( SQL_err );    // exit with error code, error message is reported on the console 
             }    
             
             SQL_err  = SQL_Get_Test_Station_Id();    // get the test station id, otherwise create one
             
             if ( SQL_err != 0 )    {
                 return ( SQL_err );    // exit with error code, error message is reported on the console 
             }    
             
             SQL_err  = SQL_Get_Device_For_DevType_And_WaferId();    // get the device id, otherwise create one
             
             if ( SQL_err != 0 )    {
                 return ( SQL_err );    // exit with error code, error message is reported on the console 
             }
             
             SQL_err  = SQL_Get_Script();                            // get the script id, otherwise create one
             
             if ( SQL_err != 0 )    {
                 return ( SQL_err );    // exit with error code, error message is reported on the console 
             }
             
             SQL_err  = SQL_Get_TestSetup();                            // get the test setup id, otherwise create one
             
             if ( SQL_err != 0 )    {
                 return ( SQL_err );    // exit with error code, error message is reported on the console 
             }
             
                 
         return ( SQL_err );
     }
 
 /*    errors routines library for use with LittleC */
 
     // errors library definitions are being processed
     // this symbol denotes, that a errors library was already included
     // this symbol defines the version of the errors library
         
     char     lc_err_msg_macro_name[70];            // error message macro name
     char     lc_err_msg[250];                    // error message macro value
     
     int     lc_err_section_nr;
     int     lc_err_subsection_nr;
     int     lc_err_nr;
     int     lc_err_code_nr;
     
     // general 
     
     
     
     
     
         
     int Log_Error( int section_nr, int subsection_nr, int err_nr )    {
         
                 
         
             int macro_defined;
             int log_file_is_open;
 
             if  ( err_nr == 0 )    {
                 return ( 0 );        // do not log successful operations
             }        
             else {
                 lc_err_nr = -err_nr;        // make a positive number out of error code
                 lc_err_subsection_nr = subsection_nr;
                 lc_err_section_nr = section_nr;
                 lc_err_code_nr = (lc_err_section_nr * 1000) + (lc_err_subsection_nr * 100) + lc_err_nr;        // form error code number
                 lc_err_code_nr = -lc_err_code_nr;
             }
             
             EMFT_VSnPrintf( lc_err_msg_macro_name, "EMFT_ERR_SECTION_%d_SUBSECTION_%d_NR_%d_MSG", lc_err_section_nr, lc_err_subsection_nr, lc_err_nr );        // store constant string into measurement setup
             macro_defined = EMFT_IsMacroDefined( lc_err_msg_macro_name );    // test, if measurement setup macro exists
             
             if ( macro_defined != 0 )     {
                 EMFT_GetMacroValue( lc_err_msg_macro_name,  lc_err_msg );            // obtain error message value
                 
                 
                     log_file_is_open = EMFT_Is_File_Open();        // check, if the log file is open
                     if ( log_file_is_open != 0)    {
                         // log file is open - write the error message to the file
                         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t*****\tError:\t");    emft_write_string( lc_err_msg ); emft_write_string("\t*****\r\n");
                     }
                                 
                 print( lc_err_msg ); print("\n");    // print the error message value on the console
                 
             }            
             else    {
             
                                     log_file_is_open = EMFT_Is_File_Open();        // check, if the log file is open
                     if ( log_file_is_open != 0 )    {
                         // log file is open - write the error message to the file
                         emft_write_string("% "); emft_write_current_timestamp();    emft_write_string("\t*****\tError nr:\t");    emft_write_var( err_nr ); emft_write_string(" message is not defined!\t*****\r\n");
                     }
                                 
                 puts("Error nr.: "); print( err_nr ); puts(" message is not defined!\n");    // No error message value is defined
             }
             
             return ( 0 );
             }
     
 
 // CPC3000 pressure controller related variables
 double    upump_backpressure;    //  (double) micropump inlet pressure in hPa (mbar)
 float    upump_exc_freq;        //  (float) micropump excitation frequency in Hz
 
 /* Main */
 int main()
 {                              
     
     int        resp_len;    
     int     Beckhoff_error;
     double  Pressure_Drop;
     int        Pressure_Controller1_error;    
     int        Pressure_Controller2_error;
     int        FLB_DEV1_error;
     int        FLB_DEV2_error;
     int     SQL_err;
     
     Pressure_Controller1_error = 0;    
     Pressure_Controller2_error = 0;    
     
     Pressure_Drop = 0;
     FLB_DEV1_error = 0;
     FLB_DEV2_error = 0;
         
     Signal_Setup();        // install a new panel keypress handler and reset global safe exit variable 
     
     // Measurement step 1:
     // Measurement step 1a: Connect flow sensor to inlet of micropump
     // Measurement step 1b: Connect flow sensor to outlet of micropump
     // Measurement step 1c: Connect pump electrically
     // Measurement step 1d: Open file and get file name from Excel
     
     puts("Measurement step 1:\n");    // notify user of current measurement step status
     
     puts("Please flow sensors to micropump inlet and inlet, function generator to micropump and pressure controller to the micropump outlet.\n(press 'p' to proceed)\n");    // notify user of current measurement step status        
     Wait_On_User_Response('p');
     
     //    Measurement step 2: (instrument setup)
     Beckhoff_error = Bus_Beckhoff_Connect();
     
         if ( Beckhoff_error != 0 )    {
             puts("Beckhoff bus connect error! Script will now exit\n");    // notify user of Beckhoff bus controller error
             Bus_Beckhoff_Disconnect();    // disconnect 
             return ( Beckhoff_error );    // return from script
         }
     
             // user is using the water measurement station line A or B - initialize valves
         Beckhoff_error = Valves_Beckhoff_Configure();
         
             if ( Beckhoff_error != 0 )    {
                 puts("Beckhoff EL2809 valve controller configuration error! Script will now exit\n");    // notify user of valve controller error
                 Bus_Beckhoff_Disconnect();    // disconnect all Beckhoff devices
                 return ( Beckhoff_error );    // return from script
             }
             
     Beckhoff_error = PS_Beckhoff_Configure();
     
         if ( Beckhoff_error != 0 )    {
             puts("Beckhoff EL3054 pressure sensor configuration error! Script will now exit\n");    // notify user of pressure sensor error
             Bus_Beckhoff_Disconnect();    // disconnect all Beckhoff devices
             return ( Beckhoff_error );    // return from script
         }
             
     
     //    step 2b:    Setup frequency generator (sinus flank signal)
     uPumps_Excitation_Setup();
     uPumps_Excitation_Stop();    
     
     FLB_DEV1_error = FLB_DEV1_Setup();    //    step 2c:    Setup Flowbus flow sensor as Device 1
     
         if ( FLB_DEV1_error != 0 )    {
             puts("FlowBus device 1 error! Script will now exit\n");    // notify user of pressure controller error                
             FLB_DEV1_Close();
             uPumps_Excitation_Close();
             return ( FLB_DEV1_error );        // return from script
         }
         
     FLB_DEV2_error = FLB_DEV2_Setup();    //    step 2d:    Setup Flowbus flow sensor as Device 2
     
         if ( FLB_DEV2_error != 0 )    {
             puts("FlowBus device 2 error! Script will now exit\n");    // notify user of pressure controller error                
             FLB_DEV1_Close();
             FLB_DEV2_Close();
             uPumps_Excitation_Close();
             return ( FLB_DEV2_error );        // return from script
         }
         
     //    step 2e:    CPC3000 pressure controller setup
     Pressure_Controller1_error = Pressure_Controller1_Setup();    
     
         if ( Pressure_Controller1_error != 0 )    {
             puts("Pressure controller error! Script will now exit\n");    // notify user of pressure controller error
             Pressure_Controller1_Close();    // close all open instruments 
             FLB_DEV1_Close();
             FLB_DEV2_Close();
             uPumps_Excitation_Close();
             return ( Pressure_Controller1_error );        // return from script
         }
         
     Pressure_Controller2_error = Pressure_Controller2_Setup();    
     
         if ( Pressure_Controller2_error != 0 )    {
             puts("Pressure controller error! Script will now exit\n");    // notify user of pressure controller error
             FLB_DEV1_Close();
             FLB_DEV2_Close();
             uPumps_Excitation_Close();
             Pressure_Controller2_Close();    // close all open instruments                 
             Pressure_Controller1_Close();    // close all open instruments                 
             Bus_Beckhoff_Disconnect();    // disconnect all Beckhoff devices
             return ( Pressure_Controller2_error );    // exit with error code, error message is reported on the console 
         }
         
     Pressure_Controller1_error = Pressure_Controller1_Stop(1);        // do not apply pressure on the pressure sensors
     
         if ( Pressure_Controller1_error != 0 )    {
             puts("Pressure controller error! Script will now exit\n");    // notify user of pressure controller error
             FLB_DEV1_Close();
             FLB_DEV2_Close();
             uPumps_Excitation_Close();
             Pressure_Controller2_Close();    // close all open instruments                 
             Pressure_Controller1_Close();    // close all open instruments                 
             Bus_Beckhoff_Disconnect();    // disconnect all Beckhoff devices
             return ( Pressure_Controller1_error );    // exit with error code, error message is reported on the console 
         }    
     
     Pressure_Controller2_error = Pressure_Controller2_Stop(1);        // do not apply pressure on the pressure sensors
     
         if ( Pressure_Controller2_error != 0 )    {
             puts("Pressure controller error! Script will now exit\n");    // notify user of pressure controller error
             FLB_DEV1_Close();
             FLB_DEV2_Close();
             uPumps_Excitation_Close();
             Pressure_Controller2_Close();    // close all open instruments                 
             Pressure_Controller1_Close();    // close all open instruments                 
             Bus_Beckhoff_Disconnect();    // disconnect all Beckhoff devices
             return ( Pressure_Controller2_error );    // exit with error code, error message is reported on the console 
         }    
         
     //    step 3a:    set micropump inlet underpressure                        
     Pressure_Controller2_error = Pressure_Controller2_SetPressure( -10.0 );
     
         if ( Pressure_Controller2_error != 0 )    {
             puts("Pressure controller error! Script will now exit\n");    // notify user of pressure controller error
             Pressure_Controller1_Close();    // close all open instruments 
             Pressure_Controller2_Close();    // close all open instruments 
             FLB_DEV1_Close();
             FLB_DEV2_Close();
             uPumps_Excitation_Stop();    // stop micropump excitation
             uPumps_Excitation_Close();
             LogFile_Close();    // close log file            
             return ( Pressure_Controller2_error );    // exit with error code, error message is reported on the console 
         }
         puts("Underpressure "); puts( "P_INLET" ); puts("="); print( -10.0 ); puts("\t"); print("hPa"); puts("\n");
     
     EMFT_XY_Graph_Add_Plot(    20, 
                             0.0, 
                             500.0, 
                             0, 
                             1, 
                             "Q1(P)", 
                             "hPa", 
                             FlB_Dev1_fmmt_units, 
                             "DARK BLUE", "DOUBLE", "DOUBLE", "BOTTOM", "LEFT");
     
     EMFT_XY_Graph_Add_Plot(    20, 
                             0, 
                             1, 
                             -500, 
                             3000, 
                             "dP(Q1)", 
                             FlB_Dev1_fmmt_units, 
                             "hPa", 
                             "DARK RED", "DOUBLE", "DOUBLE", "BOTTOM", "LEFT");    
 
     LogFile_Setup_Open();        // setup and open log file name
     LogFile_WriteHeader();        // store general information about script execution into file
     LogFile_WritePiezoData();    // store piezo driver configuration                
     LogFile_MarkHeaderStop();    // insert header stop marker into results file for easier processing of results in Origin    
     LogMmtHeaderRow();            // store header of the measurement results file
     
     SQL_err = SQL_Setup_Open();        // establish all connections to sql database    
     
         if ( SQL_err != 0 )    {
             Pressure_Controller1_Close();    // close all open instruments 
             Pressure_Controller2_Close();    // close all open instruments 
             FLB_DEV1_Close();
             FLB_DEV2_Close();
             uPumps_Excitation_Close();
             return ( SQL_err );    // return from script
         }    
     
     SQL_err  = SQL_New_Mmt_Header();    // start new SQL measurement header and data session, otherwise create one
     
         if ( SQL_err != 0 )    {
             // something went wrong with the SQL connection
             Pressure_Controller1_Close();    // close all open instruments 
             Pressure_Controller2_Close();    // close all open instruments 
             FLB_DEV1_Close();
             FLB_DEV2_Close();
             uPumps_Excitation_Stop();    // stop micropump excitation
             uPumps_Excitation_Close();
             LogFile_Close();    // close log file
             SQL_Reject_Mmt_Header_And_Data();        // reject last measurement set            
             EMFT_SQL_Disconnect( );    // release all connections
             return ( SQL_err );    // exit with error code, error message is reported on the console 
         }
     
     // step 3:     Main measurement loop - start measuring inlet flow rate over variable back pressure at a given sinus-flank excitation    
     upump_backpressure = 0.0;    // reset test pressure back to initial value
         
     FlB_Dev1_fmmt = 1.0;                        // reset flow value
     FlB_Dev2_fmmt = 1.0;                        // reset flow value
 
     // loop_step31: iteration over measurements        
     do    {
         
         
         //    step 3a:    set micropump outlet pressure                        
         Pressure_Controller1_error = Pressure_Controller1_SetPressure( upump_backpressure );
         
             if ( Pressure_Controller1_error != 0 )    {
                 puts("Pressure controller error! Script will now exit\n");    // notify user of pressure controller error
                 Pressure_Controller1_Close();    // close all open instruments 
                 Pressure_Controller2_Close();    // close all open instruments 
                 FLB_DEV1_Close();
                 FLB_DEV2_Close();
                 uPumps_Excitation_Stop();    // stop micropump excitation
                 uPumps_Excitation_Close();
                 LogFile_Close();    // close log file
                 SQL_Reject_Mmt_Header_And_Data();        // reject last measurement set            
                 EMFT_SQL_Disconnect( );    // release all connections
                 return ( Pressure_Controller1_error );    // exit with error code, error message is reported on the console 
             }
                 puts( "P_OUTLET" ); puts("="); print( upump_backpressure ); puts("\t"); print("hPa"); puts("\n");
     
         upump_exc_freq = 5.0;    // set micropump excitation frequency
         
         // loop_step32: measurement steps
         do {                    
             
             //    step 3a:    start micropump
             uPumps_Excitation_FreqStart( upump_exc_freq, 0 );            
             puts("\nMicropump excitation "); puts( "f" ); puts("="); print( upump_exc_freq ); puts("\t"); print("Hz"); puts("\t");    // notify user of current measurement step status
             
             FLB_DEV12_Measure_Until_FMMT_Stable( 1 );    //    step 3b:    wait until air flow sensor stabilizes
 
             
             
 
                 PS_Beckhoff_GetStableValue( 3, 2 );    // wait until water inlet pressure sensor stabilizes
                 PS_Beckhoff_GetValue( 3, 3 );            // read outlet A line pressure sensor
                 Pressure_Drop = Beckhoff_B_PS1_mmt - Beckhoff_B_PS2_mmt;
                 
                         
             
             EMFT_XY_Graph_Add_Point( "Q1(P)", upump_exc_freq, FlB_Dev1_fmmt);    // add a datapoint to XY plot showing flow vs. pressure
             EMFT_XY_Graph_Add_Point( "dP(Q1)", FlB_Dev1_fmmt, Pressure_Drop );    // add a datapoint to XY plot showing flow vs. pressure drop
             
             puts("Q1"); puts("="); print( FlB_Dev1_fmmt ); puts("\t"); print( FlB_Dev1_fmmt_units ); puts("\t");                        
 
             //    step 3c:    log frequency, pressure, both flow rates and both pressures
             
             
 
                 Log1Dbl5Float( upump_exc_freq, upump_backpressure, FlB_Dev1_fmmt, FlB_Dev2_fmmt, Beckhoff_B_PS1_mmt, Beckhoff_B_PS2_mmt );
                         
             //    step 3c:    log frequency, pressure, both flow rates, both pressures and pressure drop to SQL server
             SQL_err = SQL_Insert_Mmt_Data( 0 );        // append acquired measurements to data session, stage parameter is irrelevant for this script
             
                 if ( SQL_err != 0 )    {
                     // something went wrong with the SQL connection
                     Pressure_Controller1_Close();    // close all open instruments 
                     Pressure_Controller2_Close();    // close all open instruments 
                     FLB_DEV1_Close();
                     FLB_DEV2_Close();
                     uPumps_Excitation_Stop();    // stop micropump excitation
                     uPumps_Excitation_Close();
                     LogFile_Close();    // close log file
                     SQL_Reject_Mmt_Header_And_Data();        // reject last measurement set            
                     EMFT_SQL_Disconnect( );    // release all connections
                     return ( SQL_err );    // exit with error code, error message is reported on the console 
                 }
                         
             upump_exc_freq = upump_exc_freq + 10.0;        // set micropump excitation frequency 
         
         } while( ( upump_exc_freq < 70.0 ) && (Signal_goto_safe_state == 0) );    // endloop_step32:
                         
         upump_backpressure = upump_backpressure + 100.0;        // adjust pressure according to uniform pressure setpoint stepping    
         
     } while ( ( upump_backpressure <= 500.0 ) && (Signal_goto_safe_state == 0) );    // endloop_step32    
     
     SQL_err  = SQL_Commit_Mmt_EndTime_And_Info();            // finalize insertion of successfully completed last measurement
     
         if ( SQL_err != 0 )    {
             // something went wrong with the SQL connection            
             Pressure_Controller1_Close();    // close all open instruments 
             Pressure_Controller2_Close();    // close all open instruments 
             FLB_DEV1_Close();
             FLB_DEV2_Close();
             uPumps_Excitation_Stop();    // stop micropump excitation
             uPumps_Excitation_Close();
             LogFile_Close();    // close log file
             SQL_Reject_Mmt_Header_And_Data();        // reject last measurement set            
             EMFT_SQL_Disconnect( );    // release all connections
             return ( SQL_err );    // exit with error code, error message is reported on the console 
         }        
     
     if ( Signal_goto_safe_state != 0 )    {        
         // user interrupted the execution of script - set instruments to safe state
         Signal_SetSafeState();    
         return( -1 );    // exit with error code, error message is reported on the console
     }
     
     // step 4:    Finish
     // step 4a:    Stop logging
     uPumps_Excitation_Stop();    // stop micropump excitation
     uPumps_Excitation_Close();
 
     Pressure_Controller1_Stop(1);        // set standby mode on the controller - do not apply pressure on the micropump
     Pressure_Controller2_Stop(1);        // set standby mode on the controller - do not apply pressure on the micropump
     // step 4b: Disconnect instruments
     Pressure_Controller1_Close();
     Pressure_Controller2_Close();
     
     FLB_DEV1_Close();
     FLB_DEV2_Close();
     
     // EMFT_SQL_Disconnect function breaks all existing SQL connections and releases acquired memory    
     SQL_err = EMFT_SQL_Disconnect( );    // release all connections
     
     // step 4c:    Stop logging    
     LogFile_Close();    // Close log file
     LogFile_Copy_Results();    // Copy results to specified remote location
 
     Bus_Beckhoff_Disconnect();        // disconnect all Beckhoff devices
     
     puts("Measurements finished!\n");    // notify user of current measurement step status
             
     return ( 0 );
 }
